'use strict';

var util_1 = require('util');
var path = require('path');
var os = require('os');
var crypto_1 = require('crypto');
var net_1 = require('net');
var url = require('url');
var fs = require('fs');
var child_process_1 = require('child_process');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var util_1__default = /*#__PURE__*/_interopDefaultLegacy(util_1);
var path__default = /*#__PURE__*/_interopDefaultLegacy(path);
var os__default = /*#__PURE__*/_interopDefaultLegacy(os);
var crypto_1__default = /*#__PURE__*/_interopDefaultLegacy(crypto_1);
var net_1__default = /*#__PURE__*/_interopDefaultLegacy(net_1);
var url__default = /*#__PURE__*/_interopDefaultLegacy(url);
var fs__default = /*#__PURE__*/_interopDefaultLegacy(fs);
var child_process_1__default = /*#__PURE__*/_interopDefaultLegacy(child_process_1);

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function getAugmentedNamespace(n) {
	if (n.__esModule) return n;
	var a = Object.defineProperty({}, '__esModule', {value: true});
	Object.keys(n).forEach(function (k) {
		var d = Object.getOwnPropertyDescriptor(n, k);
		Object.defineProperty(a, k, d.get ? d : {
			enumerable: true,
			get: function () {
				return n[k];
			}
		});
	});
	return a;
}

function createCommonjsModule(fn) {
  var module = { exports: {} };
	return fn(module, module.exports), module.exports;
}

var is = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.thenable = exports.typedArray = exports.stringArray = exports.array = exports.func = exports.error = exports.number = exports.string = exports.boolean = void 0;
function boolean(value) {
    return value === true || value === false;
}
exports.boolean = boolean;
function string(value) {
    return typeof value === 'string' || value instanceof String;
}
exports.string = string;
function number(value) {
    return typeof value === 'number' || value instanceof Number;
}
exports.number = number;
function error(value) {
    return value instanceof Error;
}
exports.error = error;
function func(value) {
    return typeof value === 'function';
}
exports.func = func;
function array(value) {
    return Array.isArray(value);
}
exports.array = array;
function stringArray(value) {
    return array(value) && value.every(elem => string(elem));
}
exports.stringArray = stringArray;
function typedArray(value, check) {
    return Array.isArray(value) && value.every(check);
}
exports.typedArray = typedArray;
function thenable(value) {
    return value && func(value.then);
}
exports.thenable = thenable;

});

/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */

let _ral;
function RAL() {
    if (_ral === undefined) {
        throw new Error(`No runtime abstraction layer installed`);
    }
    return _ral;
}
(function (RAL) {
    function install(ral) {
        if (ral === undefined) {
            throw new Error(`No runtime abstraction layer provided`);
        }
        _ral = ral;
    }
    RAL.install = install;
})(RAL || (RAL = {}));
var _default = RAL;


var ral = /*#__PURE__*/Object.defineProperty({
	default: _default
}, '__esModule', {value: true});

var disposable = createCommonjsModule(function (module, exports) {
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.Disposable = void 0;
var Disposable;
(function (Disposable) {
    function create(func) {
        return {
            dispose: func
        };
    }
    Disposable.create = create;
})(Disposable = exports.Disposable || (exports.Disposable = {}));

});

var messageBuffer = createCommonjsModule(function (module, exports) {
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractMessageBuffer = void 0;
const CR = 13;
const LF = 10;
const CRLF = '\r\n';
class AbstractMessageBuffer {
    constructor(encoding = 'utf-8') {
        this._encoding = encoding;
        this._chunks = [];
        this._totalLength = 0;
    }
    get encoding() {
        return this._encoding;
    }
    append(chunk) {
        const toAppend = typeof chunk === 'string' ? this.fromString(chunk, this._encoding) : chunk;
        this._chunks.push(toAppend);
        this._totalLength += toAppend.byteLength;
    }
    tryReadHeaders() {
        if (this._chunks.length === 0) {
            return undefined;
        }
        let state = 0;
        let chunkIndex = 0;
        let offset = 0;
        let chunkBytesRead = 0;
        row: while (chunkIndex < this._chunks.length) {
            const chunk = this._chunks[chunkIndex];
            offset = 0;
             while (offset < chunk.length) {
                const value = chunk[offset];
                switch (value) {
                    case CR:
                        switch (state) {
                            case 0:
                                state = 1;
                                break;
                            case 2:
                                state = 3;
                                break;
                            default:
                                state = 0;
                        }
                        break;
                    case LF:
                        switch (state) {
                            case 1:
                                state = 2;
                                break;
                            case 3:
                                state = 4;
                                offset++;
                                break row;
                            default:
                                state = 0;
                        }
                        break;
                    default:
                        state = 0;
                }
                offset++;
            }
            chunkBytesRead += chunk.byteLength;
            chunkIndex++;
        }
        if (state !== 4) {
            return undefined;
        }
        // The buffer contains the two CRLF at the end. So we will
        // have two empty lines after the split at the end as well.
        const buffer = this._read(chunkBytesRead + offset);
        const result = new Map();
        const headers = this.toString(buffer, 'ascii').split(CRLF);
        if (headers.length < 2) {
            return result;
        }
        for (let i = 0; i < headers.length - 2; i++) {
            const header = headers[i];
            const index = header.indexOf(':');
            if (index === -1) {
                throw new Error('Message header must separate key and value using :');
            }
            const key = header.substr(0, index);
            const value = header.substr(index + 1).trim();
            result.set(key, value);
        }
        return result;
    }
    tryReadBody(length) {
        if (this._totalLength < length) {
            return undefined;
        }
        return this._read(length);
    }
    get numberOfBytes() {
        return this._totalLength;
    }
    _read(byteCount) {
        if (byteCount === 0) {
            return this.emptyBuffer();
        }
        if (byteCount > this._totalLength) {
            throw new Error(`Cannot read so many bytes!`);
        }
        if (this._chunks[0].byteLength === byteCount) {
            // super fast path, precisely first chunk must be returned
            const chunk = this._chunks[0];
            this._chunks.shift();
            this._totalLength -= byteCount;
            return this.asNative(chunk);
        }
        if (this._chunks[0].byteLength > byteCount) {
            // fast path, the reading is entirely within the first chunk
            const chunk = this._chunks[0];
            const result = this.asNative(chunk, byteCount);
            this._chunks[0] = chunk.slice(byteCount);
            this._totalLength -= byteCount;
            return result;
        }
        const result = this.allocNative(byteCount);
        let resultOffset = 0;
        let chunkIndex = 0;
        while (byteCount > 0) {
            const chunk = this._chunks[chunkIndex];
            if (chunk.byteLength > byteCount) {
                // this chunk will survive
                const chunkPart = chunk.slice(0, byteCount);
                result.set(chunkPart, resultOffset);
                resultOffset += byteCount;
                this._chunks[chunkIndex] = chunk.slice(byteCount);
                this._totalLength -= byteCount;
                byteCount -= byteCount;
            }
            else {
                // this chunk will be entirely read
                result.set(chunk, resultOffset);
                resultOffset += chunk.byteLength;
                this._chunks.shift();
                this._totalLength -= chunk.byteLength;
                byteCount -= chunk.byteLength;
            }
        }
        return result;
    }
}
exports.AbstractMessageBuffer = AbstractMessageBuffer;

});

/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */





class MessageBuffer extends messageBuffer.AbstractMessageBuffer {
    constructor(encoding = 'utf-8') {
        super(encoding);
    }
    emptyBuffer() {
        return MessageBuffer.emptyBuffer;
    }
    fromString(value, encoding) {
        return Buffer.from(value, encoding);
    }
    toString(value, encoding) {
        if (value instanceof Buffer) {
            return value.toString(encoding);
        }
        else {
            return new util_1__default['default'].TextDecoder(encoding).decode(value);
        }
    }
    asNative(buffer, length) {
        if (length === undefined) {
            return buffer instanceof Buffer ? buffer : Buffer.from(buffer);
        }
        else {
            return buffer instanceof Buffer ? buffer.slice(0, length) : Buffer.from(buffer, 0, length);
        }
    }
    allocNative(length) {
        return Buffer.allocUnsafe(length);
    }
}
MessageBuffer.emptyBuffer = Buffer.allocUnsafe(0);
class ReadableStreamWrapper {
    constructor(stream) {
        this.stream = stream;
    }
    onClose(listener) {
        this.stream.on('close', listener);
        return disposable.Disposable.create(() => this.stream.off('close', listener));
    }
    onError(listener) {
        this.stream.on('error', listener);
        return disposable.Disposable.create(() => this.stream.off('error', listener));
    }
    onEnd(listener) {
        this.stream.on('end', listener);
        return disposable.Disposable.create(() => this.stream.off('end', listener));
    }
    onData(listener) {
        this.stream.on('data', listener);
        return disposable.Disposable.create(() => this.stream.off('data', listener));
    }
}
class WritableStreamWrapper {
    constructor(stream) {
        this.stream = stream;
    }
    onClose(listener) {
        this.stream.on('close', listener);
        return disposable.Disposable.create(() => this.stream.off('close', listener));
    }
    onError(listener) {
        this.stream.on('error', listener);
        return disposable.Disposable.create(() => this.stream.off('error', listener));
    }
    onEnd(listener) {
        this.stream.on('end', listener);
        return disposable.Disposable.create(() => this.stream.off('end', listener));
    }
    write(data, encoding) {
        return new Promise((resolve, reject) => {
            const callback = (error) => {
                if (error === undefined || error === null) {
                    resolve();
                }
                else {
                    reject(error);
                }
            };
            if (typeof data === 'string') {
                this.stream.write(data, encoding, callback);
            }
            else {
                this.stream.write(data, callback);
            }
        });
    }
    end() {
        this.stream.end();
    }
}
const _ril = Object.freeze({
    messageBuffer: Object.freeze({
        create: (encoding) => new MessageBuffer(encoding)
    }),
    applicationJson: Object.freeze({
        encoder: Object.freeze({
            name: 'application/json',
            encode: (msg, options) => {
                try {
                    return Promise.resolve(Buffer.from(JSON.stringify(msg, undefined, 0), options.charset));
                }
                catch (err) {
                    return Promise.reject(err);
                }
            }
        }),
        decoder: Object.freeze({
            name: 'application/json',
            decode: (buffer, options) => {
                try {
                    if (buffer instanceof Buffer) {
                        return Promise.resolve(JSON.parse(buffer.toString(options.charset)));
                    }
                    else {
                        return Promise.resolve(JSON.parse(new util_1__default['default'].TextDecoder(options.charset).decode(buffer)));
                    }
                }
                catch (err) {
                    return Promise.reject(err);
                }
            }
        })
    }),
    stream: Object.freeze({
        asReadableStream: (stream) => new ReadableStreamWrapper(stream),
        asWritableStream: (stream) => new WritableStreamWrapper(stream)
    }),
    console: console,
    timer: Object.freeze({
        setTimeout(callback, ms, ...args) {
            return setTimeout(callback, ms, ...args);
        },
        clearTimeout(handle) {
            clearTimeout(handle);
        },
        setImmediate(callback, ...args) {
            return setImmediate(callback, ...args);
        },
        clearImmediate(handle) {
            clearImmediate(handle);
        }
    })
});
function RIL() {
    return _ril;
}
(function (RIL) {
    function install() {
        ral.default.install(_ril);
    }
    RIL.install = install;
})(RIL || (RIL = {}));
var _default$1 = RIL;


var ril = /*#__PURE__*/Object.defineProperty({
	default: _default$1
}, '__esModule', {value: true});

var is$1 = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.stringArray = exports.array = exports.func = exports.error = exports.number = exports.string = exports.boolean = void 0;
function boolean(value) {
    return value === true || value === false;
}
exports.boolean = boolean;
function string(value) {
    return typeof value === 'string' || value instanceof String;
}
exports.string = string;
function number(value) {
    return typeof value === 'number' || value instanceof Number;
}
exports.number = number;
function error(value) {
    return value instanceof Error;
}
exports.error = error;
function func(value) {
    return typeof value === 'function';
}
exports.func = func;
function array(value) {
    return Array.isArray(value);
}
exports.array = array;
function stringArray(value) {
    return array(value) && value.every(elem => string(elem));
}
exports.stringArray = stringArray;

});

var messages = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.isResponseMessage = exports.isNotificationMessage = exports.isRequestMessage = exports.NotificationType9 = exports.NotificationType8 = exports.NotificationType7 = exports.NotificationType6 = exports.NotificationType5 = exports.NotificationType4 = exports.NotificationType3 = exports.NotificationType2 = exports.NotificationType1 = exports.NotificationType0 = exports.NotificationType = exports.RequestType9 = exports.RequestType8 = exports.RequestType7 = exports.RequestType6 = exports.RequestType5 = exports.RequestType4 = exports.RequestType3 = exports.RequestType2 = exports.RequestType1 = exports.RequestType = exports.RequestType0 = exports.AbstractMessageSignature = exports.ParameterStructures = exports.ResponseError = exports.ErrorCodes = void 0;

/**
 * Predefined error codes.
 */
var ErrorCodes;
(function (ErrorCodes) {
    // Defined by JSON RPC
    ErrorCodes.ParseError = -32700;
    ErrorCodes.InvalidRequest = -32600;
    ErrorCodes.MethodNotFound = -32601;
    ErrorCodes.InvalidParams = -32602;
    ErrorCodes.InternalError = -32603;
    /**
     * This is the start range of JSON RPC reserved error codes.
     * It doesn't denote a real error code. No application error codes should
     * be defined between the start and end range. For backwards
     * compatibility the `ServerNotInitialized` and the `UnknownErrorCode`
     * are left in the range.
     *
     * @since 3.16.0
    */
    ErrorCodes.jsonrpcReservedErrorRangeStart = -32099;
    /** @deprecated use  jsonrpcReservedErrorRangeStart */
    ErrorCodes.serverErrorStart = ErrorCodes.jsonrpcReservedErrorRangeStart;
    ErrorCodes.MessageWriteError = -32099;
    ErrorCodes.MessageReadError = -32098;
    ErrorCodes.ServerNotInitialized = -32002;
    ErrorCodes.UnknownErrorCode = -32001;
    /**
     * This is the end range of JSON RPC reserved error codes.
     * It doesn't denote a real error code.
     *
     * @since 3.16.0
    */
    ErrorCodes.jsonrpcReservedErrorRangeEnd = -32000;
    /** @deprecated use  jsonrpcReservedErrorRangeEnd */
    ErrorCodes.serverErrorEnd = ErrorCodes.jsonrpcReservedErrorRangeEnd;
})(ErrorCodes = exports.ErrorCodes || (exports.ErrorCodes = {}));
/**
 * An error object return in a response in case a request
 * has failed.
 */
class ResponseError extends Error {
    constructor(code, message, data) {
        super(message);
        this.code = is$1.number(code) ? code : ErrorCodes.UnknownErrorCode;
        this.data = data;
        Object.setPrototypeOf(this, ResponseError.prototype);
    }
    toJson() {
        return {
            code: this.code,
            message: this.message,
            data: this.data,
        };
    }
}
exports.ResponseError = ResponseError;
class ParameterStructures {
    constructor(kind) {
        this.kind = kind;
    }
    static is(value) {
        return value === ParameterStructures.auto || value === ParameterStructures.byName || value === ParameterStructures.byPosition;
    }
    toString() {
        return this.kind;
    }
}
exports.ParameterStructures = ParameterStructures;
/**
 * The parameter structure is automatically inferred on the number of parameters
 * and the parameter type in case of a single param.
 */
ParameterStructures.auto = new ParameterStructures('auto');
/**
 * Forces `byPosition` parameter structure. This is useful if you have a single
 * parameter which has a literal type.
 */
ParameterStructures.byPosition = new ParameterStructures('byPosition');
/**
 * Forces `byName` parameter structure. This is only useful when having a single
 * parameter. The library will report errors if used with a different number of
 * parameters.
 */
ParameterStructures.byName = new ParameterStructures('byName');
/**
 * An abstract implementation of a MessageType.
 */
class AbstractMessageSignature {
    constructor(method, numberOfParams) {
        this.method = method;
        this.numberOfParams = numberOfParams;
    }
    get parameterStructures() {
        return ParameterStructures.auto;
    }
}
exports.AbstractMessageSignature = AbstractMessageSignature;
/**
 * Classes to type request response pairs
 */
class RequestType0 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 0);
    }
}
exports.RequestType0 = RequestType0;
class RequestType extends AbstractMessageSignature {
    constructor(method, _parameterStructures = ParameterStructures.auto) {
        super(method, 1);
        this._parameterStructures = _parameterStructures;
    }
    get parameterStructures() {
        return this._parameterStructures;
    }
}
exports.RequestType = RequestType;
class RequestType1 extends AbstractMessageSignature {
    constructor(method, _parameterStructures = ParameterStructures.auto) {
        super(method, 1);
        this._parameterStructures = _parameterStructures;
    }
    get parameterStructures() {
        return this._parameterStructures;
    }
}
exports.RequestType1 = RequestType1;
class RequestType2 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 2);
    }
}
exports.RequestType2 = RequestType2;
class RequestType3 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 3);
    }
}
exports.RequestType3 = RequestType3;
class RequestType4 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 4);
    }
}
exports.RequestType4 = RequestType4;
class RequestType5 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 5);
    }
}
exports.RequestType5 = RequestType5;
class RequestType6 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 6);
    }
}
exports.RequestType6 = RequestType6;
class RequestType7 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 7);
    }
}
exports.RequestType7 = RequestType7;
class RequestType8 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 8);
    }
}
exports.RequestType8 = RequestType8;
class RequestType9 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 9);
    }
}
exports.RequestType9 = RequestType9;
class NotificationType extends AbstractMessageSignature {
    constructor(method, _parameterStructures = ParameterStructures.auto) {
        super(method, 1);
        this._parameterStructures = _parameterStructures;
    }
    get parameterStructures() {
        return this._parameterStructures;
    }
}
exports.NotificationType = NotificationType;
class NotificationType0 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 0);
    }
}
exports.NotificationType0 = NotificationType0;
class NotificationType1 extends AbstractMessageSignature {
    constructor(method, _parameterStructures = ParameterStructures.auto) {
        super(method, 1);
        this._parameterStructures = _parameterStructures;
    }
    get parameterStructures() {
        return this._parameterStructures;
    }
}
exports.NotificationType1 = NotificationType1;
class NotificationType2 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 2);
    }
}
exports.NotificationType2 = NotificationType2;
class NotificationType3 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 3);
    }
}
exports.NotificationType3 = NotificationType3;
class NotificationType4 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 4);
    }
}
exports.NotificationType4 = NotificationType4;
class NotificationType5 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 5);
    }
}
exports.NotificationType5 = NotificationType5;
class NotificationType6 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 6);
    }
}
exports.NotificationType6 = NotificationType6;
class NotificationType7 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 7);
    }
}
exports.NotificationType7 = NotificationType7;
class NotificationType8 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 8);
    }
}
exports.NotificationType8 = NotificationType8;
class NotificationType9 extends AbstractMessageSignature {
    constructor(method) {
        super(method, 9);
    }
}
exports.NotificationType9 = NotificationType9;
/**
 * Tests if the given message is a request message
 */
function isRequestMessage(message) {
    const candidate = message;
    return candidate && is$1.string(candidate.method) && (is$1.string(candidate.id) || is$1.number(candidate.id));
}
exports.isRequestMessage = isRequestMessage;
/**
 * Tests if the given message is a notification message
 */
function isNotificationMessage(message) {
    const candidate = message;
    return candidate && is$1.string(candidate.method) && message.id === void 0;
}
exports.isNotificationMessage = isNotificationMessage;
/**
 * Tests if the given message is a response message
 */
function isResponseMessage(message) {
    const candidate = message;
    return candidate && (candidate.result !== void 0 || !!candidate.error) && (is$1.string(candidate.id) || is$1.number(candidate.id) || candidate.id === null);
}
exports.isResponseMessage = isResponseMessage;

});

var events = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Emitter = exports.Event = void 0;

var Event;
(function (Event) {
    const _disposable = { dispose() { } };
    Event.None = function () { return _disposable; };
})(Event = exports.Event || (exports.Event = {}));
class CallbackList {
    add(callback, context = null, bucket) {
        if (!this._callbacks) {
            this._callbacks = [];
            this._contexts = [];
        }
        this._callbacks.push(callback);
        this._contexts.push(context);
        if (Array.isArray(bucket)) {
            bucket.push({ dispose: () => this.remove(callback, context) });
        }
    }
    remove(callback, context = null) {
        if (!this._callbacks) {
            return;
        }
        let foundCallbackWithDifferentContext = false;
        for (let i = 0, len = this._callbacks.length; i < len; i++) {
            if (this._callbacks[i] === callback) {
                if (this._contexts[i] === context) {
                    // callback & context match => remove it
                    this._callbacks.splice(i, 1);
                    this._contexts.splice(i, 1);
                    return;
                }
                else {
                    foundCallbackWithDifferentContext = true;
                }
            }
        }
        if (foundCallbackWithDifferentContext) {
            throw new Error('When adding a listener with a context, you should remove it with the same context');
        }
    }
    invoke(...args) {
        if (!this._callbacks) {
            return [];
        }
        const ret = [], callbacks = this._callbacks.slice(0), contexts = this._contexts.slice(0);
        for (let i = 0, len = callbacks.length; i < len; i++) {
            try {
                ret.push(callbacks[i].apply(contexts[i], args));
            }
            catch (e) {
                // eslint-disable-next-line no-console
                ral.default().console.error(e);
            }
        }
        return ret;
    }
    isEmpty() {
        return !this._callbacks || this._callbacks.length === 0;
    }
    dispose() {
        this._callbacks = undefined;
        this._contexts = undefined;
    }
}
class Emitter {
    constructor(_options) {
        this._options = _options;
    }
    /**
     * For the public to allow to subscribe
     * to events from this Emitter
     */
    get event() {
        if (!this._event) {
            this._event = (listener, thisArgs, disposables) => {
                if (!this._callbacks) {
                    this._callbacks = new CallbackList();
                }
                if (this._options && this._options.onFirstListenerAdd && this._callbacks.isEmpty()) {
                    this._options.onFirstListenerAdd(this);
                }
                this._callbacks.add(listener, thisArgs);
                const result = {
                    dispose: () => {
                        if (!this._callbacks) {
                            // disposable is disposed after emitter is disposed.
                            return;
                        }
                        this._callbacks.remove(listener, thisArgs);
                        result.dispose = Emitter._noop;
                        if (this._options && this._options.onLastListenerRemove && this._callbacks.isEmpty()) {
                            this._options.onLastListenerRemove(this);
                        }
                    }
                };
                if (Array.isArray(disposables)) {
                    disposables.push(result);
                }
                return result;
            };
        }
        return this._event;
    }
    /**
     * To be kept private to fire an event to
     * subscribers
     */
    fire(event) {
        if (this._callbacks) {
            this._callbacks.invoke.call(this._callbacks, event);
        }
    }
    dispose() {
        if (this._callbacks) {
            this._callbacks.dispose();
            this._callbacks = undefined;
        }
    }
}
exports.Emitter = Emitter;
Emitter._noop = function () { };

});

var cancellation = createCommonjsModule(function (module, exports) {
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.CancellationTokenSource = exports.CancellationToken = void 0;



var CancellationToken;
(function (CancellationToken) {
    CancellationToken.None = Object.freeze({
        isCancellationRequested: false,
        onCancellationRequested: events.Event.None
    });
    CancellationToken.Cancelled = Object.freeze({
        isCancellationRequested: true,
        onCancellationRequested: events.Event.None
    });
    function is(value) {
        const candidate = value;
        return candidate && (candidate === CancellationToken.None
            || candidate === CancellationToken.Cancelled
            || (is$1.boolean(candidate.isCancellationRequested) && !!candidate.onCancellationRequested));
    }
    CancellationToken.is = is;
})(CancellationToken = exports.CancellationToken || (exports.CancellationToken = {}));
const shortcutEvent = Object.freeze(function (callback, context) {
    const handle = ral.default().timer.setTimeout(callback.bind(context), 0);
    return { dispose() { ral.default().timer.clearTimeout(handle); } };
});
class MutableToken {
    constructor() {
        this._isCancelled = false;
    }
    cancel() {
        if (!this._isCancelled) {
            this._isCancelled = true;
            if (this._emitter) {
                this._emitter.fire(undefined);
                this.dispose();
            }
        }
    }
    get isCancellationRequested() {
        return this._isCancelled;
    }
    get onCancellationRequested() {
        if (this._isCancelled) {
            return shortcutEvent;
        }
        if (!this._emitter) {
            this._emitter = new events.Emitter();
        }
        return this._emitter.event;
    }
    dispose() {
        if (this._emitter) {
            this._emitter.dispose();
            this._emitter = undefined;
        }
    }
}
class CancellationTokenSource {
    get token() {
        if (!this._token) {
            // be lazy and create the token only when
            // actually needed
            this._token = new MutableToken();
        }
        return this._token;
    }
    cancel() {
        if (!this._token) {
            // save an object by returning the default
            // cancelled token when cancellation happens
            // before someone asks for the token
            this._token = CancellationToken.Cancelled;
        }
        else {
            this._token.cancel();
        }
    }
    dispose() {
        if (!this._token) {
            // ensure to initialize with an empty token if we had none
            this._token = CancellationToken.None;
        }
        else if (this._token instanceof MutableToken) {
            // actually dispose
            this._token.dispose();
        }
    }
}
exports.CancellationTokenSource = CancellationTokenSource;

});

var messageReader = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReadableStreamMessageReader = exports.AbstractMessageReader = exports.MessageReader = void 0;



var MessageReader;
(function (MessageReader) {
    function is(value) {
        let candidate = value;
        return candidate && is$1.func(candidate.listen) && is$1.func(candidate.dispose) &&
            is$1.func(candidate.onError) && is$1.func(candidate.onClose) && is$1.func(candidate.onPartialMessage);
    }
    MessageReader.is = is;
})(MessageReader = exports.MessageReader || (exports.MessageReader = {}));
class AbstractMessageReader {
    constructor() {
        this.errorEmitter = new events.Emitter();
        this.closeEmitter = new events.Emitter();
        this.partialMessageEmitter = new events.Emitter();
    }
    dispose() {
        this.errorEmitter.dispose();
        this.closeEmitter.dispose();
    }
    get onError() {
        return this.errorEmitter.event;
    }
    fireError(error) {
        this.errorEmitter.fire(this.asError(error));
    }
    get onClose() {
        return this.closeEmitter.event;
    }
    fireClose() {
        this.closeEmitter.fire(undefined);
    }
    get onPartialMessage() {
        return this.partialMessageEmitter.event;
    }
    firePartialMessage(info) {
        this.partialMessageEmitter.fire(info);
    }
    asError(error) {
        if (error instanceof Error) {
            return error;
        }
        else {
            return new Error(`Reader received error. Reason: ${is$1.string(error.message) ? error.message : 'unknown'}`);
        }
    }
}
exports.AbstractMessageReader = AbstractMessageReader;
var ResolvedMessageReaderOptions;
(function (ResolvedMessageReaderOptions) {
    function fromOptions(options) {
        var _a;
        let charset;
        let contentDecoder;
        const contentDecoders = new Map();
        let contentTypeDecoder;
        const contentTypeDecoders = new Map();
        if (options === undefined || typeof options === 'string') {
            charset = options !== null && options !== void 0 ? options : 'utf-8';
        }
        else {
            charset = (_a = options.charset) !== null && _a !== void 0 ? _a : 'utf-8';
            if (options.contentDecoder !== undefined) {
                contentDecoder = options.contentDecoder;
                contentDecoders.set(contentDecoder.name, contentDecoder);
            }
            if (options.contentDecoders !== undefined) {
                for (const decoder of options.contentDecoders) {
                    contentDecoders.set(decoder.name, decoder);
                }
            }
            if (options.contentTypeDecoder !== undefined) {
                contentTypeDecoder = options.contentTypeDecoder;
                contentTypeDecoders.set(contentTypeDecoder.name, contentTypeDecoder);
            }
            if (options.contentTypeDecoders !== undefined) {
                for (const decoder of options.contentTypeDecoders) {
                    contentTypeDecoders.set(decoder.name, decoder);
                }
            }
        }
        if (contentTypeDecoder === undefined) {
            contentTypeDecoder = ral.default().applicationJson.decoder;
            contentTypeDecoders.set(contentTypeDecoder.name, contentTypeDecoder);
        }
        return { charset, contentDecoder, contentDecoders, contentTypeDecoder, contentTypeDecoders };
    }
    ResolvedMessageReaderOptions.fromOptions = fromOptions;
})(ResolvedMessageReaderOptions || (ResolvedMessageReaderOptions = {}));
class ReadableStreamMessageReader extends AbstractMessageReader {
    constructor(readable, options) {
        super();
        this.readable = readable;
        this.options = ResolvedMessageReaderOptions.fromOptions(options);
        this.buffer = ral.default().messageBuffer.create(this.options.charset);
        this._partialMessageTimeout = 10000;
        this.nextMessageLength = -1;
        this.messageToken = 0;
    }
    set partialMessageTimeout(timeout) {
        this._partialMessageTimeout = timeout;
    }
    get partialMessageTimeout() {
        return this._partialMessageTimeout;
    }
    listen(callback) {
        this.nextMessageLength = -1;
        this.messageToken = 0;
        this.partialMessageTimer = undefined;
        this.callback = callback;
        const result = this.readable.onData((data) => {
            this.onData(data);
        });
        this.readable.onError((error) => this.fireError(error));
        this.readable.onClose(() => this.fireClose());
        return result;
    }
    onData(data) {
        this.buffer.append(data);
        while (true) {
            if (this.nextMessageLength === -1) {
                const headers = this.buffer.tryReadHeaders();
                if (!headers) {
                    return;
                }
                const contentLength = headers.get('Content-Length');
                if (!contentLength) {
                    throw new Error('Header must provide a Content-Length property.');
                }
                const length = parseInt(contentLength);
                if (isNaN(length)) {
                    throw new Error('Content-Length value must be a number.');
                }
                this.nextMessageLength = length;
            }
            const body = this.buffer.tryReadBody(this.nextMessageLength);
            if (body === undefined) {
                /** We haven't received the full message yet. */
                this.setPartialMessageTimer();
                return;
            }
            this.clearPartialMessageTimer();
            this.nextMessageLength = -1;
            let p;
            if (this.options.contentDecoder !== undefined) {
                p = this.options.contentDecoder.decode(body);
            }
            else {
                p = Promise.resolve(body);
            }
            p.then((value) => {
                this.options.contentTypeDecoder.decode(value, this.options).then((msg) => {
                    this.callback(msg);
                }, (error) => {
                    this.fireError(error);
                });
            }, (error) => {
                this.fireError(error);
            });
        }
    }
    clearPartialMessageTimer() {
        if (this.partialMessageTimer) {
            ral.default().timer.clearTimeout(this.partialMessageTimer);
            this.partialMessageTimer = undefined;
        }
    }
    setPartialMessageTimer() {
        this.clearPartialMessageTimer();
        if (this._partialMessageTimeout <= 0) {
            return;
        }
        this.partialMessageTimer = ral.default().timer.setTimeout((token, timeout) => {
            this.partialMessageTimer = undefined;
            if (token === this.messageToken) {
                this.firePartialMessage({ messageToken: token, waitingTime: timeout });
                this.setPartialMessageTimer();
            }
        }, this._partialMessageTimeout, this.messageToken, this._partialMessageTimeout);
    }
}
exports.ReadableStreamMessageReader = ReadableStreamMessageReader;

});

var semaphore = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Semaphore = void 0;

class Semaphore {
    constructor(capacity = 1) {
        if (capacity <= 0) {
            throw new Error('Capacity must be greater than 0');
        }
        this._capacity = capacity;
        this._active = 0;
        this._waiting = [];
    }
    lock(thunk) {
        return new Promise((resolve, reject) => {
            this._waiting.push({ thunk, resolve, reject });
            this.runNext();
        });
    }
    get active() {
        return this._active;
    }
    runNext() {
        if (this._waiting.length === 0 || this._active === this._capacity) {
            return;
        }
        ral.default().timer.setImmediate(() => this.doRunNext());
    }
    doRunNext() {
        if (this._waiting.length === 0 || this._active === this._capacity) {
            return;
        }
        const next = this._waiting.shift();
        this._active++;
        if (this._active > this._capacity) {
            throw new Error(`To many thunks active`);
        }
        try {
            const result = next.thunk();
            if (result instanceof Promise) {
                result.then((value) => {
                    this._active--;
                    next.resolve(value);
                    this.runNext();
                }, (err) => {
                    this._active--;
                    next.reject(err);
                    this.runNext();
                });
            }
            else {
                this._active--;
                next.resolve(result);
                this.runNext();
            }
        }
        catch (err) {
            this._active--;
            next.reject(err);
            this.runNext();
        }
    }
}
exports.Semaphore = Semaphore;

});

var messageWriter = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.WriteableStreamMessageWriter = exports.AbstractMessageWriter = exports.MessageWriter = void 0;




const ContentLength = 'Content-Length: ';
const CRLF = '\r\n';
var MessageWriter;
(function (MessageWriter) {
    function is(value) {
        let candidate = value;
        return candidate && is$1.func(candidate.dispose) && is$1.func(candidate.onClose) &&
            is$1.func(candidate.onError) && is$1.func(candidate.write);
    }
    MessageWriter.is = is;
})(MessageWriter = exports.MessageWriter || (exports.MessageWriter = {}));
class AbstractMessageWriter {
    constructor() {
        this.errorEmitter = new events.Emitter();
        this.closeEmitter = new events.Emitter();
    }
    dispose() {
        this.errorEmitter.dispose();
        this.closeEmitter.dispose();
    }
    get onError() {
        return this.errorEmitter.event;
    }
    fireError(error, message, count) {
        this.errorEmitter.fire([this.asError(error), message, count]);
    }
    get onClose() {
        return this.closeEmitter.event;
    }
    fireClose() {
        this.closeEmitter.fire(undefined);
    }
    asError(error) {
        if (error instanceof Error) {
            return error;
        }
        else {
            return new Error(`Writer received error. Reason: ${is$1.string(error.message) ? error.message : 'unknown'}`);
        }
    }
}
exports.AbstractMessageWriter = AbstractMessageWriter;
var ResolvedMessageWriterOptions;
(function (ResolvedMessageWriterOptions) {
    function fromOptions(options) {
        var _a, _b;
        if (options === undefined || typeof options === 'string') {
            return { charset: options !== null && options !== void 0 ? options : 'utf-8', contentTypeEncoder: ral.default().applicationJson.encoder };
        }
        else {
            return { charset: (_a = options.charset) !== null && _a !== void 0 ? _a : 'utf-8', contentEncoder: options.contentEncoder, contentTypeEncoder: (_b = options.contentTypeEncoder) !== null && _b !== void 0 ? _b : ral.default().applicationJson.encoder };
        }
    }
    ResolvedMessageWriterOptions.fromOptions = fromOptions;
})(ResolvedMessageWriterOptions || (ResolvedMessageWriterOptions = {}));
class WriteableStreamMessageWriter extends AbstractMessageWriter {
    constructor(writable, options) {
        super();
        this.writable = writable;
        this.options = ResolvedMessageWriterOptions.fromOptions(options);
        this.errorCount = 0;
        this.writeSemaphore = new semaphore.Semaphore(1);
        this.writable.onError((error) => this.fireError(error));
        this.writable.onClose(() => this.fireClose());
    }
    async write(msg) {
        return this.writeSemaphore.lock(async () => {
            const payload = this.options.contentTypeEncoder.encode(msg, this.options).then((buffer) => {
                if (this.options.contentEncoder !== undefined) {
                    return this.options.contentEncoder.encode(buffer);
                }
                else {
                    return buffer;
                }
            });
            return payload.then((buffer) => {
                const headers = [];
                headers.push(ContentLength, buffer.byteLength.toString(), CRLF);
                headers.push(CRLF);
                return this.doWrite(msg, headers, buffer);
            }, (error) => {
                this.fireError(error);
                throw error;
            });
        });
    }
    async doWrite(msg, headers, data) {
        try {
            await this.writable.write(headers.join(''), 'ascii');
            return this.writable.write(data);
        }
        catch (error) {
            this.handleError(error, msg);
            return Promise.reject(error);
        }
    }
    handleError(error, msg) {
        this.errorCount++;
        this.fireError(error, msg, this.errorCount);
    }
    end() {
        this.writable.end();
    }
}
exports.WriteableStreamMessageWriter = WriteableStreamMessageWriter;

});

var linkedMap = createCommonjsModule(function (module, exports) {
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.LRUCache = exports.LinkedMap = exports.Touch = void 0;
var Touch;
(function (Touch) {
    Touch.None = 0;
    Touch.First = 1;
    Touch.AsOld = Touch.First;
    Touch.Last = 2;
    Touch.AsNew = Touch.Last;
})(Touch = exports.Touch || (exports.Touch = {}));
class LinkedMap {
    constructor() {
        this[Symbol.toStringTag] = 'LinkedMap';
        this._map = new Map();
        this._head = undefined;
        this._tail = undefined;
        this._size = 0;
        this._state = 0;
    }
    clear() {
        this._map.clear();
        this._head = undefined;
        this._tail = undefined;
        this._size = 0;
        this._state++;
    }
    isEmpty() {
        return !this._head && !this._tail;
    }
    get size() {
        return this._size;
    }
    get first() {
        var _a;
        return (_a = this._head) === null || _a === void 0 ? void 0 : _a.value;
    }
    get last() {
        var _a;
        return (_a = this._tail) === null || _a === void 0 ? void 0 : _a.value;
    }
    has(key) {
        return this._map.has(key);
    }
    get(key, touch = Touch.None) {
        const item = this._map.get(key);
        if (!item) {
            return undefined;
        }
        if (touch !== Touch.None) {
            this.touch(item, touch);
        }
        return item.value;
    }
    set(key, value, touch = Touch.None) {
        let item = this._map.get(key);
        if (item) {
            item.value = value;
            if (touch !== Touch.None) {
                this.touch(item, touch);
            }
        }
        else {
            item = { key, value, next: undefined, previous: undefined };
            switch (touch) {
                case Touch.None:
                    this.addItemLast(item);
                    break;
                case Touch.First:
                    this.addItemFirst(item);
                    break;
                case Touch.Last:
                    this.addItemLast(item);
                    break;
                default:
                    this.addItemLast(item);
                    break;
            }
            this._map.set(key, item);
            this._size++;
        }
        return this;
    }
    delete(key) {
        return !!this.remove(key);
    }
    remove(key) {
        const item = this._map.get(key);
        if (!item) {
            return undefined;
        }
        this._map.delete(key);
        this.removeItem(item);
        this._size--;
        return item.value;
    }
    shift() {
        if (!this._head && !this._tail) {
            return undefined;
        }
        if (!this._head || !this._tail) {
            throw new Error('Invalid list');
        }
        const item = this._head;
        this._map.delete(item.key);
        this.removeItem(item);
        this._size--;
        return item.value;
    }
    forEach(callbackfn, thisArg) {
        const state = this._state;
        let current = this._head;
        while (current) {
            if (thisArg) {
                callbackfn.bind(thisArg)(current.value, current.key, this);
            }
            else {
                callbackfn(current.value, current.key, this);
            }
            if (this._state !== state) {
                throw new Error(`LinkedMap got modified during iteration.`);
            }
            current = current.next;
        }
    }
    keys() {
        const map = this;
        const state = this._state;
        let current = this._head;
        const iterator = {
            [Symbol.iterator]() {
                return iterator;
            },
            next() {
                if (map._state !== state) {
                    throw new Error(`LinkedMap got modified during iteration.`);
                }
                if (current) {
                    const result = { value: current.key, done: false };
                    current = current.next;
                    return result;
                }
                else {
                    return { value: undefined, done: true };
                }
            }
        };
        return iterator;
    }
    values() {
        const map = this;
        const state = this._state;
        let current = this._head;
        const iterator = {
            [Symbol.iterator]() {
                return iterator;
            },
            next() {
                if (map._state !== state) {
                    throw new Error(`LinkedMap got modified during iteration.`);
                }
                if (current) {
                    const result = { value: current.value, done: false };
                    current = current.next;
                    return result;
                }
                else {
                    return { value: undefined, done: true };
                }
            }
        };
        return iterator;
    }
    entries() {
        const map = this;
        const state = this._state;
        let current = this._head;
        const iterator = {
            [Symbol.iterator]() {
                return iterator;
            },
            next() {
                if (map._state !== state) {
                    throw new Error(`LinkedMap got modified during iteration.`);
                }
                if (current) {
                    const result = { value: [current.key, current.value], done: false };
                    current = current.next;
                    return result;
                }
                else {
                    return { value: undefined, done: true };
                }
            }
        };
        return iterator;
    }
    [Symbol.iterator]() {
        return this.entries();
    }
    trimOld(newSize) {
        if (newSize >= this.size) {
            return;
        }
        if (newSize === 0) {
            this.clear();
            return;
        }
        let current = this._head;
        let currentSize = this.size;
        while (current && currentSize > newSize) {
            this._map.delete(current.key);
            current = current.next;
            currentSize--;
        }
        this._head = current;
        this._size = currentSize;
        if (current) {
            current.previous = undefined;
        }
        this._state++;
    }
    addItemFirst(item) {
        // First time Insert
        if (!this._head && !this._tail) {
            this._tail = item;
        }
        else if (!this._head) {
            throw new Error('Invalid list');
        }
        else {
            item.next = this._head;
            this._head.previous = item;
        }
        this._head = item;
        this._state++;
    }
    addItemLast(item) {
        // First time Insert
        if (!this._head && !this._tail) {
            this._head = item;
        }
        else if (!this._tail) {
            throw new Error('Invalid list');
        }
        else {
            item.previous = this._tail;
            this._tail.next = item;
        }
        this._tail = item;
        this._state++;
    }
    removeItem(item) {
        if (item === this._head && item === this._tail) {
            this._head = undefined;
            this._tail = undefined;
        }
        else if (item === this._head) {
            // This can only happend if size === 1 which is handle
            // by the case above.
            if (!item.next) {
                throw new Error('Invalid list');
            }
            item.next.previous = undefined;
            this._head = item.next;
        }
        else if (item === this._tail) {
            // This can only happend if size === 1 which is handle
            // by the case above.
            if (!item.previous) {
                throw new Error('Invalid list');
            }
            item.previous.next = undefined;
            this._tail = item.previous;
        }
        else {
            const next = item.next;
            const previous = item.previous;
            if (!next || !previous) {
                throw new Error('Invalid list');
            }
            next.previous = previous;
            previous.next = next;
        }
        item.next = undefined;
        item.previous = undefined;
        this._state++;
    }
    touch(item, touch) {
        if (!this._head || !this._tail) {
            throw new Error('Invalid list');
        }
        if ((touch !== Touch.First && touch !== Touch.Last)) {
            return;
        }
        if (touch === Touch.First) {
            if (item === this._head) {
                return;
            }
            const next = item.next;
            const previous = item.previous;
            // Unlink the item
            if (item === this._tail) {
                // previous must be defined since item was not head but is tail
                // So there are more than on item in the map
                previous.next = undefined;
                this._tail = previous;
            }
            else {
                // Both next and previous are not undefined since item was neither head nor tail.
                next.previous = previous;
                previous.next = next;
            }
            // Insert the node at head
            item.previous = undefined;
            item.next = this._head;
            this._head.previous = item;
            this._head = item;
            this._state++;
        }
        else if (touch === Touch.Last) {
            if (item === this._tail) {
                return;
            }
            const next = item.next;
            const previous = item.previous;
            // Unlink the item.
            if (item === this._head) {
                // next must be defined since item was not tail but is head
                // So there are more than on item in the map
                next.previous = undefined;
                this._head = next;
            }
            else {
                // Both next and previous are not undefined since item was neither head nor tail.
                next.previous = previous;
                previous.next = next;
            }
            item.next = undefined;
            item.previous = this._tail;
            this._tail.next = item;
            this._tail = item;
            this._state++;
        }
    }
    toJSON() {
        const data = [];
        this.forEach((value, key) => {
            data.push([key, value]);
        });
        return data;
    }
    fromJSON(data) {
        this.clear();
        for (const [key, value] of data) {
            this.set(key, value);
        }
    }
}
exports.LinkedMap = LinkedMap;
class LRUCache extends LinkedMap {
    constructor(limit, ratio = 1) {
        super();
        this._limit = limit;
        this._ratio = Math.min(Math.max(0, ratio), 1);
    }
    get limit() {
        return this._limit;
    }
    set limit(limit) {
        this._limit = limit;
        this.checkTrim();
    }
    get ratio() {
        return this._ratio;
    }
    set ratio(ratio) {
        this._ratio = Math.min(Math.max(0, ratio), 1);
        this.checkTrim();
    }
    get(key, touch = Touch.AsNew) {
        return super.get(key, touch);
    }
    peek(key) {
        return super.get(key, Touch.None);
    }
    set(key, value) {
        super.set(key, value, Touch.Last);
        this.checkTrim();
        return this;
    }
    checkTrim() {
        if (this.size > this._limit) {
            this.trimOld(Math.round(this._limit * this._ratio));
        }
    }
}
exports.LRUCache = LRUCache;

});

var connection = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMessageConnection = exports.ConnectionOptions = exports.CancellationStrategy = exports.CancellationSenderStrategy = exports.CancellationReceiverStrategy = exports.ConnectionStrategy = exports.ConnectionError = exports.ConnectionErrors = exports.LogTraceNotification = exports.SetTraceNotification = exports.TraceFormat = exports.Trace = exports.NullLogger = exports.ProgressType = void 0;






var CancelNotification;
(function (CancelNotification) {
    CancelNotification.type = new messages.NotificationType('$/cancelRequest');
})(CancelNotification || (CancelNotification = {}));
var ProgressNotification;
(function (ProgressNotification) {
    ProgressNotification.type = new messages.NotificationType('$/progress');
})(ProgressNotification || (ProgressNotification = {}));
class ProgressType {
    constructor() {
    }
}
exports.ProgressType = ProgressType;
var StarRequestHandler;
(function (StarRequestHandler) {
    function is(value) {
        return is$1.func(value);
    }
    StarRequestHandler.is = is;
})(StarRequestHandler || (StarRequestHandler = {}));
exports.NullLogger = Object.freeze({
    error: () => { },
    warn: () => { },
    info: () => { },
    log: () => { }
});
var Trace;
(function (Trace) {
    Trace[Trace["Off"] = 0] = "Off";
    Trace[Trace["Messages"] = 1] = "Messages";
    Trace[Trace["Verbose"] = 2] = "Verbose";
})(Trace = exports.Trace || (exports.Trace = {}));
(function (Trace) {
    function fromString(value) {
        if (!is$1.string(value)) {
            return Trace.Off;
        }
        value = value.toLowerCase();
        switch (value) {
            case 'off':
                return Trace.Off;
            case 'messages':
                return Trace.Messages;
            case 'verbose':
                return Trace.Verbose;
            default:
                return Trace.Off;
        }
    }
    Trace.fromString = fromString;
    function toString(value) {
        switch (value) {
            case Trace.Off:
                return 'off';
            case Trace.Messages:
                return 'messages';
            case Trace.Verbose:
                return 'verbose';
            default:
                return 'off';
        }
    }
    Trace.toString = toString;
})(Trace = exports.Trace || (exports.Trace = {}));
var TraceFormat;
(function (TraceFormat) {
    TraceFormat["Text"] = "text";
    TraceFormat["JSON"] = "json";
})(TraceFormat = exports.TraceFormat || (exports.TraceFormat = {}));
(function (TraceFormat) {
    function fromString(value) {
        value = value.toLowerCase();
        if (value === 'json') {
            return TraceFormat.JSON;
        }
        else {
            return TraceFormat.Text;
        }
    }
    TraceFormat.fromString = fromString;
})(TraceFormat = exports.TraceFormat || (exports.TraceFormat = {}));
var SetTraceNotification;
(function (SetTraceNotification) {
    SetTraceNotification.type = new messages.NotificationType('$/setTrace');
})(SetTraceNotification = exports.SetTraceNotification || (exports.SetTraceNotification = {}));
var LogTraceNotification;
(function (LogTraceNotification) {
    LogTraceNotification.type = new messages.NotificationType('$/logTrace');
})(LogTraceNotification = exports.LogTraceNotification || (exports.LogTraceNotification = {}));
var ConnectionErrors;
(function (ConnectionErrors) {
    /**
     * The connection is closed.
     */
    ConnectionErrors[ConnectionErrors["Closed"] = 1] = "Closed";
    /**
     * The connection got disposed.
     */
    ConnectionErrors[ConnectionErrors["Disposed"] = 2] = "Disposed";
    /**
     * The connection is already in listening mode.
     */
    ConnectionErrors[ConnectionErrors["AlreadyListening"] = 3] = "AlreadyListening";
})(ConnectionErrors = exports.ConnectionErrors || (exports.ConnectionErrors = {}));
class ConnectionError extends Error {
    constructor(code, message) {
        super(message);
        this.code = code;
        Object.setPrototypeOf(this, ConnectionError.prototype);
    }
}
exports.ConnectionError = ConnectionError;
var ConnectionStrategy;
(function (ConnectionStrategy) {
    function is(value) {
        const candidate = value;
        return candidate && is$1.func(candidate.cancelUndispatched);
    }
    ConnectionStrategy.is = is;
})(ConnectionStrategy = exports.ConnectionStrategy || (exports.ConnectionStrategy = {}));
var CancellationReceiverStrategy;
(function (CancellationReceiverStrategy) {
    CancellationReceiverStrategy.Message = Object.freeze({
        createCancellationTokenSource(_) {
            return new cancellation.CancellationTokenSource();
        }
    });
    function is(value) {
        const candidate = value;
        return candidate && is$1.func(candidate.createCancellationTokenSource);
    }
    CancellationReceiverStrategy.is = is;
})(CancellationReceiverStrategy = exports.CancellationReceiverStrategy || (exports.CancellationReceiverStrategy = {}));
var CancellationSenderStrategy;
(function (CancellationSenderStrategy) {
    CancellationSenderStrategy.Message = Object.freeze({
        sendCancellation(conn, id) {
            conn.sendNotification(CancelNotification.type, { id });
        },
        cleanup(_) { }
    });
    function is(value) {
        const candidate = value;
        return candidate && is$1.func(candidate.sendCancellation) && is$1.func(candidate.cleanup);
    }
    CancellationSenderStrategy.is = is;
})(CancellationSenderStrategy = exports.CancellationSenderStrategy || (exports.CancellationSenderStrategy = {}));
var CancellationStrategy;
(function (CancellationStrategy) {
    CancellationStrategy.Message = Object.freeze({
        receiver: CancellationReceiverStrategy.Message,
        sender: CancellationSenderStrategy.Message
    });
    function is(value) {
        const candidate = value;
        return candidate && CancellationReceiverStrategy.is(candidate.receiver) && CancellationSenderStrategy.is(candidate.sender);
    }
    CancellationStrategy.is = is;
})(CancellationStrategy = exports.CancellationStrategy || (exports.CancellationStrategy = {}));
var ConnectionOptions;
(function (ConnectionOptions) {
    function is(value) {
        const candidate = value;
        return candidate && (CancellationStrategy.is(candidate.cancellationStrategy) || ConnectionStrategy.is(candidate.connectionStrategy));
    }
    ConnectionOptions.is = is;
})(ConnectionOptions = exports.ConnectionOptions || (exports.ConnectionOptions = {}));
var ConnectionState;
(function (ConnectionState) {
    ConnectionState[ConnectionState["New"] = 1] = "New";
    ConnectionState[ConnectionState["Listening"] = 2] = "Listening";
    ConnectionState[ConnectionState["Closed"] = 3] = "Closed";
    ConnectionState[ConnectionState["Disposed"] = 4] = "Disposed";
})(ConnectionState || (ConnectionState = {}));
function createMessageConnection(messageReader, messageWriter, _logger, options) {
    const logger = _logger !== undefined ? _logger : exports.NullLogger;
    let sequenceNumber = 0;
    let notificationSquenceNumber = 0;
    let unknownResponseSquenceNumber = 0;
    const version = '2.0';
    let starRequestHandler = undefined;
    const requestHandlers = Object.create(null);
    let starNotificationHandler = undefined;
    const notificationHandlers = Object.create(null);
    const progressHandlers = new Map();
    let timer;
    let messageQueue = new linkedMap.LinkedMap();
    let responsePromises = Object.create(null);
    let requestTokens = Object.create(null);
    let trace = Trace.Off;
    let traceFormat = TraceFormat.Text;
    let tracer;
    let state = ConnectionState.New;
    const errorEmitter = new events.Emitter();
    const closeEmitter = new events.Emitter();
    const unhandledNotificationEmitter = new events.Emitter();
    const unhandledProgressEmitter = new events.Emitter();
    const disposeEmitter = new events.Emitter();
    const cancellationStrategy = (options && options.cancellationStrategy) ? options.cancellationStrategy : CancellationStrategy.Message;
    function createRequestQueueKey(id) {
        if (id === null) {
            throw new Error(`Can't send requests with id null since the response can't be correlated.`);
        }
        return 'req-' + id.toString();
    }
    function createResponseQueueKey(id) {
        if (id === null) {
            return 'res-unknown-' + (++unknownResponseSquenceNumber).toString();
        }
        else {
            return 'res-' + id.toString();
        }
    }
    function createNotificationQueueKey() {
        return 'not-' + (++notificationSquenceNumber).toString();
    }
    function addMessageToQueue(queue, message) {
        if (messages.isRequestMessage(message)) {
            queue.set(createRequestQueueKey(message.id), message);
        }
        else if (messages.isResponseMessage(message)) {
            queue.set(createResponseQueueKey(message.id), message);
        }
        else {
            queue.set(createNotificationQueueKey(), message);
        }
    }
    function cancelUndispatched(_message) {
        return undefined;
    }
    function isListening() {
        return state === ConnectionState.Listening;
    }
    function isClosed() {
        return state === ConnectionState.Closed;
    }
    function isDisposed() {
        return state === ConnectionState.Disposed;
    }
    function closeHandler() {
        if (state === ConnectionState.New || state === ConnectionState.Listening) {
            state = ConnectionState.Closed;
            closeEmitter.fire(undefined);
        }
        // If the connection is disposed don't sent close events.
    }
    function readErrorHandler(error) {
        errorEmitter.fire([error, undefined, undefined]);
    }
    function writeErrorHandler(data) {
        errorEmitter.fire(data);
    }
    messageReader.onClose(closeHandler);
    messageReader.onError(readErrorHandler);
    messageWriter.onClose(closeHandler);
    messageWriter.onError(writeErrorHandler);
    function triggerMessageQueue() {
        if (timer || messageQueue.size === 0) {
            return;
        }
        timer = ral.default().timer.setImmediate(() => {
            timer = undefined;
            processMessageQueue();
        });
    }
    function processMessageQueue() {
        if (messageQueue.size === 0) {
            return;
        }
        const message = messageQueue.shift();
        try {
            if (messages.isRequestMessage(message)) {
                handleRequest(message);
            }
            else if (messages.isNotificationMessage(message)) {
                handleNotification(message);
            }
            else if (messages.isResponseMessage(message)) {
                handleResponse(message);
            }
            else {
                handleInvalidMessage(message);
            }
        }
        finally {
            triggerMessageQueue();
        }
    }
    const callback = (message) => {
        try {
            // We have received a cancellation message. Check if the message is still in the queue
            // and cancel it if allowed to do so.
            if (messages.isNotificationMessage(message) && message.method === CancelNotification.type.method) {
                const key = createRequestQueueKey(message.params.id);
                const toCancel = messageQueue.get(key);
                if (messages.isRequestMessage(toCancel)) {
                    const strategy = options === null || options === void 0 ? void 0 : options.connectionStrategy;
                    const response = (strategy && strategy.cancelUndispatched) ? strategy.cancelUndispatched(toCancel, cancelUndispatched) : cancelUndispatched(toCancel);
                    if (response && (response.error !== undefined || response.result !== undefined)) {
                        messageQueue.delete(key);
                        response.id = toCancel.id;
                        traceSendingResponse(response, message.method, Date.now());
                        messageWriter.write(response);
                        return;
                    }
                }
            }
            addMessageToQueue(messageQueue, message);
        }
        finally {
            triggerMessageQueue();
        }
    };
    function handleRequest(requestMessage) {
        if (isDisposed()) {
            // we return here silently since we fired an event when the
            // connection got disposed.
            return;
        }
        function reply(resultOrError, method, startTime) {
            const message = {
                jsonrpc: version,
                id: requestMessage.id
            };
            if (resultOrError instanceof messages.ResponseError) {
                message.error = resultOrError.toJson();
            }
            else {
                message.result = resultOrError === undefined ? null : resultOrError;
            }
            traceSendingResponse(message, method, startTime);
            messageWriter.write(message);
        }
        function replyError(error, method, startTime) {
            const message = {
                jsonrpc: version,
                id: requestMessage.id,
                error: error.toJson()
            };
            traceSendingResponse(message, method, startTime);
            messageWriter.write(message);
        }
        function replySuccess(result, method, startTime) {
            // The JSON RPC defines that a response must either have a result or an error
            // So we can't treat undefined as a valid response result.
            if (result === undefined) {
                result = null;
            }
            const message = {
                jsonrpc: version,
                id: requestMessage.id,
                result: result
            };
            traceSendingResponse(message, method, startTime);
            messageWriter.write(message);
        }
        traceReceivedRequest(requestMessage);
        const element = requestHandlers[requestMessage.method];
        let type;
        let requestHandler;
        if (element) {
            type = element.type;
            requestHandler = element.handler;
        }
        const startTime = Date.now();
        if (requestHandler || starRequestHandler) {
            const tokenKey = String(requestMessage.id);
            const cancellationSource = cancellationStrategy.receiver.createCancellationTokenSource(tokenKey);
            requestTokens[tokenKey] = cancellationSource;
            try {
                let handlerResult;
                if (requestHandler) {
                    if (requestMessage.params === undefined) {
                        if (type !== undefined && type.numberOfParams !== 0) {
                            replyError(new messages.ResponseError(messages.ErrorCodes.InvalidParams, `Request ${requestMessage.method} defines ${type.numberOfParams} params but recevied none.`), requestMessage.method, startTime);
                            return;
                        }
                        handlerResult = requestHandler(cancellationSource.token);
                    }
                    else if (Array.isArray(requestMessage.params)) {
                        if (type !== undefined && type.parameterStructures === messages.ParameterStructures.byName) {
                            replyError(new messages.ResponseError(messages.ErrorCodes.InvalidParams, `Request ${requestMessage.method} defines parameters by name but received parameters by position`), requestMessage.method, startTime);
                            return;
                        }
                        handlerResult = requestHandler(...requestMessage.params, cancellationSource.token);
                    }
                    else {
                        if (type !== undefined && type.parameterStructures === messages.ParameterStructures.byPosition) {
                            replyError(new messages.ResponseError(messages.ErrorCodes.InvalidParams, `Request ${requestMessage.method} defines parameters by position but received parameters by name`), requestMessage.method, startTime);
                            return;
                        }
                        handlerResult = requestHandler(requestMessage.params, cancellationSource.token);
                    }
                }
                else if (starRequestHandler) {
                    handlerResult = starRequestHandler(requestMessage.method, requestMessage.params, cancellationSource.token);
                }
                const promise = handlerResult;
                if (!handlerResult) {
                    delete requestTokens[tokenKey];
                    replySuccess(handlerResult, requestMessage.method, startTime);
                }
                else if (promise.then) {
                    promise.then((resultOrError) => {
                        delete requestTokens[tokenKey];
                        reply(resultOrError, requestMessage.method, startTime);
                    }, error => {
                        delete requestTokens[tokenKey];
                        if (error instanceof messages.ResponseError) {
                            replyError(error, requestMessage.method, startTime);
                        }
                        else if (error && is$1.string(error.message)) {
                            replyError(new messages.ResponseError(messages.ErrorCodes.InternalError, `Request ${requestMessage.method} failed with message: ${error.message}`), requestMessage.method, startTime);
                        }
                        else {
                            replyError(new messages.ResponseError(messages.ErrorCodes.InternalError, `Request ${requestMessage.method} failed unexpectedly without providing any details.`), requestMessage.method, startTime);
                        }
                    });
                }
                else {
                    delete requestTokens[tokenKey];
                    reply(handlerResult, requestMessage.method, startTime);
                }
            }
            catch (error) {
                delete requestTokens[tokenKey];
                if (error instanceof messages.ResponseError) {
                    reply(error, requestMessage.method, startTime);
                }
                else if (error && is$1.string(error.message)) {
                    replyError(new messages.ResponseError(messages.ErrorCodes.InternalError, `Request ${requestMessage.method} failed with message: ${error.message}`), requestMessage.method, startTime);
                }
                else {
                    replyError(new messages.ResponseError(messages.ErrorCodes.InternalError, `Request ${requestMessage.method} failed unexpectedly without providing any details.`), requestMessage.method, startTime);
                }
            }
        }
        else {
            replyError(new messages.ResponseError(messages.ErrorCodes.MethodNotFound, `Unhandled method ${requestMessage.method}`), requestMessage.method, startTime);
        }
    }
    function handleResponse(responseMessage) {
        if (isDisposed()) {
            // See handle request.
            return;
        }
        if (responseMessage.id === null) {
            if (responseMessage.error) {
                logger.error(`Received response message without id: Error is: \n${JSON.stringify(responseMessage.error, undefined, 4)}`);
            }
            else {
                logger.error(`Received response message without id. No further error information provided.`);
            }
        }
        else {
            const key = String(responseMessage.id);
            const responsePromise = responsePromises[key];
            traceReceivedResponse(responseMessage, responsePromise);
            if (responsePromise) {
                delete responsePromises[key];
                try {
                    if (responseMessage.error) {
                        const error = responseMessage.error;
                        responsePromise.reject(new messages.ResponseError(error.code, error.message, error.data));
                    }
                    else if (responseMessage.result !== undefined) {
                        responsePromise.resolve(responseMessage.result);
                    }
                    else {
                        throw new Error('Should never happen.');
                    }
                }
                catch (error) {
                    if (error.message) {
                        logger.error(`Response handler '${responsePromise.method}' failed with message: ${error.message}`);
                    }
                    else {
                        logger.error(`Response handler '${responsePromise.method}' failed unexpectedly.`);
                    }
                }
            }
        }
    }
    function handleNotification(message) {
        if (isDisposed()) {
            // See handle request.
            return;
        }
        let type = undefined;
        let notificationHandler;
        if (message.method === CancelNotification.type.method) {
            notificationHandler = (params) => {
                const id = params.id;
                const source = requestTokens[String(id)];
                if (source) {
                    source.cancel();
                }
            };
        }
        else {
            const element = notificationHandlers[message.method];
            if (element) {
                notificationHandler = element.handler;
                type = element.type;
            }
        }
        if (notificationHandler || starNotificationHandler) {
            try {
                traceReceivedNotification(message);
                if (notificationHandler) {
                    if (message.params === undefined) {
                        if (type !== undefined) {
                            if (type.numberOfParams !== 0 && type.parameterStructures !== messages.ParameterStructures.byName) {
                                logger.error(`Notification ${message.method} defines ${type.numberOfParams} params but recevied none.`);
                            }
                        }
                        notificationHandler();
                    }
                    else if (Array.isArray(message.params)) {
                        if (type !== undefined) {
                            if (type.parameterStructures === messages.ParameterStructures.byName) {
                                logger.error(`Notification ${message.method} defines parameters by name but received parameters by position`);
                            }
                            if (type.numberOfParams !== message.params.length) {
                                logger.error(`Notification ${message.method} defines ${type.numberOfParams} params but received ${message.params.length} argumennts`);
                            }
                        }
                        notificationHandler(...message.params);
                    }
                    else {
                        if (type !== undefined && type.parameterStructures === messages.ParameterStructures.byPosition) {
                            logger.error(`Notification ${message.method} defines parameters by position but received parameters by name`);
                        }
                        notificationHandler(message.params);
                    }
                }
                else if (starNotificationHandler) {
                    starNotificationHandler(message.method, message.params);
                }
            }
            catch (error) {
                if (error.message) {
                    logger.error(`Notification handler '${message.method}' failed with message: ${error.message}`);
                }
                else {
                    logger.error(`Notification handler '${message.method}' failed unexpectedly.`);
                }
            }
        }
        else {
            unhandledNotificationEmitter.fire(message);
        }
    }
    function handleInvalidMessage(message) {
        if (!message) {
            logger.error('Received empty message.');
            return;
        }
        logger.error(`Received message which is neither a response nor a notification message:\n${JSON.stringify(message, null, 4)}`);
        // Test whether we find an id to reject the promise
        const responseMessage = message;
        if (is$1.string(responseMessage.id) || is$1.number(responseMessage.id)) {
            const key = String(responseMessage.id);
            const responseHandler = responsePromises[key];
            if (responseHandler) {
                responseHandler.reject(new Error('The received response has neither a result nor an error property.'));
            }
        }
    }
    function traceSendingRequest(message) {
        if (trace === Trace.Off || !tracer) {
            return;
        }
        if (traceFormat === TraceFormat.Text) {
            let data = undefined;
            if (trace === Trace.Verbose && message.params) {
                data = `Params: ${JSON.stringify(message.params, null, 4)}\n\n`;
            }
            tracer.log(`Sending request '${message.method} - (${message.id})'.`, data);
        }
        else {
            logLSPMessage('send-request', message);
        }
    }
    function traceSendingNotification(message) {
        if (trace === Trace.Off || !tracer) {
            return;
        }
        if (traceFormat === TraceFormat.Text) {
            let data = undefined;
            if (trace === Trace.Verbose) {
                if (message.params) {
                    data = `Params: ${JSON.stringify(message.params, null, 4)}\n\n`;
                }
                else {
                    data = 'No parameters provided.\n\n';
                }
            }
            tracer.log(`Sending notification '${message.method}'.`, data);
        }
        else {
            logLSPMessage('send-notification', message);
        }
    }
    function traceSendingResponse(message, method, startTime) {
        if (trace === Trace.Off || !tracer) {
            return;
        }
        if (traceFormat === TraceFormat.Text) {
            let data = undefined;
            if (trace === Trace.Verbose) {
                if (message.error && message.error.data) {
                    data = `Error data: ${JSON.stringify(message.error.data, null, 4)}\n\n`;
                }
                else {
                    if (message.result) {
                        data = `Result: ${JSON.stringify(message.result, null, 4)}\n\n`;
                    }
                    else if (message.error === undefined) {
                        data = 'No result returned.\n\n';
                    }
                }
            }
            tracer.log(`Sending response '${method} - (${message.id})'. Processing request took ${Date.now() - startTime}ms`, data);
        }
        else {
            logLSPMessage('send-response', message);
        }
    }
    function traceReceivedRequest(message) {
        if (trace === Trace.Off || !tracer) {
            return;
        }
        if (traceFormat === TraceFormat.Text) {
            let data = undefined;
            if (trace === Trace.Verbose && message.params) {
                data = `Params: ${JSON.stringify(message.params, null, 4)}\n\n`;
            }
            tracer.log(`Received request '${message.method} - (${message.id})'.`, data);
        }
        else {
            logLSPMessage('receive-request', message);
        }
    }
    function traceReceivedNotification(message) {
        if (trace === Trace.Off || !tracer || message.method === LogTraceNotification.type.method) {
            return;
        }
        if (traceFormat === TraceFormat.Text) {
            let data = undefined;
            if (trace === Trace.Verbose) {
                if (message.params) {
                    data = `Params: ${JSON.stringify(message.params, null, 4)}\n\n`;
                }
                else {
                    data = 'No parameters provided.\n\n';
                }
            }
            tracer.log(`Received notification '${message.method}'.`, data);
        }
        else {
            logLSPMessage('receive-notification', message);
        }
    }
    function traceReceivedResponse(message, responsePromise) {
        if (trace === Trace.Off || !tracer) {
            return;
        }
        if (traceFormat === TraceFormat.Text) {
            let data = undefined;
            if (trace === Trace.Verbose) {
                if (message.error && message.error.data) {
                    data = `Error data: ${JSON.stringify(message.error.data, null, 4)}\n\n`;
                }
                else {
                    if (message.result) {
                        data = `Result: ${JSON.stringify(message.result, null, 4)}\n\n`;
                    }
                    else if (message.error === undefined) {
                        data = 'No result returned.\n\n';
                    }
                }
            }
            if (responsePromise) {
                const error = message.error ? ` Request failed: ${message.error.message} (${message.error.code}).` : '';
                tracer.log(`Received response '${responsePromise.method} - (${message.id})' in ${Date.now() - responsePromise.timerStart}ms.${error}`, data);
            }
            else {
                tracer.log(`Received response ${message.id} without active response promise.`, data);
            }
        }
        else {
            logLSPMessage('receive-response', message);
        }
    }
    function logLSPMessage(type, message) {
        if (!tracer || trace === Trace.Off) {
            return;
        }
        const lspMessage = {
            isLSPMessage: true,
            type,
            message,
            timestamp: Date.now()
        };
        tracer.log(lspMessage);
    }
    function throwIfClosedOrDisposed() {
        if (isClosed()) {
            throw new ConnectionError(ConnectionErrors.Closed, 'Connection is closed.');
        }
        if (isDisposed()) {
            throw new ConnectionError(ConnectionErrors.Disposed, 'Connection is disposed.');
        }
    }
    function throwIfListening() {
        if (isListening()) {
            throw new ConnectionError(ConnectionErrors.AlreadyListening, 'Connection is already listening');
        }
    }
    function throwIfNotListening() {
        if (!isListening()) {
            throw new Error('Call listen() first.');
        }
    }
    function undefinedToNull(param) {
        if (param === undefined) {
            return null;
        }
        else {
            return param;
        }
    }
    function nullToUndefined(param) {
        if (param === null) {
            return undefined;
        }
        else {
            return param;
        }
    }
    function isNamedParam(param) {
        return param !== undefined && param !== null && !Array.isArray(param) && typeof param === 'object';
    }
    function computeSingleParam(parameterStructures, param) {
        switch (parameterStructures) {
            case messages.ParameterStructures.auto:
                if (isNamedParam(param)) {
                    return nullToUndefined(param);
                }
                else {
                    return [undefinedToNull(param)];
                }
            case messages.ParameterStructures.byName:
                if (!isNamedParam(param)) {
                    throw new Error(`Recevied parameters by name but param is not an object literal.`);
                }
                return nullToUndefined(param);
            case messages.ParameterStructures.byPosition:
                return [undefinedToNull(param)];
            default:
                throw new Error(`Unknown parameter structure ${parameterStructures.toString()}`);
        }
    }
    function computeMessageParams(type, params) {
        let result;
        const numberOfParams = type.numberOfParams;
        switch (numberOfParams) {
            case 0:
                result = undefined;
                break;
            case 1:
                result = computeSingleParam(type.parameterStructures, params[0]);
                break;
            default:
                result = [];
                for (let i = 0; i < params.length && i < numberOfParams; i++) {
                    result.push(undefinedToNull(params[i]));
                }
                if (params.length < numberOfParams) {
                    for (let i = params.length; i < numberOfParams; i++) {
                        result.push(null);
                    }
                }
                break;
        }
        return result;
    }
    const connection = {
        sendNotification: (type, ...args) => {
            throwIfClosedOrDisposed();
            let method;
            let messageParams;
            if (is$1.string(type)) {
                method = type;
                const first = args[0];
                let paramStart = 0;
                let parameterStructures = messages.ParameterStructures.auto;
                if (messages.ParameterStructures.is(first)) {
                    paramStart = 1;
                    parameterStructures = first;
                }
                let paramEnd = args.length;
                const numberOfParams = paramEnd - paramStart;
                switch (numberOfParams) {
                    case 0:
                        messageParams = undefined;
                        break;
                    case 1:
                        messageParams = computeSingleParam(parameterStructures, args[paramStart]);
                        break;
                    default:
                        if (parameterStructures === messages.ParameterStructures.byName) {
                            throw new Error(`Recevied ${numberOfParams} parameters for 'by Name' notification parameter structure.`);
                        }
                        messageParams = args.slice(paramStart, paramEnd).map(value => undefinedToNull(value));
                        break;
                }
            }
            else {
                const params = args;
                method = type.method;
                messageParams = computeMessageParams(type, params);
            }
            const notificationMessage = {
                jsonrpc: version,
                method: method,
                params: messageParams
            };
            traceSendingNotification(notificationMessage);
            messageWriter.write(notificationMessage);
        },
        onNotification: (type, handler) => {
            throwIfClosedOrDisposed();
            let method;
            if (is$1.func(type)) {
                starNotificationHandler = type;
            }
            else if (handler) {
                if (is$1.string(type)) {
                    method = type;
                    notificationHandlers[type] = { type: undefined, handler };
                }
                else {
                    method = type.method;
                    notificationHandlers[type.method] = { type, handler };
                }
            }
            return {
                dispose: () => {
                    if (method !== undefined) {
                        delete notificationHandlers[method];
                    }
                    else {
                        starNotificationHandler = undefined;
                    }
                }
            };
        },
        onProgress: (_type, token, handler) => {
            if (progressHandlers.has(token)) {
                throw new Error(`Progress handler for token ${token} already registered`);
            }
            progressHandlers.set(token, handler);
            return {
                dispose: () => {
                    progressHandlers.delete(token);
                }
            };
        },
        sendProgress: (_type, token, value) => {
            connection.sendNotification(ProgressNotification.type, { token, value });
        },
        onUnhandledProgress: unhandledProgressEmitter.event,
        sendRequest: (type, ...args) => {
            throwIfClosedOrDisposed();
            throwIfNotListening();
            let method;
            let messageParams;
            let token = undefined;
            if (is$1.string(type)) {
                method = type;
                const first = args[0];
                const last = args[args.length - 1];
                let paramStart = 0;
                let parameterStructures = messages.ParameterStructures.auto;
                if (messages.ParameterStructures.is(first)) {
                    paramStart = 1;
                    parameterStructures = first;
                }
                let paramEnd = args.length;
                if (cancellation.CancellationToken.is(last)) {
                    paramEnd = paramEnd - 1;
                    token = last;
                }
                const numberOfParams = paramEnd - paramStart;
                switch (numberOfParams) {
                    case 0:
                        messageParams = undefined;
                        break;
                    case 1:
                        messageParams = computeSingleParam(parameterStructures, args[paramStart]);
                        break;
                    default:
                        if (parameterStructures === messages.ParameterStructures.byName) {
                            throw new Error(`Recevied ${numberOfParams} parameters for 'by Name' request parameter structure.`);
                        }
                        messageParams = args.slice(paramStart, paramEnd).map(value => undefinedToNull(value));
                        break;
                }
            }
            else {
                const params = args;
                method = type.method;
                messageParams = computeMessageParams(type, params);
                const numberOfParams = type.numberOfParams;
                token = cancellation.CancellationToken.is(params[numberOfParams]) ? params[numberOfParams] : undefined;
            }
            const id = sequenceNumber++;
            let disposable;
            if (token) {
                disposable = token.onCancellationRequested(() => {
                    cancellationStrategy.sender.sendCancellation(connection, id);
                });
            }
            const result = new Promise((resolve, reject) => {
                const requestMessage = {
                    jsonrpc: version,
                    id: id,
                    method: method,
                    params: messageParams
                };
                const resolveWithCleanup = (r) => {
                    resolve(r);
                    cancellationStrategy.sender.cleanup(id);
                    disposable === null || disposable === void 0 ? void 0 : disposable.dispose();
                };
                const rejectWithCleanup = (r) => {
                    reject(r);
                    cancellationStrategy.sender.cleanup(id);
                    disposable === null || disposable === void 0 ? void 0 : disposable.dispose();
                };
                let responsePromise = { method: method, timerStart: Date.now(), resolve: resolveWithCleanup, reject: rejectWithCleanup };
                traceSendingRequest(requestMessage);
                try {
                    messageWriter.write(requestMessage);
                }
                catch (e) {
                    // Writing the message failed. So we need to reject the promise.
                    responsePromise.reject(new messages.ResponseError(messages.ErrorCodes.MessageWriteError, e.message ? e.message : 'Unknown reason'));
                    responsePromise = null;
                }
                if (responsePromise) {
                    responsePromises[String(id)] = responsePromise;
                }
            });
            return result;
        },
        onRequest: (type, handler) => {
            throwIfClosedOrDisposed();
            let method = null;
            if (StarRequestHandler.is(type)) {
                method = undefined;
                starRequestHandler = type;
            }
            else if (is$1.string(type)) {
                method = null;
                if (handler !== undefined) {
                    method = type;
                    requestHandlers[type] = { handler: handler, type: undefined };
                }
            }
            else {
                if (handler !== undefined) {
                    method = type.method;
                    requestHandlers[type.method] = { type, handler };
                }
            }
            return {
                dispose: () => {
                    if (method === null) {
                        return;
                    }
                    if (method !== undefined) {
                        delete requestHandlers[method];
                    }
                    else {
                        starRequestHandler = undefined;
                    }
                }
            };
        },
        trace: (_value, _tracer, sendNotificationOrTraceOptions) => {
            let _sendNotification = false;
            let _traceFormat = TraceFormat.Text;
            if (sendNotificationOrTraceOptions !== undefined) {
                if (is$1.boolean(sendNotificationOrTraceOptions)) {
                    _sendNotification = sendNotificationOrTraceOptions;
                }
                else {
                    _sendNotification = sendNotificationOrTraceOptions.sendNotification || false;
                    _traceFormat = sendNotificationOrTraceOptions.traceFormat || TraceFormat.Text;
                }
            }
            trace = _value;
            traceFormat = _traceFormat;
            if (trace === Trace.Off) {
                tracer = undefined;
            }
            else {
                tracer = _tracer;
            }
            if (_sendNotification && !isClosed() && !isDisposed()) {
                connection.sendNotification(SetTraceNotification.type, { value: Trace.toString(_value) });
            }
        },
        onError: errorEmitter.event,
        onClose: closeEmitter.event,
        onUnhandledNotification: unhandledNotificationEmitter.event,
        onDispose: disposeEmitter.event,
        end: () => {
            messageWriter.end();
        },
        dispose: () => {
            if (isDisposed()) {
                return;
            }
            state = ConnectionState.Disposed;
            disposeEmitter.fire(undefined);
            const error = new Error('Connection got disposed.');
            Object.keys(responsePromises).forEach((key) => {
                responsePromises[key].reject(error);
            });
            responsePromises = Object.create(null);
            requestTokens = Object.create(null);
            messageQueue = new linkedMap.LinkedMap();
            // Test for backwards compatibility
            if (is$1.func(messageWriter.dispose)) {
                messageWriter.dispose();
            }
            if (is$1.func(messageReader.dispose)) {
                messageReader.dispose();
            }
        },
        listen: () => {
            throwIfClosedOrDisposed();
            throwIfListening();
            state = ConnectionState.Listening;
            messageReader.listen(callback);
        },
        inspect: () => {
            // eslint-disable-next-line no-console
            ral.default().console.log('inspect');
        }
    };
    connection.onNotification(LogTraceNotification.type, (params) => {
        if (trace === Trace.Off || !tracer) {
            return;
        }
        tracer.log(params.message, trace === Trace.Verbose ? params.verbose : undefined);
    });
    connection.onNotification(ProgressNotification.type, (params) => {
        const handler = progressHandlers.get(params.token);
        if (handler) {
            handler(params.value);
        }
        else {
            unhandledProgressEmitter.fire(params);
        }
    });
    return connection;
}
exports.createMessageConnection = createMessageConnection;

});

var api = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
/// <reference path="../../typings/thenable.d.ts" />
Object.defineProperty(exports, "__esModule", { value: true });
exports.CancellationSenderStrategy = exports.CancellationReceiverStrategy = exports.ConnectionError = exports.ConnectionErrors = exports.LogTraceNotification = exports.SetTraceNotification = exports.TraceFormat = exports.Trace = exports.ProgressType = exports.createMessageConnection = exports.NullLogger = exports.ConnectionOptions = exports.ConnectionStrategy = exports.WriteableStreamMessageWriter = exports.AbstractMessageWriter = exports.MessageWriter = exports.ReadableStreamMessageReader = exports.AbstractMessageReader = exports.MessageReader = exports.CancellationToken = exports.CancellationTokenSource = exports.Emitter = exports.Event = exports.Disposable = exports.ParameterStructures = exports.NotificationType9 = exports.NotificationType8 = exports.NotificationType7 = exports.NotificationType6 = exports.NotificationType5 = exports.NotificationType4 = exports.NotificationType3 = exports.NotificationType2 = exports.NotificationType1 = exports.NotificationType0 = exports.NotificationType = exports.ErrorCodes = exports.ResponseError = exports.RequestType9 = exports.RequestType8 = exports.RequestType7 = exports.RequestType6 = exports.RequestType5 = exports.RequestType4 = exports.RequestType3 = exports.RequestType2 = exports.RequestType1 = exports.RequestType0 = exports.RequestType = exports.RAL = void 0;
exports.CancellationStrategy = void 0;

Object.defineProperty(exports, "RequestType", { enumerable: true, get: function () { return messages.RequestType; } });
Object.defineProperty(exports, "RequestType0", { enumerable: true, get: function () { return messages.RequestType0; } });
Object.defineProperty(exports, "RequestType1", { enumerable: true, get: function () { return messages.RequestType1; } });
Object.defineProperty(exports, "RequestType2", { enumerable: true, get: function () { return messages.RequestType2; } });
Object.defineProperty(exports, "RequestType3", { enumerable: true, get: function () { return messages.RequestType3; } });
Object.defineProperty(exports, "RequestType4", { enumerable: true, get: function () { return messages.RequestType4; } });
Object.defineProperty(exports, "RequestType5", { enumerable: true, get: function () { return messages.RequestType5; } });
Object.defineProperty(exports, "RequestType6", { enumerable: true, get: function () { return messages.RequestType6; } });
Object.defineProperty(exports, "RequestType7", { enumerable: true, get: function () { return messages.RequestType7; } });
Object.defineProperty(exports, "RequestType8", { enumerable: true, get: function () { return messages.RequestType8; } });
Object.defineProperty(exports, "RequestType9", { enumerable: true, get: function () { return messages.RequestType9; } });
Object.defineProperty(exports, "ResponseError", { enumerable: true, get: function () { return messages.ResponseError; } });
Object.defineProperty(exports, "ErrorCodes", { enumerable: true, get: function () { return messages.ErrorCodes; } });
Object.defineProperty(exports, "NotificationType", { enumerable: true, get: function () { return messages.NotificationType; } });
Object.defineProperty(exports, "NotificationType0", { enumerable: true, get: function () { return messages.NotificationType0; } });
Object.defineProperty(exports, "NotificationType1", { enumerable: true, get: function () { return messages.NotificationType1; } });
Object.defineProperty(exports, "NotificationType2", { enumerable: true, get: function () { return messages.NotificationType2; } });
Object.defineProperty(exports, "NotificationType3", { enumerable: true, get: function () { return messages.NotificationType3; } });
Object.defineProperty(exports, "NotificationType4", { enumerable: true, get: function () { return messages.NotificationType4; } });
Object.defineProperty(exports, "NotificationType5", { enumerable: true, get: function () { return messages.NotificationType5; } });
Object.defineProperty(exports, "NotificationType6", { enumerable: true, get: function () { return messages.NotificationType6; } });
Object.defineProperty(exports, "NotificationType7", { enumerable: true, get: function () { return messages.NotificationType7; } });
Object.defineProperty(exports, "NotificationType8", { enumerable: true, get: function () { return messages.NotificationType8; } });
Object.defineProperty(exports, "NotificationType9", { enumerable: true, get: function () { return messages.NotificationType9; } });
Object.defineProperty(exports, "ParameterStructures", { enumerable: true, get: function () { return messages.ParameterStructures; } });

Object.defineProperty(exports, "Disposable", { enumerable: true, get: function () { return disposable.Disposable; } });

Object.defineProperty(exports, "Event", { enumerable: true, get: function () { return events.Event; } });
Object.defineProperty(exports, "Emitter", { enumerable: true, get: function () { return events.Emitter; } });

Object.defineProperty(exports, "CancellationTokenSource", { enumerable: true, get: function () { return cancellation.CancellationTokenSource; } });
Object.defineProperty(exports, "CancellationToken", { enumerable: true, get: function () { return cancellation.CancellationToken; } });

Object.defineProperty(exports, "MessageReader", { enumerable: true, get: function () { return messageReader.MessageReader; } });
Object.defineProperty(exports, "AbstractMessageReader", { enumerable: true, get: function () { return messageReader.AbstractMessageReader; } });
Object.defineProperty(exports, "ReadableStreamMessageReader", { enumerable: true, get: function () { return messageReader.ReadableStreamMessageReader; } });

Object.defineProperty(exports, "MessageWriter", { enumerable: true, get: function () { return messageWriter.MessageWriter; } });
Object.defineProperty(exports, "AbstractMessageWriter", { enumerable: true, get: function () { return messageWriter.AbstractMessageWriter; } });
Object.defineProperty(exports, "WriteableStreamMessageWriter", { enumerable: true, get: function () { return messageWriter.WriteableStreamMessageWriter; } });

Object.defineProperty(exports, "ConnectionStrategy", { enumerable: true, get: function () { return connection.ConnectionStrategy; } });
Object.defineProperty(exports, "ConnectionOptions", { enumerable: true, get: function () { return connection.ConnectionOptions; } });
Object.defineProperty(exports, "NullLogger", { enumerable: true, get: function () { return connection.NullLogger; } });
Object.defineProperty(exports, "createMessageConnection", { enumerable: true, get: function () { return connection.createMessageConnection; } });
Object.defineProperty(exports, "ProgressType", { enumerable: true, get: function () { return connection.ProgressType; } });
Object.defineProperty(exports, "Trace", { enumerable: true, get: function () { return connection.Trace; } });
Object.defineProperty(exports, "TraceFormat", { enumerable: true, get: function () { return connection.TraceFormat; } });
Object.defineProperty(exports, "SetTraceNotification", { enumerable: true, get: function () { return connection.SetTraceNotification; } });
Object.defineProperty(exports, "LogTraceNotification", { enumerable: true, get: function () { return connection.LogTraceNotification; } });
Object.defineProperty(exports, "ConnectionErrors", { enumerable: true, get: function () { return connection.ConnectionErrors; } });
Object.defineProperty(exports, "ConnectionError", { enumerable: true, get: function () { return connection.ConnectionError; } });
Object.defineProperty(exports, "CancellationReceiverStrategy", { enumerable: true, get: function () { return connection.CancellationReceiverStrategy; } });
Object.defineProperty(exports, "CancellationSenderStrategy", { enumerable: true, get: function () { return connection.CancellationSenderStrategy; } });
Object.defineProperty(exports, "CancellationStrategy", { enumerable: true, get: function () { return connection.CancellationStrategy; } });

exports.RAL = ral.default;

});

var main = createCommonjsModule(function (module, exports) {
var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (commonjsGlobal && commonjsGlobal.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMessageConnection = exports.createServerSocketTransport = exports.createClientSocketTransport = exports.createServerPipeTransport = exports.createClientPipeTransport = exports.generateRandomPipeName = exports.StreamMessageWriter = exports.StreamMessageReader = exports.SocketMessageWriter = exports.SocketMessageReader = exports.IPCMessageWriter = exports.IPCMessageReader = void 0;
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ----------------------------------------------------------------------------------------- */

// Install the node runtime abstract.
ril.default.install();





__exportStar(api, exports);
class IPCMessageReader extends api.AbstractMessageReader {
    constructor(process) {
        super();
        this.process = process;
        let eventEmitter = this.process;
        eventEmitter.on('error', (error) => this.fireError(error));
        eventEmitter.on('close', () => this.fireClose());
    }
    listen(callback) {
        this.process.on('message', callback);
        return api.Disposable.create(() => this.process.off('message', callback));
    }
}
exports.IPCMessageReader = IPCMessageReader;
class IPCMessageWriter extends api.AbstractMessageWriter {
    constructor(process) {
        super();
        this.process = process;
        this.errorCount = 0;
        let eventEmitter = this.process;
        eventEmitter.on('error', (error) => this.fireError(error));
        eventEmitter.on('close', () => this.fireClose);
    }
    write(msg) {
        try {
            if (typeof this.process.send === 'function') {
                this.process.send(msg, undefined, undefined, (error) => {
                    if (error) {
                        this.errorCount++;
                        this.handleError(error, msg);
                    }
                    else {
                        this.errorCount = 0;
                    }
                });
            }
            return Promise.resolve();
        }
        catch (error) {
            this.handleError(error, msg);
            return Promise.reject(error);
        }
    }
    handleError(error, msg) {
        this.errorCount++;
        this.fireError(error, msg, this.errorCount);
    }
    end() {
    }
}
exports.IPCMessageWriter = IPCMessageWriter;
class SocketMessageReader extends api.ReadableStreamMessageReader {
    constructor(socket, encoding = 'utf-8') {
        super(ril.default().stream.asReadableStream(socket), encoding);
    }
}
exports.SocketMessageReader = SocketMessageReader;
class SocketMessageWriter extends api.WriteableStreamMessageWriter {
    constructor(socket, options) {
        super(ril.default().stream.asWritableStream(socket), options);
        this.socket = socket;
    }
    dispose() {
        super.dispose();
        this.socket.destroy();
    }
}
exports.SocketMessageWriter = SocketMessageWriter;
class StreamMessageReader extends api.ReadableStreamMessageReader {
    constructor(readble, encoding) {
        super(ril.default().stream.asReadableStream(readble), encoding);
    }
}
exports.StreamMessageReader = StreamMessageReader;
class StreamMessageWriter extends api.WriteableStreamMessageWriter {
    constructor(writable, options) {
        super(ril.default().stream.asWritableStream(writable), options);
    }
}
exports.StreamMessageWriter = StreamMessageWriter;
const XDG_RUNTIME_DIR = process.env['XDG_RUNTIME_DIR'];
const safeIpcPathLengths = new Map([
    ['linux', 107],
    ['darwin', 103]
]);
function generateRandomPipeName() {
    const randomSuffix = crypto_1__default['default'].randomBytes(21).toString('hex');
    if (process.platform === 'win32') {
        return `\\\\.\\pipe\\vscode-jsonrpc-${randomSuffix}-sock`;
    }
    let result;
    if (XDG_RUNTIME_DIR) {
        result = path__default['default'].join(XDG_RUNTIME_DIR, `vscode-ipc-${randomSuffix}.sock`);
    }
    else {
        result = path__default['default'].join(os__default['default'].tmpdir(), `vscode-${randomSuffix}.sock`);
    }
    const limit = safeIpcPathLengths.get(process.platform);
    if (limit !== undefined && result.length >= limit) {
        ril.default().console.warn(`WARNING: IPC handle "${result}" is longer than ${limit} characters.`);
    }
    return result;
}
exports.generateRandomPipeName = generateRandomPipeName;
function createClientPipeTransport(pipeName, encoding = 'utf-8') {
    let connectResolve;
    const connected = new Promise((resolve, _reject) => {
        connectResolve = resolve;
    });
    return new Promise((resolve, reject) => {
        let server = net_1__default['default'].createServer((socket) => {
            server.close();
            connectResolve([
                new SocketMessageReader(socket, encoding),
                new SocketMessageWriter(socket, encoding)
            ]);
        });
        server.on('error', reject);
        server.listen(pipeName, () => {
            server.removeListener('error', reject);
            resolve({
                onConnected: () => { return connected; }
            });
        });
    });
}
exports.createClientPipeTransport = createClientPipeTransport;
function createServerPipeTransport(pipeName, encoding = 'utf-8') {
    const socket = net_1__default['default'].createConnection(pipeName);
    return [
        new SocketMessageReader(socket, encoding),
        new SocketMessageWriter(socket, encoding)
    ];
}
exports.createServerPipeTransport = createServerPipeTransport;
function createClientSocketTransport(port, encoding = 'utf-8') {
    let connectResolve;
    const connected = new Promise((resolve, _reject) => {
        connectResolve = resolve;
    });
    return new Promise((resolve, reject) => {
        const server = net_1__default['default'].createServer((socket) => {
            server.close();
            connectResolve([
                new SocketMessageReader(socket, encoding),
                new SocketMessageWriter(socket, encoding)
            ]);
        });
        server.on('error', reject);
        server.listen(port, '127.0.0.1', () => {
            server.removeListener('error', reject);
            resolve({
                onConnected: () => { return connected; }
            });
        });
    });
}
exports.createClientSocketTransport = createClientSocketTransport;
function createServerSocketTransport(port, encoding = 'utf-8') {
    const socket = net_1__default['default'].createConnection(port, '127.0.0.1');
    return [
        new SocketMessageReader(socket, encoding),
        new SocketMessageWriter(socket, encoding)
    ];
}
exports.createServerSocketTransport = createServerSocketTransport;
function isReadableStream(value) {
    const candidate = value;
    return candidate.read !== undefined && candidate.addListener !== undefined;
}
function isWritableStream(value) {
    const candidate = value;
    return candidate.write !== undefined && candidate.addListener !== undefined;
}
function createMessageConnection(input, output, logger, options) {
    if (!logger) {
        logger = api.NullLogger;
    }
    const reader = isReadableStream(input) ? new StreamMessageReader(input) : input;
    const writer = isWritableStream(output) ? new StreamMessageWriter(output) : output;
    if (api.ConnectionStrategy.is(options)) {
        options = { connectionStrategy: options };
    }
    return api.createMessageConnection(reader, writer, logger, options);
}
exports.createMessageConnection = createMessageConnection;

});

/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ----------------------------------------------------------------------------------------- */

var node = main;

/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
var integer;
(function (integer) {
    integer.MIN_VALUE = -2147483648;
    integer.MAX_VALUE = 2147483647;
})(integer || (integer = {}));
var uinteger;
(function (uinteger) {
    uinteger.MIN_VALUE = 0;
    uinteger.MAX_VALUE = 2147483647;
})(uinteger || (uinteger = {}));
/**
 * The Position namespace provides helper functions to work with
 * [Position](#Position) literals.
 */
var Position;
(function (Position) {
    /**
     * Creates a new Position literal from the given line and character.
     * @param line The position's line.
     * @param character The position's character.
     */
    function create(line, character) {
        if (line === Number.MAX_VALUE) {
            line = uinteger.MAX_VALUE;
        }
        if (character === Number.MAX_VALUE) {
            character = uinteger.MAX_VALUE;
        }
        return { line: line, character: character };
    }
    Position.create = create;
    /**
     * Checks whether the given literal conforms to the [Position](#Position) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.objectLiteral(candidate) && Is.uinteger(candidate.line) && Is.uinteger(candidate.character);
    }
    Position.is = is;
})(Position || (Position = {}));
/**
 * The Range namespace provides helper functions to work with
 * [Range](#Range) literals.
 */
var Range;
(function (Range) {
    function create(one, two, three, four) {
        if (Is.uinteger(one) && Is.uinteger(two) && Is.uinteger(three) && Is.uinteger(four)) {
            return { start: Position.create(one, two), end: Position.create(three, four) };
        }
        else if (Position.is(one) && Position.is(two)) {
            return { start: one, end: two };
        }
        else {
            throw new Error("Range#create called with invalid arguments[" + one + ", " + two + ", " + three + ", " + four + "]");
        }
    }
    Range.create = create;
    /**
     * Checks whether the given literal conforms to the [Range](#Range) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.objectLiteral(candidate) && Position.is(candidate.start) && Position.is(candidate.end);
    }
    Range.is = is;
})(Range || (Range = {}));
/**
 * The Location namespace provides helper functions to work with
 * [Location](#Location) literals.
 */
var Location;
(function (Location) {
    /**
     * Creates a Location literal.
     * @param uri The location's uri.
     * @param range The location's range.
     */
    function create(uri, range) {
        return { uri: uri, range: range };
    }
    Location.create = create;
    /**
     * Checks whether the given literal conforms to the [Location](#Location) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.defined(candidate) && Range.is(candidate.range) && (Is.string(candidate.uri) || Is.undefined(candidate.uri));
    }
    Location.is = is;
})(Location || (Location = {}));
/**
 * The LocationLink namespace provides helper functions to work with
 * [LocationLink](#LocationLink) literals.
 */
var LocationLink;
(function (LocationLink) {
    /**
     * Creates a LocationLink literal.
     * @param targetUri The definition's uri.
     * @param targetRange The full range of the definition.
     * @param targetSelectionRange The span of the symbol definition at the target.
     * @param originSelectionRange The span of the symbol being defined in the originating source file.
     */
    function create(targetUri, targetRange, targetSelectionRange, originSelectionRange) {
        return { targetUri: targetUri, targetRange: targetRange, targetSelectionRange: targetSelectionRange, originSelectionRange: originSelectionRange };
    }
    LocationLink.create = create;
    /**
     * Checks whether the given literal conforms to the [LocationLink](#LocationLink) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.defined(candidate) && Range.is(candidate.targetRange) && Is.string(candidate.targetUri)
            && (Range.is(candidate.targetSelectionRange) || Is.undefined(candidate.targetSelectionRange))
            && (Range.is(candidate.originSelectionRange) || Is.undefined(candidate.originSelectionRange));
    }
    LocationLink.is = is;
})(LocationLink || (LocationLink = {}));
/**
 * The Color namespace provides helper functions to work with
 * [Color](#Color) literals.
 */
var Color;
(function (Color) {
    /**
     * Creates a new Color literal.
     */
    function create(red, green, blue, alpha) {
        return {
            red: red,
            green: green,
            blue: blue,
            alpha: alpha,
        };
    }
    Color.create = create;
    /**
     * Checks whether the given literal conforms to the [Color](#Color) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.numberRange(candidate.red, 0, 1)
            && Is.numberRange(candidate.green, 0, 1)
            && Is.numberRange(candidate.blue, 0, 1)
            && Is.numberRange(candidate.alpha, 0, 1);
    }
    Color.is = is;
})(Color || (Color = {}));
/**
 * The ColorInformation namespace provides helper functions to work with
 * [ColorInformation](#ColorInformation) literals.
 */
var ColorInformation;
(function (ColorInformation) {
    /**
     * Creates a new ColorInformation literal.
     */
    function create(range, color) {
        return {
            range: range,
            color: color,
        };
    }
    ColorInformation.create = create;
    /**
     * Checks whether the given literal conforms to the [ColorInformation](#ColorInformation) interface.
     */
    function is(value) {
        var candidate = value;
        return Range.is(candidate.range) && Color.is(candidate.color);
    }
    ColorInformation.is = is;
})(ColorInformation || (ColorInformation = {}));
/**
 * The Color namespace provides helper functions to work with
 * [ColorPresentation](#ColorPresentation) literals.
 */
var ColorPresentation;
(function (ColorPresentation) {
    /**
     * Creates a new ColorInformation literal.
     */
    function create(label, textEdit, additionalTextEdits) {
        return {
            label: label,
            textEdit: textEdit,
            additionalTextEdits: additionalTextEdits,
        };
    }
    ColorPresentation.create = create;
    /**
     * Checks whether the given literal conforms to the [ColorInformation](#ColorInformation) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.string(candidate.label)
            && (Is.undefined(candidate.textEdit) || TextEdit.is(candidate))
            && (Is.undefined(candidate.additionalTextEdits) || Is.typedArray(candidate.additionalTextEdits, TextEdit.is));
    }
    ColorPresentation.is = is;
})(ColorPresentation || (ColorPresentation = {}));
/**
 * Enum of known range kinds
 */
var FoldingRangeKind;
(function (FoldingRangeKind) {
    /**
     * Folding range for a comment
     */
    FoldingRangeKind["Comment"] = "comment";
    /**
     * Folding range for a imports or includes
     */
    FoldingRangeKind["Imports"] = "imports";
    /**
     * Folding range for a region (e.g. `#region`)
     */
    FoldingRangeKind["Region"] = "region";
})(FoldingRangeKind || (FoldingRangeKind = {}));
/**
 * The folding range namespace provides helper functions to work with
 * [FoldingRange](#FoldingRange) literals.
 */
var FoldingRange;
(function (FoldingRange) {
    /**
     * Creates a new FoldingRange literal.
     */
    function create(startLine, endLine, startCharacter, endCharacter, kind) {
        var result = {
            startLine: startLine,
            endLine: endLine
        };
        if (Is.defined(startCharacter)) {
            result.startCharacter = startCharacter;
        }
        if (Is.defined(endCharacter)) {
            result.endCharacter = endCharacter;
        }
        if (Is.defined(kind)) {
            result.kind = kind;
        }
        return result;
    }
    FoldingRange.create = create;
    /**
     * Checks whether the given literal conforms to the [FoldingRange](#FoldingRange) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.uinteger(candidate.startLine) && Is.uinteger(candidate.startLine)
            && (Is.undefined(candidate.startCharacter) || Is.uinteger(candidate.startCharacter))
            && (Is.undefined(candidate.endCharacter) || Is.uinteger(candidate.endCharacter))
            && (Is.undefined(candidate.kind) || Is.string(candidate.kind));
    }
    FoldingRange.is = is;
})(FoldingRange || (FoldingRange = {}));
/**
 * The DiagnosticRelatedInformation namespace provides helper functions to work with
 * [DiagnosticRelatedInformation](#DiagnosticRelatedInformation) literals.
 */
var DiagnosticRelatedInformation;
(function (DiagnosticRelatedInformation) {
    /**
     * Creates a new DiagnosticRelatedInformation literal.
     */
    function create(location, message) {
        return {
            location: location,
            message: message
        };
    }
    DiagnosticRelatedInformation.create = create;
    /**
     * Checks whether the given literal conforms to the [DiagnosticRelatedInformation](#DiagnosticRelatedInformation) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.defined(candidate) && Location.is(candidate.location) && Is.string(candidate.message);
    }
    DiagnosticRelatedInformation.is = is;
})(DiagnosticRelatedInformation || (DiagnosticRelatedInformation = {}));
/**
 * The diagnostic's severity.
 */
var DiagnosticSeverity;
(function (DiagnosticSeverity) {
    /**
     * Reports an error.
     */
    DiagnosticSeverity.Error = 1;
    /**
     * Reports a warning.
     */
    DiagnosticSeverity.Warning = 2;
    /**
     * Reports an information.
     */
    DiagnosticSeverity.Information = 3;
    /**
     * Reports a hint.
     */
    DiagnosticSeverity.Hint = 4;
})(DiagnosticSeverity || (DiagnosticSeverity = {}));
/**
 * The diagnostic tags.
 *
 * @since 3.15.0
 */
var DiagnosticTag;
(function (DiagnosticTag) {
    /**
     * Unused or unnecessary code.
     *
     * Clients are allowed to render diagnostics with this tag faded out instead of having
     * an error squiggle.
     */
    DiagnosticTag.Unnecessary = 1;
    /**
     * Deprecated or obsolete code.
     *
     * Clients are allowed to rendered diagnostics with this tag strike through.
     */
    DiagnosticTag.Deprecated = 2;
})(DiagnosticTag || (DiagnosticTag = {}));
/**
 * The CodeDescription namespace provides functions to deal with descriptions for diagnostic codes.
 *
 * @since 3.16.0
 */
var CodeDescription;
(function (CodeDescription) {
    function is(value) {
        var candidate = value;
        return candidate !== undefined && candidate !== null && Is.string(candidate.href);
    }
    CodeDescription.is = is;
})(CodeDescription || (CodeDescription = {}));
/**
 * The Diagnostic namespace provides helper functions to work with
 * [Diagnostic](#Diagnostic) literals.
 */
var Diagnostic;
(function (Diagnostic) {
    /**
     * Creates a new Diagnostic literal.
     */
    function create(range, message, severity, code, source, relatedInformation) {
        var result = { range: range, message: message };
        if (Is.defined(severity)) {
            result.severity = severity;
        }
        if (Is.defined(code)) {
            result.code = code;
        }
        if (Is.defined(source)) {
            result.source = source;
        }
        if (Is.defined(relatedInformation)) {
            result.relatedInformation = relatedInformation;
        }
        return result;
    }
    Diagnostic.create = create;
    /**
     * Checks whether the given literal conforms to the [Diagnostic](#Diagnostic) interface.
     */
    function is(value) {
        var _a;
        var candidate = value;
        return Is.defined(candidate)
            && Range.is(candidate.range)
            && Is.string(candidate.message)
            && (Is.number(candidate.severity) || Is.undefined(candidate.severity))
            && (Is.integer(candidate.code) || Is.string(candidate.code) || Is.undefined(candidate.code))
            && (Is.undefined(candidate.codeDescription) || (Is.string((_a = candidate.codeDescription) === null || _a === void 0 ? void 0 : _a.href)))
            && (Is.string(candidate.source) || Is.undefined(candidate.source))
            && (Is.undefined(candidate.relatedInformation) || Is.typedArray(candidate.relatedInformation, DiagnosticRelatedInformation.is));
    }
    Diagnostic.is = is;
})(Diagnostic || (Diagnostic = {}));
/**
 * The Command namespace provides helper functions to work with
 * [Command](#Command) literals.
 */
var Command;
(function (Command) {
    /**
     * Creates a new Command literal.
     */
    function create(title, command) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        var result = { title: title, command: command };
        if (Is.defined(args) && args.length > 0) {
            result.arguments = args;
        }
        return result;
    }
    Command.create = create;
    /**
     * Checks whether the given literal conforms to the [Command](#Command) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.defined(candidate) && Is.string(candidate.title) && Is.string(candidate.command);
    }
    Command.is = is;
})(Command || (Command = {}));
/**
 * The TextEdit namespace provides helper function to create replace,
 * insert and delete edits more easily.
 */
var TextEdit;
(function (TextEdit) {
    /**
     * Creates a replace text edit.
     * @param range The range of text to be replaced.
     * @param newText The new text.
     */
    function replace(range, newText) {
        return { range: range, newText: newText };
    }
    TextEdit.replace = replace;
    /**
     * Creates a insert text edit.
     * @param position The position to insert the text at.
     * @param newText The text to be inserted.
     */
    function insert(position, newText) {
        return { range: { start: position, end: position }, newText: newText };
    }
    TextEdit.insert = insert;
    /**
     * Creates a delete text edit.
     * @param range The range of text to be deleted.
     */
    function del(range) {
        return { range: range, newText: '' };
    }
    TextEdit.del = del;
    function is(value) {
        var candidate = value;
        return Is.objectLiteral(candidate)
            && Is.string(candidate.newText)
            && Range.is(candidate.range);
    }
    TextEdit.is = is;
})(TextEdit || (TextEdit = {}));
var ChangeAnnotation;
(function (ChangeAnnotation) {
    function create(label, needsConfirmation, description) {
        var result = { label: label };
        if (needsConfirmation !== undefined) {
            result.needsConfirmation = needsConfirmation;
        }
        if (description !== undefined) {
            result.description = description;
        }
        return result;
    }
    ChangeAnnotation.create = create;
    function is(value) {
        var candidate = value;
        return candidate !== undefined && Is.objectLiteral(candidate) && Is.string(candidate.label) &&
            (Is.boolean(candidate.needsConfirmation) || candidate.needsConfirmation === undefined) &&
            (Is.string(candidate.description) || candidate.description === undefined);
    }
    ChangeAnnotation.is = is;
})(ChangeAnnotation || (ChangeAnnotation = {}));
var ChangeAnnotationIdentifier;
(function (ChangeAnnotationIdentifier) {
    function is(value) {
        var candidate = value;
        return typeof candidate === 'string';
    }
    ChangeAnnotationIdentifier.is = is;
})(ChangeAnnotationIdentifier || (ChangeAnnotationIdentifier = {}));
var AnnotatedTextEdit;
(function (AnnotatedTextEdit) {
    /**
     * Creates an annotated replace text edit.
     *
     * @param range The range of text to be replaced.
     * @param newText The new text.
     * @param annotation The annotation.
     */
    function replace(range, newText, annotation) {
        return { range: range, newText: newText, annotationId: annotation };
    }
    AnnotatedTextEdit.replace = replace;
    /**
     * Creates an annotated insert text edit.
     *
     * @param position The position to insert the text at.
     * @param newText The text to be inserted.
     * @param annotation The annotation.
     */
    function insert(position, newText, annotation) {
        return { range: { start: position, end: position }, newText: newText, annotationId: annotation };
    }
    AnnotatedTextEdit.insert = insert;
    /**
     * Creates an annotated delete text edit.
     *
     * @param range The range of text to be deleted.
     * @param annotation The annotation.
     */
    function del(range, annotation) {
        return { range: range, newText: '', annotationId: annotation };
    }
    AnnotatedTextEdit.del = del;
    function is(value) {
        var candidate = value;
        return TextEdit.is(candidate) && (ChangeAnnotation.is(candidate.annotationId) || ChangeAnnotationIdentifier.is(candidate.annotationId));
    }
    AnnotatedTextEdit.is = is;
})(AnnotatedTextEdit || (AnnotatedTextEdit = {}));
/**
 * The TextDocumentEdit namespace provides helper function to create
 * an edit that manipulates a text document.
 */
var TextDocumentEdit;
(function (TextDocumentEdit) {
    /**
     * Creates a new `TextDocumentEdit`
     */
    function create(textDocument, edits) {
        return { textDocument: textDocument, edits: edits };
    }
    TextDocumentEdit.create = create;
    function is(value) {
        var candidate = value;
        return Is.defined(candidate)
            && OptionalVersionedTextDocumentIdentifier.is(candidate.textDocument)
            && Array.isArray(candidate.edits);
    }
    TextDocumentEdit.is = is;
})(TextDocumentEdit || (TextDocumentEdit = {}));
var CreateFile;
(function (CreateFile) {
    function create(uri, options, annotation) {
        var result = {
            kind: 'create',
            uri: uri
        };
        if (options !== undefined && (options.overwrite !== undefined || options.ignoreIfExists !== undefined)) {
            result.options = options;
        }
        if (annotation !== undefined) {
            result.annotationId = annotation;
        }
        return result;
    }
    CreateFile.create = create;
    function is(value) {
        var candidate = value;
        return candidate && candidate.kind === 'create' && Is.string(candidate.uri) && (candidate.options === undefined ||
            ((candidate.options.overwrite === undefined || Is.boolean(candidate.options.overwrite)) && (candidate.options.ignoreIfExists === undefined || Is.boolean(candidate.options.ignoreIfExists)))) && (candidate.annotationId === undefined || ChangeAnnotationIdentifier.is(candidate.annotationId));
    }
    CreateFile.is = is;
})(CreateFile || (CreateFile = {}));
var RenameFile;
(function (RenameFile) {
    function create(oldUri, newUri, options, annotation) {
        var result = {
            kind: 'rename',
            oldUri: oldUri,
            newUri: newUri
        };
        if (options !== undefined && (options.overwrite !== undefined || options.ignoreIfExists !== undefined)) {
            result.options = options;
        }
        if (annotation !== undefined) {
            result.annotationId = annotation;
        }
        return result;
    }
    RenameFile.create = create;
    function is(value) {
        var candidate = value;
        return candidate && candidate.kind === 'rename' && Is.string(candidate.oldUri) && Is.string(candidate.newUri) && (candidate.options === undefined ||
            ((candidate.options.overwrite === undefined || Is.boolean(candidate.options.overwrite)) && (candidate.options.ignoreIfExists === undefined || Is.boolean(candidate.options.ignoreIfExists)))) && (candidate.annotationId === undefined || ChangeAnnotationIdentifier.is(candidate.annotationId));
    }
    RenameFile.is = is;
})(RenameFile || (RenameFile = {}));
var DeleteFile;
(function (DeleteFile) {
    function create(uri, options, annotation) {
        var result = {
            kind: 'delete',
            uri: uri
        };
        if (options !== undefined && (options.recursive !== undefined || options.ignoreIfNotExists !== undefined)) {
            result.options = options;
        }
        if (annotation !== undefined) {
            result.annotationId = annotation;
        }
        return result;
    }
    DeleteFile.create = create;
    function is(value) {
        var candidate = value;
        return candidate && candidate.kind === 'delete' && Is.string(candidate.uri) && (candidate.options === undefined ||
            ((candidate.options.recursive === undefined || Is.boolean(candidate.options.recursive)) && (candidate.options.ignoreIfNotExists === undefined || Is.boolean(candidate.options.ignoreIfNotExists)))) && (candidate.annotationId === undefined || ChangeAnnotationIdentifier.is(candidate.annotationId));
    }
    DeleteFile.is = is;
})(DeleteFile || (DeleteFile = {}));
var WorkspaceEdit;
(function (WorkspaceEdit) {
    function is(value) {
        var candidate = value;
        return candidate &&
            (candidate.changes !== undefined || candidate.documentChanges !== undefined) &&
            (candidate.documentChanges === undefined || candidate.documentChanges.every(function (change) {
                if (Is.string(change.kind)) {
                    return CreateFile.is(change) || RenameFile.is(change) || DeleteFile.is(change);
                }
                else {
                    return TextDocumentEdit.is(change);
                }
            }));
    }
    WorkspaceEdit.is = is;
})(WorkspaceEdit || (WorkspaceEdit = {}));
var TextEditChangeImpl = /** @class */ (function () {
    function TextEditChangeImpl(edits, changeAnnotations) {
        this.edits = edits;
        this.changeAnnotations = changeAnnotations;
    }
    TextEditChangeImpl.prototype.insert = function (position, newText, annotation) {
        var edit;
        var id;
        if (annotation === undefined) {
            edit = TextEdit.insert(position, newText);
        }
        else if (ChangeAnnotationIdentifier.is(annotation)) {
            id = annotation;
            edit = AnnotatedTextEdit.insert(position, newText, annotation);
        }
        else {
            this.assertChangeAnnotations(this.changeAnnotations);
            id = this.changeAnnotations.manage(annotation);
            edit = AnnotatedTextEdit.insert(position, newText, id);
        }
        this.edits.push(edit);
        if (id !== undefined) {
            return id;
        }
    };
    TextEditChangeImpl.prototype.replace = function (range, newText, annotation) {
        var edit;
        var id;
        if (annotation === undefined) {
            edit = TextEdit.replace(range, newText);
        }
        else if (ChangeAnnotationIdentifier.is(annotation)) {
            id = annotation;
            edit = AnnotatedTextEdit.replace(range, newText, annotation);
        }
        else {
            this.assertChangeAnnotations(this.changeAnnotations);
            id = this.changeAnnotations.manage(annotation);
            edit = AnnotatedTextEdit.replace(range, newText, id);
        }
        this.edits.push(edit);
        if (id !== undefined) {
            return id;
        }
    };
    TextEditChangeImpl.prototype.delete = function (range, annotation) {
        var edit;
        var id;
        if (annotation === undefined) {
            edit = TextEdit.del(range);
        }
        else if (ChangeAnnotationIdentifier.is(annotation)) {
            id = annotation;
            edit = AnnotatedTextEdit.del(range, annotation);
        }
        else {
            this.assertChangeAnnotations(this.changeAnnotations);
            id = this.changeAnnotations.manage(annotation);
            edit = AnnotatedTextEdit.del(range, id);
        }
        this.edits.push(edit);
        if (id !== undefined) {
            return id;
        }
    };
    TextEditChangeImpl.prototype.add = function (edit) {
        this.edits.push(edit);
    };
    TextEditChangeImpl.prototype.all = function () {
        return this.edits;
    };
    TextEditChangeImpl.prototype.clear = function () {
        this.edits.splice(0, this.edits.length);
    };
    TextEditChangeImpl.prototype.assertChangeAnnotations = function (value) {
        if (value === undefined) {
            throw new Error("Text edit change is not configured to manage change annotations.");
        }
    };
    return TextEditChangeImpl;
}());
/**
 * A helper class
 */
var ChangeAnnotations = /** @class */ (function () {
    function ChangeAnnotations(annotations) {
        this._annotations = annotations === undefined ? Object.create(null) : annotations;
        this._counter = 0;
        this._size = 0;
    }
    ChangeAnnotations.prototype.all = function () {
        return this._annotations;
    };
    Object.defineProperty(ChangeAnnotations.prototype, "size", {
        get: function () {
            return this._size;
        },
        enumerable: false,
        configurable: true
    });
    ChangeAnnotations.prototype.manage = function (idOrAnnotation, annotation) {
        var id;
        if (ChangeAnnotationIdentifier.is(idOrAnnotation)) {
            id = idOrAnnotation;
        }
        else {
            id = this.nextId();
            annotation = idOrAnnotation;
        }
        if (this._annotations[id] !== undefined) {
            throw new Error("Id " + id + " is already in use.");
        }
        if (annotation === undefined) {
            throw new Error("No annotation provided for id " + id);
        }
        this._annotations[id] = annotation;
        this._size++;
        return id;
    };
    ChangeAnnotations.prototype.nextId = function () {
        this._counter++;
        return this._counter.toString();
    };
    return ChangeAnnotations;
}());
/**
 * A workspace change helps constructing changes to a workspace.
 */
var WorkspaceChange = /** @class */ (function () {
    function WorkspaceChange(workspaceEdit) {
        var _this = this;
        this._textEditChanges = Object.create(null);
        if (workspaceEdit !== undefined) {
            this._workspaceEdit = workspaceEdit;
            if (workspaceEdit.documentChanges) {
                this._changeAnnotations = new ChangeAnnotations(workspaceEdit.changeAnnotations);
                workspaceEdit.changeAnnotations = this._changeAnnotations.all();
                workspaceEdit.documentChanges.forEach(function (change) {
                    if (TextDocumentEdit.is(change)) {
                        var textEditChange = new TextEditChangeImpl(change.edits, _this._changeAnnotations);
                        _this._textEditChanges[change.textDocument.uri] = textEditChange;
                    }
                });
            }
            else if (workspaceEdit.changes) {
                Object.keys(workspaceEdit.changes).forEach(function (key) {
                    var textEditChange = new TextEditChangeImpl(workspaceEdit.changes[key]);
                    _this._textEditChanges[key] = textEditChange;
                });
            }
        }
        else {
            this._workspaceEdit = {};
        }
    }
    Object.defineProperty(WorkspaceChange.prototype, "edit", {
        /**
         * Returns the underlying [WorkspaceEdit](#WorkspaceEdit) literal
         * use to be returned from a workspace edit operation like rename.
         */
        get: function () {
            this.initDocumentChanges();
            if (this._changeAnnotations !== undefined) {
                if (this._changeAnnotations.size === 0) {
                    this._workspaceEdit.changeAnnotations = undefined;
                }
                else {
                    this._workspaceEdit.changeAnnotations = this._changeAnnotations.all();
                }
            }
            return this._workspaceEdit;
        },
        enumerable: false,
        configurable: true
    });
    WorkspaceChange.prototype.getTextEditChange = function (key) {
        if (OptionalVersionedTextDocumentIdentifier.is(key)) {
            this.initDocumentChanges();
            if (this._workspaceEdit.documentChanges === undefined) {
                throw new Error('Workspace edit is not configured for document changes.');
            }
            var textDocument = { uri: key.uri, version: key.version };
            var result = this._textEditChanges[textDocument.uri];
            if (!result) {
                var edits = [];
                var textDocumentEdit = {
                    textDocument: textDocument,
                    edits: edits
                };
                this._workspaceEdit.documentChanges.push(textDocumentEdit);
                result = new TextEditChangeImpl(edits, this._changeAnnotations);
                this._textEditChanges[textDocument.uri] = result;
            }
            return result;
        }
        else {
            this.initChanges();
            if (this._workspaceEdit.changes === undefined) {
                throw new Error('Workspace edit is not configured for normal text edit changes.');
            }
            var result = this._textEditChanges[key];
            if (!result) {
                var edits = [];
                this._workspaceEdit.changes[key] = edits;
                result = new TextEditChangeImpl(edits);
                this._textEditChanges[key] = result;
            }
            return result;
        }
    };
    WorkspaceChange.prototype.initDocumentChanges = function () {
        if (this._workspaceEdit.documentChanges === undefined && this._workspaceEdit.changes === undefined) {
            this._changeAnnotations = new ChangeAnnotations();
            this._workspaceEdit.documentChanges = [];
            this._workspaceEdit.changeAnnotations = this._changeAnnotations.all();
        }
    };
    WorkspaceChange.prototype.initChanges = function () {
        if (this._workspaceEdit.documentChanges === undefined && this._workspaceEdit.changes === undefined) {
            this._workspaceEdit.changes = Object.create(null);
        }
    };
    WorkspaceChange.prototype.createFile = function (uri, optionsOrAnnotation, options) {
        this.initDocumentChanges();
        if (this._workspaceEdit.documentChanges === undefined) {
            throw new Error('Workspace edit is not configured for document changes.');
        }
        var annotation;
        if (ChangeAnnotation.is(optionsOrAnnotation) || ChangeAnnotationIdentifier.is(optionsOrAnnotation)) {
            annotation = optionsOrAnnotation;
        }
        else {
            options = optionsOrAnnotation;
        }
        var operation;
        var id;
        if (annotation === undefined) {
            operation = CreateFile.create(uri, options);
        }
        else {
            id = ChangeAnnotationIdentifier.is(annotation) ? annotation : this._changeAnnotations.manage(annotation);
            operation = CreateFile.create(uri, options, id);
        }
        this._workspaceEdit.documentChanges.push(operation);
        if (id !== undefined) {
            return id;
        }
    };
    WorkspaceChange.prototype.renameFile = function (oldUri, newUri, optionsOrAnnotation, options) {
        this.initDocumentChanges();
        if (this._workspaceEdit.documentChanges === undefined) {
            throw new Error('Workspace edit is not configured for document changes.');
        }
        var annotation;
        if (ChangeAnnotation.is(optionsOrAnnotation) || ChangeAnnotationIdentifier.is(optionsOrAnnotation)) {
            annotation = optionsOrAnnotation;
        }
        else {
            options = optionsOrAnnotation;
        }
        var operation;
        var id;
        if (annotation === undefined) {
            operation = RenameFile.create(oldUri, newUri, options);
        }
        else {
            id = ChangeAnnotationIdentifier.is(annotation) ? annotation : this._changeAnnotations.manage(annotation);
            operation = RenameFile.create(oldUri, newUri, options, id);
        }
        this._workspaceEdit.documentChanges.push(operation);
        if (id !== undefined) {
            return id;
        }
    };
    WorkspaceChange.prototype.deleteFile = function (uri, optionsOrAnnotation, options) {
        this.initDocumentChanges();
        if (this._workspaceEdit.documentChanges === undefined) {
            throw new Error('Workspace edit is not configured for document changes.');
        }
        var annotation;
        if (ChangeAnnotation.is(optionsOrAnnotation) || ChangeAnnotationIdentifier.is(optionsOrAnnotation)) {
            annotation = optionsOrAnnotation;
        }
        else {
            options = optionsOrAnnotation;
        }
        var operation;
        var id;
        if (annotation === undefined) {
            operation = DeleteFile.create(uri, options);
        }
        else {
            id = ChangeAnnotationIdentifier.is(annotation) ? annotation : this._changeAnnotations.manage(annotation);
            operation = DeleteFile.create(uri, options, id);
        }
        this._workspaceEdit.documentChanges.push(operation);
        if (id !== undefined) {
            return id;
        }
    };
    return WorkspaceChange;
}());
/**
 * The TextDocumentIdentifier namespace provides helper functions to work with
 * [TextDocumentIdentifier](#TextDocumentIdentifier) literals.
 */
var TextDocumentIdentifier;
(function (TextDocumentIdentifier) {
    /**
     * Creates a new TextDocumentIdentifier literal.
     * @param uri The document's uri.
     */
    function create(uri) {
        return { uri: uri };
    }
    TextDocumentIdentifier.create = create;
    /**
     * Checks whether the given literal conforms to the [TextDocumentIdentifier](#TextDocumentIdentifier) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.defined(candidate) && Is.string(candidate.uri);
    }
    TextDocumentIdentifier.is = is;
})(TextDocumentIdentifier || (TextDocumentIdentifier = {}));
/**
 * The VersionedTextDocumentIdentifier namespace provides helper functions to work with
 * [VersionedTextDocumentIdentifier](#VersionedTextDocumentIdentifier) literals.
 */
var VersionedTextDocumentIdentifier;
(function (VersionedTextDocumentIdentifier) {
    /**
     * Creates a new VersionedTextDocumentIdentifier literal.
     * @param uri The document's uri.
     * @param uri The document's text.
     */
    function create(uri, version) {
        return { uri: uri, version: version };
    }
    VersionedTextDocumentIdentifier.create = create;
    /**
     * Checks whether the given literal conforms to the [VersionedTextDocumentIdentifier](#VersionedTextDocumentIdentifier) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.defined(candidate) && Is.string(candidate.uri) && Is.integer(candidate.version);
    }
    VersionedTextDocumentIdentifier.is = is;
})(VersionedTextDocumentIdentifier || (VersionedTextDocumentIdentifier = {}));
/**
 * The OptionalVersionedTextDocumentIdentifier namespace provides helper functions to work with
 * [OptionalVersionedTextDocumentIdentifier](#OptionalVersionedTextDocumentIdentifier) literals.
 */
var OptionalVersionedTextDocumentIdentifier;
(function (OptionalVersionedTextDocumentIdentifier) {
    /**
     * Creates a new OptionalVersionedTextDocumentIdentifier literal.
     * @param uri The document's uri.
     * @param uri The document's text.
     */
    function create(uri, version) {
        return { uri: uri, version: version };
    }
    OptionalVersionedTextDocumentIdentifier.create = create;
    /**
     * Checks whether the given literal conforms to the [OptionalVersionedTextDocumentIdentifier](#OptionalVersionedTextDocumentIdentifier) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.defined(candidate) && Is.string(candidate.uri) && (candidate.version === null || Is.integer(candidate.version));
    }
    OptionalVersionedTextDocumentIdentifier.is = is;
})(OptionalVersionedTextDocumentIdentifier || (OptionalVersionedTextDocumentIdentifier = {}));
/**
 * The TextDocumentItem namespace provides helper functions to work with
 * [TextDocumentItem](#TextDocumentItem) literals.
 */
var TextDocumentItem;
(function (TextDocumentItem) {
    /**
     * Creates a new TextDocumentItem literal.
     * @param uri The document's uri.
     * @param languageId The document's language identifier.
     * @param version The document's version number.
     * @param text The document's text.
     */
    function create(uri, languageId, version, text) {
        return { uri: uri, languageId: languageId, version: version, text: text };
    }
    TextDocumentItem.create = create;
    /**
     * Checks whether the given literal conforms to the [TextDocumentItem](#TextDocumentItem) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.defined(candidate) && Is.string(candidate.uri) && Is.string(candidate.languageId) && Is.integer(candidate.version) && Is.string(candidate.text);
    }
    TextDocumentItem.is = is;
})(TextDocumentItem || (TextDocumentItem = {}));
/**
 * Describes the content type that a client supports in various
 * result literals like `Hover`, `ParameterInfo` or `CompletionItem`.
 *
 * Please note that `MarkupKinds` must not start with a `$`. This kinds
 * are reserved for internal usage.
 */
var MarkupKind;
(function (MarkupKind) {
    /**
     * Plain text is supported as a content format
     */
    MarkupKind.PlainText = 'plaintext';
    /**
     * Markdown is supported as a content format
     */
    MarkupKind.Markdown = 'markdown';
})(MarkupKind || (MarkupKind = {}));
(function (MarkupKind) {
    /**
     * Checks whether the given value is a value of the [MarkupKind](#MarkupKind) type.
     */
    function is(value) {
        var candidate = value;
        return candidate === MarkupKind.PlainText || candidate === MarkupKind.Markdown;
    }
    MarkupKind.is = is;
})(MarkupKind || (MarkupKind = {}));
var MarkupContent;
(function (MarkupContent) {
    /**
     * Checks whether the given value conforms to the [MarkupContent](#MarkupContent) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.objectLiteral(value) && MarkupKind.is(candidate.kind) && Is.string(candidate.value);
    }
    MarkupContent.is = is;
})(MarkupContent || (MarkupContent = {}));
/**
 * The kind of a completion entry.
 */
var CompletionItemKind;
(function (CompletionItemKind) {
    CompletionItemKind.Text = 1;
    CompletionItemKind.Method = 2;
    CompletionItemKind.Function = 3;
    CompletionItemKind.Constructor = 4;
    CompletionItemKind.Field = 5;
    CompletionItemKind.Variable = 6;
    CompletionItemKind.Class = 7;
    CompletionItemKind.Interface = 8;
    CompletionItemKind.Module = 9;
    CompletionItemKind.Property = 10;
    CompletionItemKind.Unit = 11;
    CompletionItemKind.Value = 12;
    CompletionItemKind.Enum = 13;
    CompletionItemKind.Keyword = 14;
    CompletionItemKind.Snippet = 15;
    CompletionItemKind.Color = 16;
    CompletionItemKind.File = 17;
    CompletionItemKind.Reference = 18;
    CompletionItemKind.Folder = 19;
    CompletionItemKind.EnumMember = 20;
    CompletionItemKind.Constant = 21;
    CompletionItemKind.Struct = 22;
    CompletionItemKind.Event = 23;
    CompletionItemKind.Operator = 24;
    CompletionItemKind.TypeParameter = 25;
})(CompletionItemKind || (CompletionItemKind = {}));
/**
 * Defines whether the insert text in a completion item should be interpreted as
 * plain text or a snippet.
 */
var InsertTextFormat;
(function (InsertTextFormat) {
    /**
     * The primary text to be inserted is treated as a plain string.
     */
    InsertTextFormat.PlainText = 1;
    /**
     * The primary text to be inserted is treated as a snippet.
     *
     * A snippet can define tab stops and placeholders with `$1`, `$2`
     * and `${3:foo}`. `$0` defines the final tab stop, it defaults to
     * the end of the snippet. Placeholders with equal identifiers are linked,
     * that is typing in one will update others too.
     *
     * See also: https://microsoft.github.io/language-server-protocol/specifications/specification-current/#snippet_syntax
     */
    InsertTextFormat.Snippet = 2;
})(InsertTextFormat || (InsertTextFormat = {}));
/**
 * Completion item tags are extra annotations that tweak the rendering of a completion
 * item.
 *
 * @since 3.15.0
 */
var CompletionItemTag;
(function (CompletionItemTag) {
    /**
     * Render a completion as obsolete, usually using a strike-out.
     */
    CompletionItemTag.Deprecated = 1;
})(CompletionItemTag || (CompletionItemTag = {}));
/**
 * The InsertReplaceEdit namespace provides functions to deal with insert / replace edits.
 *
 * @since 3.16.0
 */
var InsertReplaceEdit;
(function (InsertReplaceEdit) {
    /**
     * Creates a new insert / replace edit
     */
    function create(newText, insert, replace) {
        return { newText: newText, insert: insert, replace: replace };
    }
    InsertReplaceEdit.create = create;
    /**
     * Checks whether the given literal conforms to the [InsertReplaceEdit](#InsertReplaceEdit) interface.
     */
    function is(value) {
        var candidate = value;
        return candidate && Is.string(candidate.newText) && Range.is(candidate.insert) && Range.is(candidate.replace);
    }
    InsertReplaceEdit.is = is;
})(InsertReplaceEdit || (InsertReplaceEdit = {}));
/**
 * How whitespace and indentation is handled during completion
 * item insertion.
 *
 * @since 3.16.0
 */
var InsertTextMode;
(function (InsertTextMode) {
    /**
     * The insertion or replace strings is taken as it is. If the
     * value is multi line the lines below the cursor will be
     * inserted using the indentation defined in the string value.
     * The client will not apply any kind of adjustments to the
     * string.
     */
    InsertTextMode.asIs = 1;
    /**
     * The editor adjusts leading whitespace of new lines so that
     * they match the indentation up to the cursor of the line for
     * which the item is accepted.
     *
     * Consider a line like this: <2tabs><cursor><3tabs>foo. Accepting a
     * multi line completion item is indented using 2 tabs and all
     * following lines inserted will be indented using 2 tabs as well.
     */
    InsertTextMode.adjustIndentation = 2;
})(InsertTextMode || (InsertTextMode = {}));
/**
 * The CompletionItem namespace provides functions to deal with
 * completion items.
 */
var CompletionItem;
(function (CompletionItem) {
    /**
     * Create a completion item and seed it with a label.
     * @param label The completion item's label
     */
    function create(label) {
        return { label: label };
    }
    CompletionItem.create = create;
})(CompletionItem || (CompletionItem = {}));
/**
 * The CompletionList namespace provides functions to deal with
 * completion lists.
 */
var CompletionList;
(function (CompletionList) {
    /**
     * Creates a new completion list.
     *
     * @param items The completion items.
     * @param isIncomplete The list is not complete.
     */
    function create(items, isIncomplete) {
        return { items: items ? items : [], isIncomplete: !!isIncomplete };
    }
    CompletionList.create = create;
})(CompletionList || (CompletionList = {}));
var MarkedString;
(function (MarkedString) {
    /**
     * Creates a marked string from plain text.
     *
     * @param plainText The plain text.
     */
    function fromPlainText(plainText) {
        return plainText.replace(/[\\`*_{}[\]()#+\-.!]/g, '\\$&'); // escape markdown syntax tokens: http://daringfireball.net/projects/markdown/syntax#backslash
    }
    MarkedString.fromPlainText = fromPlainText;
    /**
     * Checks whether the given value conforms to the [MarkedString](#MarkedString) type.
     */
    function is(value) {
        var candidate = value;
        return Is.string(candidate) || (Is.objectLiteral(candidate) && Is.string(candidate.language) && Is.string(candidate.value));
    }
    MarkedString.is = is;
})(MarkedString || (MarkedString = {}));
var Hover;
(function (Hover) {
    /**
     * Checks whether the given value conforms to the [Hover](#Hover) interface.
     */
    function is(value) {
        var candidate = value;
        return !!candidate && Is.objectLiteral(candidate) && (MarkupContent.is(candidate.contents) ||
            MarkedString.is(candidate.contents) ||
            Is.typedArray(candidate.contents, MarkedString.is)) && (value.range === undefined || Range.is(value.range));
    }
    Hover.is = is;
})(Hover || (Hover = {}));
/**
 * The ParameterInformation namespace provides helper functions to work with
 * [ParameterInformation](#ParameterInformation) literals.
 */
var ParameterInformation;
(function (ParameterInformation) {
    /**
     * Creates a new parameter information literal.
     *
     * @param label A label string.
     * @param documentation A doc string.
     */
    function create(label, documentation) {
        return documentation ? { label: label, documentation: documentation } : { label: label };
    }
    ParameterInformation.create = create;
})(ParameterInformation || (ParameterInformation = {}));
/**
 * The SignatureInformation namespace provides helper functions to work with
 * [SignatureInformation](#SignatureInformation) literals.
 */
var SignatureInformation;
(function (SignatureInformation) {
    function create(label, documentation) {
        var parameters = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            parameters[_i - 2] = arguments[_i];
        }
        var result = { label: label };
        if (Is.defined(documentation)) {
            result.documentation = documentation;
        }
        if (Is.defined(parameters)) {
            result.parameters = parameters;
        }
        else {
            result.parameters = [];
        }
        return result;
    }
    SignatureInformation.create = create;
})(SignatureInformation || (SignatureInformation = {}));
/**
 * A document highlight kind.
 */
var DocumentHighlightKind;
(function (DocumentHighlightKind) {
    /**
     * A textual occurrence.
     */
    DocumentHighlightKind.Text = 1;
    /**
     * Read-access of a symbol, like reading a variable.
     */
    DocumentHighlightKind.Read = 2;
    /**
     * Write-access of a symbol, like writing to a variable.
     */
    DocumentHighlightKind.Write = 3;
})(DocumentHighlightKind || (DocumentHighlightKind = {}));
/**
 * DocumentHighlight namespace to provide helper functions to work with
 * [DocumentHighlight](#DocumentHighlight) literals.
 */
var DocumentHighlight;
(function (DocumentHighlight) {
    /**
     * Create a DocumentHighlight object.
     * @param range The range the highlight applies to.
     */
    function create(range, kind) {
        var result = { range: range };
        if (Is.number(kind)) {
            result.kind = kind;
        }
        return result;
    }
    DocumentHighlight.create = create;
})(DocumentHighlight || (DocumentHighlight = {}));
/**
 * A symbol kind.
 */
var SymbolKind;
(function (SymbolKind) {
    SymbolKind.File = 1;
    SymbolKind.Module = 2;
    SymbolKind.Namespace = 3;
    SymbolKind.Package = 4;
    SymbolKind.Class = 5;
    SymbolKind.Method = 6;
    SymbolKind.Property = 7;
    SymbolKind.Field = 8;
    SymbolKind.Constructor = 9;
    SymbolKind.Enum = 10;
    SymbolKind.Interface = 11;
    SymbolKind.Function = 12;
    SymbolKind.Variable = 13;
    SymbolKind.Constant = 14;
    SymbolKind.String = 15;
    SymbolKind.Number = 16;
    SymbolKind.Boolean = 17;
    SymbolKind.Array = 18;
    SymbolKind.Object = 19;
    SymbolKind.Key = 20;
    SymbolKind.Null = 21;
    SymbolKind.EnumMember = 22;
    SymbolKind.Struct = 23;
    SymbolKind.Event = 24;
    SymbolKind.Operator = 25;
    SymbolKind.TypeParameter = 26;
})(SymbolKind || (SymbolKind = {}));
/**
 * Symbol tags are extra annotations that tweak the rendering of a symbol.
 * @since 3.16
 */
var SymbolTag;
(function (SymbolTag) {
    /**
     * Render a symbol as obsolete, usually using a strike-out.
     */
    SymbolTag.Deprecated = 1;
})(SymbolTag || (SymbolTag = {}));
var SymbolInformation;
(function (SymbolInformation) {
    /**
     * Creates a new symbol information literal.
     *
     * @param name The name of the symbol.
     * @param kind The kind of the symbol.
     * @param range The range of the location of the symbol.
     * @param uri The resource of the location of symbol, defaults to the current document.
     * @param containerName The name of the symbol containing the symbol.
     */
    function create(name, kind, range, uri, containerName) {
        var result = {
            name: name,
            kind: kind,
            location: { uri: uri, range: range }
        };
        if (containerName) {
            result.containerName = containerName;
        }
        return result;
    }
    SymbolInformation.create = create;
})(SymbolInformation || (SymbolInformation = {}));
var DocumentSymbol;
(function (DocumentSymbol) {
    /**
     * Creates a new symbol information literal.
     *
     * @param name The name of the symbol.
     * @param detail The detail of the symbol.
     * @param kind The kind of the symbol.
     * @param range The range of the symbol.
     * @param selectionRange The selectionRange of the symbol.
     * @param children Children of the symbol.
     */
    function create(name, detail, kind, range, selectionRange, children) {
        var result = {
            name: name,
            detail: detail,
            kind: kind,
            range: range,
            selectionRange: selectionRange
        };
        if (children !== undefined) {
            result.children = children;
        }
        return result;
    }
    DocumentSymbol.create = create;
    /**
     * Checks whether the given literal conforms to the [DocumentSymbol](#DocumentSymbol) interface.
     */
    function is(value) {
        var candidate = value;
        return candidate &&
            Is.string(candidate.name) && Is.number(candidate.kind) &&
            Range.is(candidate.range) && Range.is(candidate.selectionRange) &&
            (candidate.detail === undefined || Is.string(candidate.detail)) &&
            (candidate.deprecated === undefined || Is.boolean(candidate.deprecated)) &&
            (candidate.children === undefined || Array.isArray(candidate.children)) &&
            (candidate.tags === undefined || Array.isArray(candidate.tags));
    }
    DocumentSymbol.is = is;
})(DocumentSymbol || (DocumentSymbol = {}));
/**
 * A set of predefined code action kinds
 */
var CodeActionKind;
(function (CodeActionKind) {
    /**
     * Empty kind.
     */
    CodeActionKind.Empty = '';
    /**
     * Base kind for quickfix actions: 'quickfix'
     */
    CodeActionKind.QuickFix = 'quickfix';
    /**
     * Base kind for refactoring actions: 'refactor'
     */
    CodeActionKind.Refactor = 'refactor';
    /**
     * Base kind for refactoring extraction actions: 'refactor.extract'
     *
     * Example extract actions:
     *
     * - Extract method
     * - Extract function
     * - Extract variable
     * - Extract interface from class
     * - ...
     */
    CodeActionKind.RefactorExtract = 'refactor.extract';
    /**
     * Base kind for refactoring inline actions: 'refactor.inline'
     *
     * Example inline actions:
     *
     * - Inline function
     * - Inline variable
     * - Inline constant
     * - ...
     */
    CodeActionKind.RefactorInline = 'refactor.inline';
    /**
     * Base kind for refactoring rewrite actions: 'refactor.rewrite'
     *
     * Example rewrite actions:
     *
     * - Convert JavaScript function to class
     * - Add or remove parameter
     * - Encapsulate field
     * - Make method static
     * - Move method to base class
     * - ...
     */
    CodeActionKind.RefactorRewrite = 'refactor.rewrite';
    /**
     * Base kind for source actions: `source`
     *
     * Source code actions apply to the entire file.
     */
    CodeActionKind.Source = 'source';
    /**
     * Base kind for an organize imports source action: `source.organizeImports`
     */
    CodeActionKind.SourceOrganizeImports = 'source.organizeImports';
    /**
     * Base kind for auto-fix source actions: `source.fixAll`.
     *
     * Fix all actions automatically fix errors that have a clear fix that do not require user input.
     * They should not suppress errors or perform unsafe fixes such as generating new types or classes.
     *
     * @since 3.15.0
     */
    CodeActionKind.SourceFixAll = 'source.fixAll';
})(CodeActionKind || (CodeActionKind = {}));
/**
 * The CodeActionContext namespace provides helper functions to work with
 * [CodeActionContext](#CodeActionContext) literals.
 */
var CodeActionContext;
(function (CodeActionContext) {
    /**
     * Creates a new CodeActionContext literal.
     */
    function create(diagnostics, only) {
        var result = { diagnostics: diagnostics };
        if (only !== undefined && only !== null) {
            result.only = only;
        }
        return result;
    }
    CodeActionContext.create = create;
    /**
     * Checks whether the given literal conforms to the [CodeActionContext](#CodeActionContext) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.defined(candidate) && Is.typedArray(candidate.diagnostics, Diagnostic.is) && (candidate.only === undefined || Is.typedArray(candidate.only, Is.string));
    }
    CodeActionContext.is = is;
})(CodeActionContext || (CodeActionContext = {}));
var CodeAction;
(function (CodeAction) {
    function create(title, kindOrCommandOrEdit, kind) {
        var result = { title: title };
        var checkKind = true;
        if (typeof kindOrCommandOrEdit === 'string') {
            checkKind = false;
            result.kind = kindOrCommandOrEdit;
        }
        else if (Command.is(kindOrCommandOrEdit)) {
            result.command = kindOrCommandOrEdit;
        }
        else {
            result.edit = kindOrCommandOrEdit;
        }
        if (checkKind && kind !== undefined) {
            result.kind = kind;
        }
        return result;
    }
    CodeAction.create = create;
    function is(value) {
        var candidate = value;
        return candidate && Is.string(candidate.title) &&
            (candidate.diagnostics === undefined || Is.typedArray(candidate.diagnostics, Diagnostic.is)) &&
            (candidate.kind === undefined || Is.string(candidate.kind)) &&
            (candidate.edit !== undefined || candidate.command !== undefined) &&
            (candidate.command === undefined || Command.is(candidate.command)) &&
            (candidate.isPreferred === undefined || Is.boolean(candidate.isPreferred)) &&
            (candidate.edit === undefined || WorkspaceEdit.is(candidate.edit));
    }
    CodeAction.is = is;
})(CodeAction || (CodeAction = {}));
/**
 * The CodeLens namespace provides helper functions to work with
 * [CodeLens](#CodeLens) literals.
 */
var CodeLens;
(function (CodeLens) {
    /**
     * Creates a new CodeLens literal.
     */
    function create(range, data) {
        var result = { range: range };
        if (Is.defined(data)) {
            result.data = data;
        }
        return result;
    }
    CodeLens.create = create;
    /**
     * Checks whether the given literal conforms to the [CodeLens](#CodeLens) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.defined(candidate) && Range.is(candidate.range) && (Is.undefined(candidate.command) || Command.is(candidate.command));
    }
    CodeLens.is = is;
})(CodeLens || (CodeLens = {}));
/**
 * The FormattingOptions namespace provides helper functions to work with
 * [FormattingOptions](#FormattingOptions) literals.
 */
var FormattingOptions;
(function (FormattingOptions) {
    /**
     * Creates a new FormattingOptions literal.
     */
    function create(tabSize, insertSpaces) {
        return { tabSize: tabSize, insertSpaces: insertSpaces };
    }
    FormattingOptions.create = create;
    /**
     * Checks whether the given literal conforms to the [FormattingOptions](#FormattingOptions) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.defined(candidate) && Is.uinteger(candidate.tabSize) && Is.boolean(candidate.insertSpaces);
    }
    FormattingOptions.is = is;
})(FormattingOptions || (FormattingOptions = {}));
/**
 * The DocumentLink namespace provides helper functions to work with
 * [DocumentLink](#DocumentLink) literals.
 */
var DocumentLink;
(function (DocumentLink) {
    /**
     * Creates a new DocumentLink literal.
     */
    function create(range, target, data) {
        return { range: range, target: target, data: data };
    }
    DocumentLink.create = create;
    /**
     * Checks whether the given literal conforms to the [DocumentLink](#DocumentLink) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.defined(candidate) && Range.is(candidate.range) && (Is.undefined(candidate.target) || Is.string(candidate.target));
    }
    DocumentLink.is = is;
})(DocumentLink || (DocumentLink = {}));
/**
 * The SelectionRange namespace provides helper function to work with
 * SelectionRange literals.
 */
var SelectionRange;
(function (SelectionRange) {
    /**
     * Creates a new SelectionRange
     * @param range the range.
     * @param parent an optional parent.
     */
    function create(range, parent) {
        return { range: range, parent: parent };
    }
    SelectionRange.create = create;
    function is(value) {
        var candidate = value;
        return candidate !== undefined && Range.is(candidate.range) && (candidate.parent === undefined || SelectionRange.is(candidate.parent));
    }
    SelectionRange.is = is;
})(SelectionRange || (SelectionRange = {}));
var EOL = ['\n', '\r\n', '\r'];
/**
 * @deprecated Use the text document from the new vscode-languageserver-textdocument package.
 */
var TextDocument;
(function (TextDocument) {
    /**
     * Creates a new ITextDocument literal from the given uri and content.
     * @param uri The document's uri.
     * @param languageId  The document's language Id.
     * @param content The document's content.
     */
    function create(uri, languageId, version, content) {
        return new FullTextDocument(uri, languageId, version, content);
    }
    TextDocument.create = create;
    /**
     * Checks whether the given literal conforms to the [ITextDocument](#ITextDocument) interface.
     */
    function is(value) {
        var candidate = value;
        return Is.defined(candidate) && Is.string(candidate.uri) && (Is.undefined(candidate.languageId) || Is.string(candidate.languageId)) && Is.uinteger(candidate.lineCount)
            && Is.func(candidate.getText) && Is.func(candidate.positionAt) && Is.func(candidate.offsetAt) ? true : false;
    }
    TextDocument.is = is;
    function applyEdits(document, edits) {
        var text = document.getText();
        var sortedEdits = mergeSort(edits, function (a, b) {
            var diff = a.range.start.line - b.range.start.line;
            if (diff === 0) {
                return a.range.start.character - b.range.start.character;
            }
            return diff;
        });
        var lastModifiedOffset = text.length;
        for (var i = sortedEdits.length - 1; i >= 0; i--) {
            var e = sortedEdits[i];
            var startOffset = document.offsetAt(e.range.start);
            var endOffset = document.offsetAt(e.range.end);
            if (endOffset <= lastModifiedOffset) {
                text = text.substring(0, startOffset) + e.newText + text.substring(endOffset, text.length);
            }
            else {
                throw new Error('Overlapping edit');
            }
            lastModifiedOffset = startOffset;
        }
        return text;
    }
    TextDocument.applyEdits = applyEdits;
    function mergeSort(data, compare) {
        if (data.length <= 1) {
            // sorted
            return data;
        }
        var p = (data.length / 2) | 0;
        var left = data.slice(0, p);
        var right = data.slice(p);
        mergeSort(left, compare);
        mergeSort(right, compare);
        var leftIdx = 0;
        var rightIdx = 0;
        var i = 0;
        while (leftIdx < left.length && rightIdx < right.length) {
            var ret = compare(left[leftIdx], right[rightIdx]);
            if (ret <= 0) {
                // smaller_equal -> take left to preserve order
                data[i++] = left[leftIdx++];
            }
            else {
                // greater -> take right
                data[i++] = right[rightIdx++];
            }
        }
        while (leftIdx < left.length) {
            data[i++] = left[leftIdx++];
        }
        while (rightIdx < right.length) {
            data[i++] = right[rightIdx++];
        }
        return data;
    }
})(TextDocument || (TextDocument = {}));
/**
 * @deprecated Use the text document from the new vscode-languageserver-textdocument package.
 */
var FullTextDocument = /** @class */ (function () {
    function FullTextDocument(uri, languageId, version, content) {
        this._uri = uri;
        this._languageId = languageId;
        this._version = version;
        this._content = content;
        this._lineOffsets = undefined;
    }
    Object.defineProperty(FullTextDocument.prototype, "uri", {
        get: function () {
            return this._uri;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FullTextDocument.prototype, "languageId", {
        get: function () {
            return this._languageId;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FullTextDocument.prototype, "version", {
        get: function () {
            return this._version;
        },
        enumerable: false,
        configurable: true
    });
    FullTextDocument.prototype.getText = function (range) {
        if (range) {
            var start = this.offsetAt(range.start);
            var end = this.offsetAt(range.end);
            return this._content.substring(start, end);
        }
        return this._content;
    };
    FullTextDocument.prototype.update = function (event, version) {
        this._content = event.text;
        this._version = version;
        this._lineOffsets = undefined;
    };
    FullTextDocument.prototype.getLineOffsets = function () {
        if (this._lineOffsets === undefined) {
            var lineOffsets = [];
            var text = this._content;
            var isLineStart = true;
            for (var i = 0; i < text.length; i++) {
                if (isLineStart) {
                    lineOffsets.push(i);
                    isLineStart = false;
                }
                var ch = text.charAt(i);
                isLineStart = (ch === '\r' || ch === '\n');
                if (ch === '\r' && i + 1 < text.length && text.charAt(i + 1) === '\n') {
                    i++;
                }
            }
            if (isLineStart && text.length > 0) {
                lineOffsets.push(text.length);
            }
            this._lineOffsets = lineOffsets;
        }
        return this._lineOffsets;
    };
    FullTextDocument.prototype.positionAt = function (offset) {
        offset = Math.max(Math.min(offset, this._content.length), 0);
        var lineOffsets = this.getLineOffsets();
        var low = 0, high = lineOffsets.length;
        if (high === 0) {
            return Position.create(0, offset);
        }
        while (low < high) {
            var mid = Math.floor((low + high) / 2);
            if (lineOffsets[mid] > offset) {
                high = mid;
            }
            else {
                low = mid + 1;
            }
        }
        // low is the least x for which the line offset is larger than the current offset
        // or array.length if no line offset is larger than the current offset
        var line = low - 1;
        return Position.create(line, offset - lineOffsets[line]);
    };
    FullTextDocument.prototype.offsetAt = function (position) {
        var lineOffsets = this.getLineOffsets();
        if (position.line >= lineOffsets.length) {
            return this._content.length;
        }
        else if (position.line < 0) {
            return 0;
        }
        var lineOffset = lineOffsets[position.line];
        var nextLineOffset = (position.line + 1 < lineOffsets.length) ? lineOffsets[position.line + 1] : this._content.length;
        return Math.max(Math.min(lineOffset + position.character, nextLineOffset), lineOffset);
    };
    Object.defineProperty(FullTextDocument.prototype, "lineCount", {
        get: function () {
            return this.getLineOffsets().length;
        },
        enumerable: false,
        configurable: true
    });
    return FullTextDocument;
}());
var Is;
(function (Is) {
    var toString = Object.prototype.toString;
    function defined(value) {
        return typeof value !== 'undefined';
    }
    Is.defined = defined;
    function undefined$1(value) {
        return typeof value === 'undefined';
    }
    Is.undefined = undefined$1;
    function boolean(value) {
        return value === true || value === false;
    }
    Is.boolean = boolean;
    function string(value) {
        return toString.call(value) === '[object String]';
    }
    Is.string = string;
    function number(value) {
        return toString.call(value) === '[object Number]';
    }
    Is.number = number;
    function numberRange(value, min, max) {
        return toString.call(value) === '[object Number]' && min <= value && value <= max;
    }
    Is.numberRange = numberRange;
    function integer(value) {
        return toString.call(value) === '[object Number]' && -2147483648 <= value && value <= 2147483647;
    }
    Is.integer = integer;
    function uinteger(value) {
        return toString.call(value) === '[object Number]' && 0 <= value && value <= 2147483647;
    }
    Is.uinteger = uinteger;
    function func(value) {
        return toString.call(value) === '[object Function]';
    }
    Is.func = func;
    function objectLiteral(value) {
        // Strictly speaking class instances pass this check as well. Since the LSP
        // doesn't use classes we ignore this for now. If we do we need to add something
        // like this: `Object.getPrototypeOf(Object.getPrototypeOf(x)) === null`
        return value !== null && typeof value === 'object';
    }
    Is.objectLiteral = objectLiteral;
    function typedArray(value, check) {
        return Array.isArray(value) && value.every(check);
    }
    Is.typedArray = typedArray;
})(Is || (Is = {}));

var main$1 = /*#__PURE__*/Object.freeze({
	__proto__: null,
	get integer () { return integer; },
	get uinteger () { return uinteger; },
	get Position () { return Position; },
	get Range () { return Range; },
	get Location () { return Location; },
	get LocationLink () { return LocationLink; },
	get Color () { return Color; },
	get ColorInformation () { return ColorInformation; },
	get ColorPresentation () { return ColorPresentation; },
	get FoldingRangeKind () { return FoldingRangeKind; },
	get FoldingRange () { return FoldingRange; },
	get DiagnosticRelatedInformation () { return DiagnosticRelatedInformation; },
	get DiagnosticSeverity () { return DiagnosticSeverity; },
	get DiagnosticTag () { return DiagnosticTag; },
	get CodeDescription () { return CodeDescription; },
	get Diagnostic () { return Diagnostic; },
	get Command () { return Command; },
	get TextEdit () { return TextEdit; },
	get ChangeAnnotation () { return ChangeAnnotation; },
	get ChangeAnnotationIdentifier () { return ChangeAnnotationIdentifier; },
	get AnnotatedTextEdit () { return AnnotatedTextEdit; },
	get TextDocumentEdit () { return TextDocumentEdit; },
	get CreateFile () { return CreateFile; },
	get RenameFile () { return RenameFile; },
	get DeleteFile () { return DeleteFile; },
	get WorkspaceEdit () { return WorkspaceEdit; },
	WorkspaceChange: WorkspaceChange,
	get TextDocumentIdentifier () { return TextDocumentIdentifier; },
	get VersionedTextDocumentIdentifier () { return VersionedTextDocumentIdentifier; },
	get OptionalVersionedTextDocumentIdentifier () { return OptionalVersionedTextDocumentIdentifier; },
	get TextDocumentItem () { return TextDocumentItem; },
	get MarkupKind () { return MarkupKind; },
	get MarkupContent () { return MarkupContent; },
	get CompletionItemKind () { return CompletionItemKind; },
	get InsertTextFormat () { return InsertTextFormat; },
	get CompletionItemTag () { return CompletionItemTag; },
	get InsertReplaceEdit () { return InsertReplaceEdit; },
	get InsertTextMode () { return InsertTextMode; },
	get CompletionItem () { return CompletionItem; },
	get CompletionList () { return CompletionList; },
	get MarkedString () { return MarkedString; },
	get Hover () { return Hover; },
	get ParameterInformation () { return ParameterInformation; },
	get SignatureInformation () { return SignatureInformation; },
	get DocumentHighlightKind () { return DocumentHighlightKind; },
	get DocumentHighlight () { return DocumentHighlight; },
	get SymbolKind () { return SymbolKind; },
	get SymbolTag () { return SymbolTag; },
	get SymbolInformation () { return SymbolInformation; },
	get DocumentSymbol () { return DocumentSymbol; },
	get CodeActionKind () { return CodeActionKind; },
	get CodeActionContext () { return CodeActionContext; },
	get CodeAction () { return CodeAction; },
	get CodeLens () { return CodeLens; },
	get FormattingOptions () { return FormattingOptions; },
	get DocumentLink () { return DocumentLink; },
	get SelectionRange () { return SelectionRange; },
	EOL: EOL,
	get TextDocument () { return TextDocument; }
});

var messages$1 = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProtocolNotificationType = exports.ProtocolNotificationType0 = exports.ProtocolRequestType = exports.ProtocolRequestType0 = exports.RegistrationType = void 0;

class RegistrationType {
    constructor(method) {
        this.method = method;
    }
}
exports.RegistrationType = RegistrationType;
class ProtocolRequestType0 extends main.RequestType0 {
    constructor(method) {
        super(method);
    }
}
exports.ProtocolRequestType0 = ProtocolRequestType0;
class ProtocolRequestType extends main.RequestType {
    constructor(method) {
        super(method, main.ParameterStructures.byName);
    }
}
exports.ProtocolRequestType = ProtocolRequestType;
class ProtocolNotificationType0 extends main.NotificationType0 {
    constructor(method) {
        super(method);
    }
}
exports.ProtocolNotificationType0 = ProtocolNotificationType0;
class ProtocolNotificationType extends main.NotificationType {
    constructor(method) {
        super(method, main.ParameterStructures.byName);
    }
}
exports.ProtocolNotificationType = ProtocolNotificationType;
// let x: ProtocolNotificationType<number, { value: number}>;
// let y: ProtocolNotificationType<string, { value: number}>;
// x = y;

});

/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */

var is$2 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.objectLiteral = exports.typedArray = exports.stringArray = exports.array = exports.func = exports.error = exports.number = exports.string = exports.boolean = void 0;
function boolean(value) {
    return value === true || value === false;
}
exports.boolean = boolean;
function string(value) {
    return typeof value === 'string' || value instanceof String;
}
exports.string = string;
function number(value) {
    return typeof value === 'number' || value instanceof Number;
}
exports.number = number;
function error(value) {
    return value instanceof Error;
}
exports.error = error;
function func(value) {
    return typeof value === 'function';
}
exports.func = func;
function array(value) {
    return Array.isArray(value);
}
exports.array = array;
function stringArray(value) {
    return array(value) && value.every(elem => string(elem));
}
exports.stringArray = stringArray;
function typedArray(value, check) {
    return Array.isArray(value) && value.every(check);
}
exports.typedArray = typedArray;
function objectLiteral(value) {
    // Strictly speaking class instances pass this check as well. Since the LSP
    // doesn't use classes we ignore this for now. If we do we need to add something
    // like this: `Object.getPrototypeOf(Object.getPrototypeOf(x)) === null`
    return value !== null && typeof value === 'object';
}
exports.objectLiteral = objectLiteral;

});

var protocol_implementation = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImplementationRequest = void 0;
/**
 * A request to resolve the implementation locations of a symbol at a given text
 * document position. The request's parameter is of type [TextDocumentPositioParams]
 * (#TextDocumentPositionParams) the response is of type [Definition](#Definition) or a
 * Thenable that resolves to such.
 */
var ImplementationRequest;
(function (ImplementationRequest) {
    ImplementationRequest.method = 'textDocument/implementation';
    ImplementationRequest.type = new messages$1.ProtocolRequestType(ImplementationRequest.method);
})(ImplementationRequest = exports.ImplementationRequest || (exports.ImplementationRequest = {}));

});

var protocol_typeDefinition = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeDefinitionRequest = void 0;
/**
 * A request to resolve the type definition locations of a symbol at a given text
 * document position. The request's parameter is of type [TextDocumentPositioParams]
 * (#TextDocumentPositionParams) the response is of type [Definition](#Definition) or a
 * Thenable that resolves to such.
 */
var TypeDefinitionRequest;
(function (TypeDefinitionRequest) {
    TypeDefinitionRequest.method = 'textDocument/typeDefinition';
    TypeDefinitionRequest.type = new messages$1.ProtocolRequestType(TypeDefinitionRequest.method);
})(TypeDefinitionRequest = exports.TypeDefinitionRequest || (exports.TypeDefinitionRequest = {}));

});

var protocol_workspaceFolders = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.DidChangeWorkspaceFoldersNotification = exports.WorkspaceFoldersRequest = void 0;

/**
 * The `workspace/workspaceFolders` is sent from the server to the client to fetch the open workspace folders.
 */
var WorkspaceFoldersRequest;
(function (WorkspaceFoldersRequest) {
    WorkspaceFoldersRequest.type = new messages$1.ProtocolRequestType0('workspace/workspaceFolders');
})(WorkspaceFoldersRequest = exports.WorkspaceFoldersRequest || (exports.WorkspaceFoldersRequest = {}));
/**
 * The `workspace/didChangeWorkspaceFolders` notification is sent from the client to the server when the workspace
 * folder configuration changes.
 */
var DidChangeWorkspaceFoldersNotification;
(function (DidChangeWorkspaceFoldersNotification) {
    DidChangeWorkspaceFoldersNotification.type = new messages$1.ProtocolNotificationType('workspace/didChangeWorkspaceFolders');
})(DidChangeWorkspaceFoldersNotification = exports.DidChangeWorkspaceFoldersNotification || (exports.DidChangeWorkspaceFoldersNotification = {}));

});

var protocol_configuration = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigurationRequest = void 0;

/**
 * The 'workspace/configuration' request is sent from the server to the client to fetch a certain
 * configuration setting.
 *
 * This pull model replaces the old push model were the client signaled configuration change via an
 * event. If the server still needs to react to configuration changes (since the server caches the
 * result of `workspace/configuration` requests) the server should register for an empty configuration
 * change event and empty the cache if such an event is received.
 */
var ConfigurationRequest;
(function (ConfigurationRequest) {
    ConfigurationRequest.type = new messages$1.ProtocolRequestType('workspace/configuration');
})(ConfigurationRequest = exports.ConfigurationRequest || (exports.ConfigurationRequest = {}));

});

var protocol_colorProvider = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColorPresentationRequest = exports.DocumentColorRequest = void 0;

/**
 * A request to list all color symbols found in a given text document. The request's
 * parameter is of type [DocumentColorParams](#DocumentColorParams) the
 * response is of type [ColorInformation[]](#ColorInformation) or a Thenable
 * that resolves to such.
 */
var DocumentColorRequest;
(function (DocumentColorRequest) {
    DocumentColorRequest.method = 'textDocument/documentColor';
    DocumentColorRequest.type = new messages$1.ProtocolRequestType(DocumentColorRequest.method);
})(DocumentColorRequest = exports.DocumentColorRequest || (exports.DocumentColorRequest = {}));
/**
 * A request to list all presentation for a color. The request's
 * parameter is of type [ColorPresentationParams](#ColorPresentationParams) the
 * response is of type [ColorInformation[]](#ColorInformation) or a Thenable
 * that resolves to such.
 */
var ColorPresentationRequest;
(function (ColorPresentationRequest) {
    ColorPresentationRequest.type = new messages$1.ProtocolRequestType('textDocument/colorPresentation');
})(ColorPresentationRequest = exports.ColorPresentationRequest || (exports.ColorPresentationRequest = {}));

});

var protocol_foldingRange = createCommonjsModule(function (module, exports) {
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.FoldingRangeRequest = exports.FoldingRangeKind = void 0;

/**
 * Enum of known range kinds
 */
var FoldingRangeKind;
(function (FoldingRangeKind) {
    /**
     * Folding range for a comment
     */
    FoldingRangeKind["Comment"] = "comment";
    /**
     * Folding range for a imports or includes
     */
    FoldingRangeKind["Imports"] = "imports";
    /**
     * Folding range for a region (e.g. `#region`)
     */
    FoldingRangeKind["Region"] = "region";
})(FoldingRangeKind = exports.FoldingRangeKind || (exports.FoldingRangeKind = {}));
/**
 * A request to provide folding ranges in a document. The request's
 * parameter is of type [FoldingRangeParams](#FoldingRangeParams), the
 * response is of type [FoldingRangeList](#FoldingRangeList) or a Thenable
 * that resolves to such.
 */
var FoldingRangeRequest;
(function (FoldingRangeRequest) {
    FoldingRangeRequest.method = 'textDocument/foldingRange';
    FoldingRangeRequest.type = new messages$1.ProtocolRequestType(FoldingRangeRequest.method);
})(FoldingRangeRequest = exports.FoldingRangeRequest || (exports.FoldingRangeRequest = {}));

});

var protocol_declaration = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeclarationRequest = void 0;
/**
 * A request to resolve the type definition locations of a symbol at a given text
 * document position. The request's parameter is of type [TextDocumentPositioParams]
 * (#TextDocumentPositionParams) the response is of type [Declaration](#Declaration)
 * or a typed array of [DeclarationLink](#DeclarationLink) or a Thenable that resolves
 * to such.
 */
var DeclarationRequest;
(function (DeclarationRequest) {
    DeclarationRequest.method = 'textDocument/declaration';
    DeclarationRequest.type = new messages$1.ProtocolRequestType(DeclarationRequest.method);
})(DeclarationRequest = exports.DeclarationRequest || (exports.DeclarationRequest = {}));

});

var protocol_selectionRange = createCommonjsModule(function (module, exports) {
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectionRangeRequest = void 0;

/**
 * A request to provide selection ranges in a document. The request's
 * parameter is of type [SelectionRangeParams](#SelectionRangeParams), the
 * response is of type [SelectionRange[]](#SelectionRange[]) or a Thenable
 * that resolves to such.
 */
var SelectionRangeRequest;
(function (SelectionRangeRequest) {
    SelectionRangeRequest.method = 'textDocument/selectionRange';
    SelectionRangeRequest.type = new messages$1.ProtocolRequestType(SelectionRangeRequest.method);
})(SelectionRangeRequest = exports.SelectionRangeRequest || (exports.SelectionRangeRequest = {}));

});

var protocol_progress = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkDoneProgressCancelNotification = exports.WorkDoneProgressCreateRequest = exports.WorkDoneProgress = void 0;


var WorkDoneProgress;
(function (WorkDoneProgress) {
    WorkDoneProgress.type = new main.ProgressType();
    function is(value) {
        return value === WorkDoneProgress.type;
    }
    WorkDoneProgress.is = is;
})(WorkDoneProgress = exports.WorkDoneProgress || (exports.WorkDoneProgress = {}));
/**
 * The `window/workDoneProgress/create` request is sent from the server to the client to initiate progress
 * reporting from the server.
 */
var WorkDoneProgressCreateRequest;
(function (WorkDoneProgressCreateRequest) {
    WorkDoneProgressCreateRequest.type = new messages$1.ProtocolRequestType('window/workDoneProgress/create');
})(WorkDoneProgressCreateRequest = exports.WorkDoneProgressCreateRequest || (exports.WorkDoneProgressCreateRequest = {}));
/**
 * The `window/workDoneProgress/cancel` notification is sent from  the client to the server to cancel a progress
 * initiated on the server side.
 */
var WorkDoneProgressCancelNotification;
(function (WorkDoneProgressCancelNotification) {
    WorkDoneProgressCancelNotification.type = new messages$1.ProtocolNotificationType('window/workDoneProgress/cancel');
})(WorkDoneProgressCancelNotification = exports.WorkDoneProgressCancelNotification || (exports.WorkDoneProgressCancelNotification = {}));

});

var protocol_callHierarchy = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) TypeFox and others. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.CallHierarchyOutgoingCallsRequest = exports.CallHierarchyIncomingCallsRequest = exports.CallHierarchyPrepareRequest = void 0;

/**
 * A request to result a `CallHierarchyItem` in a document at a given position.
 * Can be used as an input to a incoming or outgoing call hierarchy.
 *
 * @since 3.16.0
 */
var CallHierarchyPrepareRequest;
(function (CallHierarchyPrepareRequest) {
    CallHierarchyPrepareRequest.method = 'textDocument/prepareCallHierarchy';
    CallHierarchyPrepareRequest.type = new messages$1.ProtocolRequestType(CallHierarchyPrepareRequest.method);
})(CallHierarchyPrepareRequest = exports.CallHierarchyPrepareRequest || (exports.CallHierarchyPrepareRequest = {}));
/**
 * A request to resolve the incoming calls for a given `CallHierarchyItem`.
 *
 * @since 3.16.0
 */
var CallHierarchyIncomingCallsRequest;
(function (CallHierarchyIncomingCallsRequest) {
    CallHierarchyIncomingCallsRequest.method = 'callHierarchy/incomingCalls';
    CallHierarchyIncomingCallsRequest.type = new messages$1.ProtocolRequestType(CallHierarchyIncomingCallsRequest.method);
})(CallHierarchyIncomingCallsRequest = exports.CallHierarchyIncomingCallsRequest || (exports.CallHierarchyIncomingCallsRequest = {}));
/**
 * A request to resolve the outgoing calls for a given `CallHierarchyItem`.
 *
 * @since 3.16.0
 */
var CallHierarchyOutgoingCallsRequest;
(function (CallHierarchyOutgoingCallsRequest) {
    CallHierarchyOutgoingCallsRequest.method = 'callHierarchy/outgoingCalls';
    CallHierarchyOutgoingCallsRequest.type = new messages$1.ProtocolRequestType(CallHierarchyOutgoingCallsRequest.method);
})(CallHierarchyOutgoingCallsRequest = exports.CallHierarchyOutgoingCallsRequest || (exports.CallHierarchyOutgoingCallsRequest = {}));

});

var protocol_semanticTokens = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.SemanticTokensRefreshRequest = exports.SemanticTokensRangeRequest = exports.SemanticTokensDeltaRequest = exports.SemanticTokensRequest = exports.SemanticTokensRegistrationType = exports.TokenFormat = exports.SemanticTokens = exports.SemanticTokenModifiers = exports.SemanticTokenTypes = void 0;

/**
 * A set of predefined token types. This set is not fixed
 * an clients can specify additional token types via the
 * corresponding client capabilities.
 *
 * @since 3.16.0
 */
var SemanticTokenTypes;
(function (SemanticTokenTypes) {
    SemanticTokenTypes["namespace"] = "namespace";
    /**
     * Represents a generic type. Acts as a fallback for types which can't be mapped to
     * a specific type like class or enum.
     */
    SemanticTokenTypes["type"] = "type";
    SemanticTokenTypes["class"] = "class";
    SemanticTokenTypes["enum"] = "enum";
    SemanticTokenTypes["interface"] = "interface";
    SemanticTokenTypes["struct"] = "struct";
    SemanticTokenTypes["typeParameter"] = "typeParameter";
    SemanticTokenTypes["parameter"] = "parameter";
    SemanticTokenTypes["variable"] = "variable";
    SemanticTokenTypes["property"] = "property";
    SemanticTokenTypes["enumMember"] = "enumMember";
    SemanticTokenTypes["event"] = "event";
    SemanticTokenTypes["function"] = "function";
    SemanticTokenTypes["method"] = "method";
    SemanticTokenTypes["macro"] = "macro";
    SemanticTokenTypes["keyword"] = "keyword";
    SemanticTokenTypes["modifier"] = "modifier";
    SemanticTokenTypes["comment"] = "comment";
    SemanticTokenTypes["string"] = "string";
    SemanticTokenTypes["number"] = "number";
    SemanticTokenTypes["regexp"] = "regexp";
    SemanticTokenTypes["operator"] = "operator";
})(SemanticTokenTypes = exports.SemanticTokenTypes || (exports.SemanticTokenTypes = {}));
/**
 * A set of predefined token modifiers. This set is not fixed
 * an clients can specify additional token types via the
 * corresponding client capabilities.
 *
 * @since 3.16.0
 */
var SemanticTokenModifiers;
(function (SemanticTokenModifiers) {
    SemanticTokenModifiers["declaration"] = "declaration";
    SemanticTokenModifiers["definition"] = "definition";
    SemanticTokenModifiers["readonly"] = "readonly";
    SemanticTokenModifiers["static"] = "static";
    SemanticTokenModifiers["deprecated"] = "deprecated";
    SemanticTokenModifiers["abstract"] = "abstract";
    SemanticTokenModifiers["async"] = "async";
    SemanticTokenModifiers["modification"] = "modification";
    SemanticTokenModifiers["documentation"] = "documentation";
    SemanticTokenModifiers["defaultLibrary"] = "defaultLibrary";
})(SemanticTokenModifiers = exports.SemanticTokenModifiers || (exports.SemanticTokenModifiers = {}));
/**
 * @since 3.16.0
 */
var SemanticTokens;
(function (SemanticTokens) {
    function is(value) {
        const candidate = value;
        return candidate !== undefined && (candidate.resultId === undefined || typeof candidate.resultId === 'string') &&
            Array.isArray(candidate.data) && (candidate.data.length === 0 || typeof candidate.data[0] === 'number');
    }
    SemanticTokens.is = is;
})(SemanticTokens = exports.SemanticTokens || (exports.SemanticTokens = {}));
//------- 'textDocument/semanticTokens' -----
var TokenFormat;
(function (TokenFormat) {
    TokenFormat.Relative = 'relative';
})(TokenFormat = exports.TokenFormat || (exports.TokenFormat = {}));
var SemanticTokensRegistrationType;
(function (SemanticTokensRegistrationType) {
    SemanticTokensRegistrationType.method = 'textDocument/semanticTokens';
    SemanticTokensRegistrationType.type = new messages$1.RegistrationType(SemanticTokensRegistrationType.method);
})(SemanticTokensRegistrationType = exports.SemanticTokensRegistrationType || (exports.SemanticTokensRegistrationType = {}));
/**
 * @since 3.16.0
 */
var SemanticTokensRequest;
(function (SemanticTokensRequest) {
    SemanticTokensRequest.method = 'textDocument/semanticTokens/full';
    SemanticTokensRequest.type = new messages$1.ProtocolRequestType(SemanticTokensRequest.method);
})(SemanticTokensRequest = exports.SemanticTokensRequest || (exports.SemanticTokensRequest = {}));
/**
 * @since 3.16.0
 */
var SemanticTokensDeltaRequest;
(function (SemanticTokensDeltaRequest) {
    SemanticTokensDeltaRequest.method = 'textDocument/semanticTokens/full/delta';
    SemanticTokensDeltaRequest.type = new messages$1.ProtocolRequestType(SemanticTokensDeltaRequest.method);
})(SemanticTokensDeltaRequest = exports.SemanticTokensDeltaRequest || (exports.SemanticTokensDeltaRequest = {}));
/**
 * @since 3.16.0
 */
var SemanticTokensRangeRequest;
(function (SemanticTokensRangeRequest) {
    SemanticTokensRangeRequest.method = 'textDocument/semanticTokens/range';
    SemanticTokensRangeRequest.type = new messages$1.ProtocolRequestType(SemanticTokensRangeRequest.method);
})(SemanticTokensRangeRequest = exports.SemanticTokensRangeRequest || (exports.SemanticTokensRangeRequest = {}));
/**
 * @since 3.16.0
 */
var SemanticTokensRefreshRequest;
(function (SemanticTokensRefreshRequest) {
    SemanticTokensRefreshRequest.method = `workspace/semanticTokens/refresh`;
    SemanticTokensRefreshRequest.type = new messages$1.ProtocolRequestType0(SemanticTokensRefreshRequest.method);
})(SemanticTokensRefreshRequest = exports.SemanticTokensRefreshRequest || (exports.SemanticTokensRefreshRequest = {}));

});

var protocol_showDocument = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShowDocumentRequest = void 0;

/**
 * A request to show a document. This request might open an
 * external program depending on the value of the URI to open.
 * For example a request to open `https://code.visualstudio.com/`
 * will very likely open the URI in a WEB browser.
 *
 * @since 3.16.0
*/
var ShowDocumentRequest;
(function (ShowDocumentRequest) {
    ShowDocumentRequest.method = 'window/showDocument';
    ShowDocumentRequest.type = new messages$1.ProtocolRequestType(ShowDocumentRequest.method);
})(ShowDocumentRequest = exports.ShowDocumentRequest || (exports.ShowDocumentRequest = {}));

});

var protocol_linkedEditingRange = createCommonjsModule(function (module, exports) {
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkedEditingRangeRequest = void 0;

/**
 * A request to provide ranges that can be edited together.
 *
 * @since 3.16.0
 */
var LinkedEditingRangeRequest;
(function (LinkedEditingRangeRequest) {
    LinkedEditingRangeRequest.method = 'textDocument/linkedEditingRange';
    LinkedEditingRangeRequest.type = new messages$1.ProtocolRequestType(LinkedEditingRangeRequest.method);
})(LinkedEditingRangeRequest = exports.LinkedEditingRangeRequest || (exports.LinkedEditingRangeRequest = {}));

});

var protocol_fileOperations = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.WillDeleteFilesRequest = exports.DidDeleteFilesNotification = exports.DidRenameFilesNotification = exports.WillRenameFilesRequest = exports.DidCreateFilesNotification = exports.WillCreateFilesRequest = exports.FileOperationPatternKind = void 0;

/**
 * A pattern kind describing if a glob pattern matches a file a folder or
 * both.
 *
 * @since 3.16.0
 */
var FileOperationPatternKind;
(function (FileOperationPatternKind) {
    /**
     * The pattern matches a file only.
     */
    FileOperationPatternKind.file = 'file';
    /**
     * The pattern matches a folder only.
     */
    FileOperationPatternKind.folder = 'folder';
})(FileOperationPatternKind = exports.FileOperationPatternKind || (exports.FileOperationPatternKind = {}));
/**
 * The will create files request is sent from the client to the server before files are actually
 * created as long as the creation is triggered from within the client.
 *
 * @since 3.16.0
 */
var WillCreateFilesRequest;
(function (WillCreateFilesRequest) {
    WillCreateFilesRequest.method = 'workspace/willCreateFiles';
    WillCreateFilesRequest.type = new messages$1.ProtocolRequestType(WillCreateFilesRequest.method);
})(WillCreateFilesRequest = exports.WillCreateFilesRequest || (exports.WillCreateFilesRequest = {}));
/**
 * The did create files notification is sent from the client to the server when
 * files were created from within the client.
 *
 * @since 3.16.0
 */
var DidCreateFilesNotification;
(function (DidCreateFilesNotification) {
    DidCreateFilesNotification.method = 'workspace/didCreateFiles';
    DidCreateFilesNotification.type = new messages$1.ProtocolNotificationType(DidCreateFilesNotification.method);
})(DidCreateFilesNotification = exports.DidCreateFilesNotification || (exports.DidCreateFilesNotification = {}));
/**
 * The will rename files request is sent from the client to the server before files are actually
 * renamed as long as the rename is triggered from within the client.
 *
 * @since 3.16.0
 */
var WillRenameFilesRequest;
(function (WillRenameFilesRequest) {
    WillRenameFilesRequest.method = 'workspace/willRenameFiles';
    WillRenameFilesRequest.type = new messages$1.ProtocolRequestType(WillRenameFilesRequest.method);
})(WillRenameFilesRequest = exports.WillRenameFilesRequest || (exports.WillRenameFilesRequest = {}));
/**
 * The did rename files notification is sent from the client to the server when
 * files were renamed from within the client.
 *
 * @since 3.16.0
 */
var DidRenameFilesNotification;
(function (DidRenameFilesNotification) {
    DidRenameFilesNotification.method = 'workspace/didRenameFiles';
    DidRenameFilesNotification.type = new messages$1.ProtocolNotificationType(DidRenameFilesNotification.method);
})(DidRenameFilesNotification = exports.DidRenameFilesNotification || (exports.DidRenameFilesNotification = {}));
/**
 * The will delete files request is sent from the client to the server before files are actually
 * deleted as long as the deletion is triggered from within the client.
 *
 * @since 3.16.0
 */
var DidDeleteFilesNotification;
(function (DidDeleteFilesNotification) {
    DidDeleteFilesNotification.method = 'workspace/didDeleteFiles';
    DidDeleteFilesNotification.type = new messages$1.ProtocolNotificationType(DidDeleteFilesNotification.method);
})(DidDeleteFilesNotification = exports.DidDeleteFilesNotification || (exports.DidDeleteFilesNotification = {}));
/**
 * The did delete files notification is sent from the client to the server when
 * files were deleted from within the client.
 *
 * @since 3.16.0
 */
var WillDeleteFilesRequest;
(function (WillDeleteFilesRequest) {
    WillDeleteFilesRequest.method = 'workspace/willDeleteFiles';
    WillDeleteFilesRequest.type = new messages$1.ProtocolRequestType(WillDeleteFilesRequest.method);
})(WillDeleteFilesRequest = exports.WillDeleteFilesRequest || (exports.WillDeleteFilesRequest = {}));

});

var protocol_moniker = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.MonikerRequest = exports.MonikerKind = exports.UniquenessLevel = void 0;

/**
 * Moniker uniqueness level to define scope of the moniker.
 *
 * @since 3.16.0
 */
var UniquenessLevel;
(function (UniquenessLevel) {
    /**
     * The moniker is only unique inside a document
     */
    UniquenessLevel["document"] = "document";
    /**
     * The moniker is unique inside a project for which a dump got created
     */
    UniquenessLevel["project"] = "project";
    /**
     * The moniker is unique inside the group to which a project belongs
     */
    UniquenessLevel["group"] = "group";
    /**
     * The moniker is unique inside the moniker scheme.
     */
    UniquenessLevel["scheme"] = "scheme";
    /**
     * The moniker is globally unique
     */
    UniquenessLevel["global"] = "global";
})(UniquenessLevel = exports.UniquenessLevel || (exports.UniquenessLevel = {}));
/**
 * The moniker kind.
 *
 * @since 3.16.0
 */
var MonikerKind;
(function (MonikerKind) {
    /**
     * The moniker represent a symbol that is imported into a project
     */
    MonikerKind["import"] = "import";
    /**
     * The moniker represents a symbol that is exported from a project
     */
    MonikerKind["export"] = "export";
    /**
     * The moniker represents a symbol that is local to a project (e.g. a local
     * variable of a function, a class not visible outside the project, ...)
     */
    MonikerKind["local"] = "local";
})(MonikerKind = exports.MonikerKind || (exports.MonikerKind = {}));
/**
 * A request to get the moniker of a symbol at a given text document position.
 * The request parameter is of type [TextDocumentPositionParams](#TextDocumentPositionParams).
 * The response is of type [Moniker[]](#Moniker[]) or `null`.
 */
var MonikerRequest;
(function (MonikerRequest) {
    MonikerRequest.method = 'textDocument/moniker';
    MonikerRequest.type = new messages$1.ProtocolRequestType(MonikerRequest.method);
})(MonikerRequest = exports.MonikerRequest || (exports.MonikerRequest = {}));

});

var protocol = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.DocumentLinkRequest = exports.CodeLensRefreshRequest = exports.CodeLensResolveRequest = exports.CodeLensRequest = exports.WorkspaceSymbolRequest = exports.CodeActionResolveRequest = exports.CodeActionRequest = exports.DocumentSymbolRequest = exports.DocumentHighlightRequest = exports.ReferencesRequest = exports.DefinitionRequest = exports.SignatureHelpRequest = exports.SignatureHelpTriggerKind = exports.HoverRequest = exports.CompletionResolveRequest = exports.CompletionRequest = exports.CompletionTriggerKind = exports.PublishDiagnosticsNotification = exports.WatchKind = exports.FileChangeType = exports.DidChangeWatchedFilesNotification = exports.WillSaveTextDocumentWaitUntilRequest = exports.WillSaveTextDocumentNotification = exports.TextDocumentSaveReason = exports.DidSaveTextDocumentNotification = exports.DidCloseTextDocumentNotification = exports.DidChangeTextDocumentNotification = exports.TextDocumentContentChangeEvent = exports.DidOpenTextDocumentNotification = exports.TextDocumentSyncKind = exports.TelemetryEventNotification = exports.LogMessageNotification = exports.ShowMessageRequest = exports.ShowMessageNotification = exports.MessageType = exports.DidChangeConfigurationNotification = exports.ExitNotification = exports.ShutdownRequest = exports.InitializedNotification = exports.InitializeError = exports.InitializeRequest = exports.WorkDoneProgressOptions = exports.TextDocumentRegistrationOptions = exports.StaticRegistrationOptions = exports.FailureHandlingKind = exports.ResourceOperationKind = exports.UnregistrationRequest = exports.RegistrationRequest = exports.DocumentSelector = exports.DocumentFilter = void 0;
exports.MonikerRequest = exports.MonikerKind = exports.UniquenessLevel = exports.WillDeleteFilesRequest = exports.DidDeleteFilesNotification = exports.WillRenameFilesRequest = exports.DidRenameFilesNotification = exports.WillCreateFilesRequest = exports.DidCreateFilesNotification = exports.FileOperationPatternKind = exports.LinkedEditingRangeRequest = exports.ShowDocumentRequest = exports.SemanticTokensRegistrationType = exports.SemanticTokensRefreshRequest = exports.SemanticTokensRangeRequest = exports.SemanticTokensDeltaRequest = exports.SemanticTokensRequest = exports.TokenFormat = exports.SemanticTokens = exports.SemanticTokenModifiers = exports.SemanticTokenTypes = exports.CallHierarchyPrepareRequest = exports.CallHierarchyOutgoingCallsRequest = exports.CallHierarchyIncomingCallsRequest = exports.WorkDoneProgressCancelNotification = exports.WorkDoneProgressCreateRequest = exports.WorkDoneProgress = exports.SelectionRangeRequest = exports.DeclarationRequest = exports.FoldingRangeRequest = exports.ColorPresentationRequest = exports.DocumentColorRequest = exports.ConfigurationRequest = exports.DidChangeWorkspaceFoldersNotification = exports.WorkspaceFoldersRequest = exports.TypeDefinitionRequest = exports.ImplementationRequest = exports.ApplyWorkspaceEditRequest = exports.ExecuteCommandRequest = exports.PrepareRenameRequest = exports.RenameRequest = exports.PrepareSupportDefaultBehavior = exports.DocumentOnTypeFormattingRequest = exports.DocumentRangeFormattingRequest = exports.DocumentFormattingRequest = exports.DocumentLinkResolveRequest = void 0;



Object.defineProperty(exports, "ImplementationRequest", { enumerable: true, get: function () { return protocol_implementation.ImplementationRequest; } });

Object.defineProperty(exports, "TypeDefinitionRequest", { enumerable: true, get: function () { return protocol_typeDefinition.TypeDefinitionRequest; } });

Object.defineProperty(exports, "WorkspaceFoldersRequest", { enumerable: true, get: function () { return protocol_workspaceFolders.WorkspaceFoldersRequest; } });
Object.defineProperty(exports, "DidChangeWorkspaceFoldersNotification", { enumerable: true, get: function () { return protocol_workspaceFolders.DidChangeWorkspaceFoldersNotification; } });

Object.defineProperty(exports, "ConfigurationRequest", { enumerable: true, get: function () { return protocol_configuration.ConfigurationRequest; } });

Object.defineProperty(exports, "DocumentColorRequest", { enumerable: true, get: function () { return protocol_colorProvider.DocumentColorRequest; } });
Object.defineProperty(exports, "ColorPresentationRequest", { enumerable: true, get: function () { return protocol_colorProvider.ColorPresentationRequest; } });

Object.defineProperty(exports, "FoldingRangeRequest", { enumerable: true, get: function () { return protocol_foldingRange.FoldingRangeRequest; } });

Object.defineProperty(exports, "DeclarationRequest", { enumerable: true, get: function () { return protocol_declaration.DeclarationRequest; } });

Object.defineProperty(exports, "SelectionRangeRequest", { enumerable: true, get: function () { return protocol_selectionRange.SelectionRangeRequest; } });

Object.defineProperty(exports, "WorkDoneProgress", { enumerable: true, get: function () { return protocol_progress.WorkDoneProgress; } });
Object.defineProperty(exports, "WorkDoneProgressCreateRequest", { enumerable: true, get: function () { return protocol_progress.WorkDoneProgressCreateRequest; } });
Object.defineProperty(exports, "WorkDoneProgressCancelNotification", { enumerable: true, get: function () { return protocol_progress.WorkDoneProgressCancelNotification; } });

Object.defineProperty(exports, "CallHierarchyIncomingCallsRequest", { enumerable: true, get: function () { return protocol_callHierarchy.CallHierarchyIncomingCallsRequest; } });
Object.defineProperty(exports, "CallHierarchyOutgoingCallsRequest", { enumerable: true, get: function () { return protocol_callHierarchy.CallHierarchyOutgoingCallsRequest; } });
Object.defineProperty(exports, "CallHierarchyPrepareRequest", { enumerable: true, get: function () { return protocol_callHierarchy.CallHierarchyPrepareRequest; } });

Object.defineProperty(exports, "SemanticTokenTypes", { enumerable: true, get: function () { return protocol_semanticTokens.SemanticTokenTypes; } });
Object.defineProperty(exports, "SemanticTokenModifiers", { enumerable: true, get: function () { return protocol_semanticTokens.SemanticTokenModifiers; } });
Object.defineProperty(exports, "SemanticTokens", { enumerable: true, get: function () { return protocol_semanticTokens.SemanticTokens; } });
Object.defineProperty(exports, "TokenFormat", { enumerable: true, get: function () { return protocol_semanticTokens.TokenFormat; } });
Object.defineProperty(exports, "SemanticTokensRequest", { enumerable: true, get: function () { return protocol_semanticTokens.SemanticTokensRequest; } });
Object.defineProperty(exports, "SemanticTokensDeltaRequest", { enumerable: true, get: function () { return protocol_semanticTokens.SemanticTokensDeltaRequest; } });
Object.defineProperty(exports, "SemanticTokensRangeRequest", { enumerable: true, get: function () { return protocol_semanticTokens.SemanticTokensRangeRequest; } });
Object.defineProperty(exports, "SemanticTokensRefreshRequest", { enumerable: true, get: function () { return protocol_semanticTokens.SemanticTokensRefreshRequest; } });
Object.defineProperty(exports, "SemanticTokensRegistrationType", { enumerable: true, get: function () { return protocol_semanticTokens.SemanticTokensRegistrationType; } });

Object.defineProperty(exports, "ShowDocumentRequest", { enumerable: true, get: function () { return protocol_showDocument.ShowDocumentRequest; } });

Object.defineProperty(exports, "LinkedEditingRangeRequest", { enumerable: true, get: function () { return protocol_linkedEditingRange.LinkedEditingRangeRequest; } });

Object.defineProperty(exports, "FileOperationPatternKind", { enumerable: true, get: function () { return protocol_fileOperations.FileOperationPatternKind; } });
Object.defineProperty(exports, "DidCreateFilesNotification", { enumerable: true, get: function () { return protocol_fileOperations.DidCreateFilesNotification; } });
Object.defineProperty(exports, "WillCreateFilesRequest", { enumerable: true, get: function () { return protocol_fileOperations.WillCreateFilesRequest; } });
Object.defineProperty(exports, "DidRenameFilesNotification", { enumerable: true, get: function () { return protocol_fileOperations.DidRenameFilesNotification; } });
Object.defineProperty(exports, "WillRenameFilesRequest", { enumerable: true, get: function () { return protocol_fileOperations.WillRenameFilesRequest; } });
Object.defineProperty(exports, "DidDeleteFilesNotification", { enumerable: true, get: function () { return protocol_fileOperations.DidDeleteFilesNotification; } });
Object.defineProperty(exports, "WillDeleteFilesRequest", { enumerable: true, get: function () { return protocol_fileOperations.WillDeleteFilesRequest; } });

Object.defineProperty(exports, "UniquenessLevel", { enumerable: true, get: function () { return protocol_moniker.UniquenessLevel; } });
Object.defineProperty(exports, "MonikerKind", { enumerable: true, get: function () { return protocol_moniker.MonikerKind; } });
Object.defineProperty(exports, "MonikerRequest", { enumerable: true, get: function () { return protocol_moniker.MonikerRequest; } });
/**
 * The DocumentFilter namespace provides helper functions to work with
 * [DocumentFilter](#DocumentFilter) literals.
 */
var DocumentFilter;
(function (DocumentFilter) {
    function is(value) {
        const candidate = value;
        return is$2.string(candidate.language) || is$2.string(candidate.scheme) || is$2.string(candidate.pattern);
    }
    DocumentFilter.is = is;
})(DocumentFilter = exports.DocumentFilter || (exports.DocumentFilter = {}));
/**
 * The DocumentSelector namespace provides helper functions to work with
 * [DocumentSelector](#DocumentSelector)s.
 */
var DocumentSelector;
(function (DocumentSelector) {
    function is(value) {
        if (!Array.isArray(value)) {
            return false;
        }
        for (let elem of value) {
            if (!is$2.string(elem) && !DocumentFilter.is(elem)) {
                return false;
            }
        }
        return true;
    }
    DocumentSelector.is = is;
})(DocumentSelector = exports.DocumentSelector || (exports.DocumentSelector = {}));
/**
 * The `client/registerCapability` request is sent from the server to the client to register a new capability
 * handler on the client side.
 */
var RegistrationRequest;
(function (RegistrationRequest) {
    RegistrationRequest.type = new messages$1.ProtocolRequestType('client/registerCapability');
})(RegistrationRequest = exports.RegistrationRequest || (exports.RegistrationRequest = {}));
/**
 * The `client/unregisterCapability` request is sent from the server to the client to unregister a previously registered capability
 * handler on the client side.
 */
var UnregistrationRequest;
(function (UnregistrationRequest) {
    UnregistrationRequest.type = new messages$1.ProtocolRequestType('client/unregisterCapability');
})(UnregistrationRequest = exports.UnregistrationRequest || (exports.UnregistrationRequest = {}));
var ResourceOperationKind;
(function (ResourceOperationKind) {
    /**
     * Supports creating new files and folders.
     */
    ResourceOperationKind.Create = 'create';
    /**
     * Supports renaming existing files and folders.
     */
    ResourceOperationKind.Rename = 'rename';
    /**
     * Supports deleting existing files and folders.
     */
    ResourceOperationKind.Delete = 'delete';
})(ResourceOperationKind = exports.ResourceOperationKind || (exports.ResourceOperationKind = {}));
var FailureHandlingKind;
(function (FailureHandlingKind) {
    /**
     * Applying the workspace change is simply aborted if one of the changes provided
     * fails. All operations executed before the failing operation stay executed.
     */
    FailureHandlingKind.Abort = 'abort';
    /**
     * All operations are executed transactional. That means they either all
     * succeed or no changes at all are applied to the workspace.
     */
    FailureHandlingKind.Transactional = 'transactional';
    /**
     * If the workspace edit contains only textual file changes they are executed transactional.
     * If resource changes (create, rename or delete file) are part of the change the failure
     * handling strategy is abort.
     */
    FailureHandlingKind.TextOnlyTransactional = 'textOnlyTransactional';
    /**
     * The client tries to undo the operations already executed. But there is no
     * guarantee that this is succeeding.
     */
    FailureHandlingKind.Undo = 'undo';
})(FailureHandlingKind = exports.FailureHandlingKind || (exports.FailureHandlingKind = {}));
/**
 * The StaticRegistrationOptions namespace provides helper functions to work with
 * [StaticRegistrationOptions](#StaticRegistrationOptions) literals.
 */
var StaticRegistrationOptions;
(function (StaticRegistrationOptions) {
    function hasId(value) {
        const candidate = value;
        return candidate && is$2.string(candidate.id) && candidate.id.length > 0;
    }
    StaticRegistrationOptions.hasId = hasId;
})(StaticRegistrationOptions = exports.StaticRegistrationOptions || (exports.StaticRegistrationOptions = {}));
/**
 * The TextDocumentRegistrationOptions namespace provides helper functions to work with
 * [TextDocumentRegistrationOptions](#TextDocumentRegistrationOptions) literals.
 */
var TextDocumentRegistrationOptions;
(function (TextDocumentRegistrationOptions) {
    function is(value) {
        const candidate = value;
        return candidate && (candidate.documentSelector === null || DocumentSelector.is(candidate.documentSelector));
    }
    TextDocumentRegistrationOptions.is = is;
})(TextDocumentRegistrationOptions = exports.TextDocumentRegistrationOptions || (exports.TextDocumentRegistrationOptions = {}));
/**
 * The WorkDoneProgressOptions namespace provides helper functions to work with
 * [WorkDoneProgressOptions](#WorkDoneProgressOptions) literals.
 */
var WorkDoneProgressOptions;
(function (WorkDoneProgressOptions) {
    function is(value) {
        const candidate = value;
        return is$2.objectLiteral(candidate) && (candidate.workDoneProgress === undefined || is$2.boolean(candidate.workDoneProgress));
    }
    WorkDoneProgressOptions.is = is;
    function hasWorkDoneProgress(value) {
        const candidate = value;
        return candidate && is$2.boolean(candidate.workDoneProgress);
    }
    WorkDoneProgressOptions.hasWorkDoneProgress = hasWorkDoneProgress;
})(WorkDoneProgressOptions = exports.WorkDoneProgressOptions || (exports.WorkDoneProgressOptions = {}));
/**
 * The initialize request is sent from the client to the server.
 * It is sent once as the request after starting up the server.
 * The requests parameter is of type [InitializeParams](#InitializeParams)
 * the response if of type [InitializeResult](#InitializeResult) of a Thenable that
 * resolves to such.
 */
var InitializeRequest;
(function (InitializeRequest) {
    InitializeRequest.type = new messages$1.ProtocolRequestType('initialize');
})(InitializeRequest = exports.InitializeRequest || (exports.InitializeRequest = {}));
/**
 * Known error codes for an `InitializeError`;
 */
var InitializeError;
(function (InitializeError) {
    /**
     * If the protocol version provided by the client can't be handled by the server.
     * @deprecated This initialize error got replaced by client capabilities. There is
     * no version handshake in version 3.0x
     */
    InitializeError.unknownProtocolVersion = 1;
})(InitializeError = exports.InitializeError || (exports.InitializeError = {}));
/**
 * The initialized notification is sent from the client to the
 * server after the client is fully initialized and the server
 * is allowed to send requests from the server to the client.
 */
var InitializedNotification;
(function (InitializedNotification) {
    InitializedNotification.type = new messages$1.ProtocolNotificationType('initialized');
})(InitializedNotification = exports.InitializedNotification || (exports.InitializedNotification = {}));
//---- Shutdown Method ----
/**
 * A shutdown request is sent from the client to the server.
 * It is sent once when the client decides to shutdown the
 * server. The only notification that is sent after a shutdown request
 * is the exit event.
 */
var ShutdownRequest;
(function (ShutdownRequest) {
    ShutdownRequest.type = new messages$1.ProtocolRequestType0('shutdown');
})(ShutdownRequest = exports.ShutdownRequest || (exports.ShutdownRequest = {}));
//---- Exit Notification ----
/**
 * The exit event is sent from the client to the server to
 * ask the server to exit its process.
 */
var ExitNotification;
(function (ExitNotification) {
    ExitNotification.type = new messages$1.ProtocolNotificationType0('exit');
})(ExitNotification = exports.ExitNotification || (exports.ExitNotification = {}));
/**
 * The configuration change notification is sent from the client to the server
 * when the client's configuration has changed. The notification contains
 * the changed configuration as defined by the language client.
 */
var DidChangeConfigurationNotification;
(function (DidChangeConfigurationNotification) {
    DidChangeConfigurationNotification.type = new messages$1.ProtocolNotificationType('workspace/didChangeConfiguration');
})(DidChangeConfigurationNotification = exports.DidChangeConfigurationNotification || (exports.DidChangeConfigurationNotification = {}));
//---- Message show and log notifications ----
/**
 * The message type
 */
var MessageType;
(function (MessageType) {
    /**
     * An error message.
     */
    MessageType.Error = 1;
    /**
     * A warning message.
     */
    MessageType.Warning = 2;
    /**
     * An information message.
     */
    MessageType.Info = 3;
    /**
     * A log message.
     */
    MessageType.Log = 4;
})(MessageType = exports.MessageType || (exports.MessageType = {}));
/**
 * The show message notification is sent from a server to a client to ask
 * the client to display a particular message in the user interface.
 */
var ShowMessageNotification;
(function (ShowMessageNotification) {
    ShowMessageNotification.type = new messages$1.ProtocolNotificationType('window/showMessage');
})(ShowMessageNotification = exports.ShowMessageNotification || (exports.ShowMessageNotification = {}));
/**
 * The show message request is sent from the server to the client to show a message
 * and a set of options actions to the user.
 */
var ShowMessageRequest;
(function (ShowMessageRequest) {
    ShowMessageRequest.type = new messages$1.ProtocolRequestType('window/showMessageRequest');
})(ShowMessageRequest = exports.ShowMessageRequest || (exports.ShowMessageRequest = {}));
/**
 * The log message notification is sent from the server to the client to ask
 * the client to log a particular message.
 */
var LogMessageNotification;
(function (LogMessageNotification) {
    LogMessageNotification.type = new messages$1.ProtocolNotificationType('window/logMessage');
})(LogMessageNotification = exports.LogMessageNotification || (exports.LogMessageNotification = {}));
//---- Telemetry notification
/**
 * The telemetry event notification is sent from the server to the client to ask
 * the client to log telemetry data.
 */
var TelemetryEventNotification;
(function (TelemetryEventNotification) {
    TelemetryEventNotification.type = new messages$1.ProtocolNotificationType('telemetry/event');
})(TelemetryEventNotification = exports.TelemetryEventNotification || (exports.TelemetryEventNotification = {}));
/**
 * Defines how the host (editor) should sync
 * document changes to the language server.
 */
var TextDocumentSyncKind;
(function (TextDocumentSyncKind) {
    /**
     * Documents should not be synced at all.
     */
    TextDocumentSyncKind.None = 0;
    /**
     * Documents are synced by always sending the full content
     * of the document.
     */
    TextDocumentSyncKind.Full = 1;
    /**
     * Documents are synced by sending the full content on open.
     * After that only incremental updates to the document are
     * send.
     */
    TextDocumentSyncKind.Incremental = 2;
})(TextDocumentSyncKind = exports.TextDocumentSyncKind || (exports.TextDocumentSyncKind = {}));
/**
 * The document open notification is sent from the client to the server to signal
 * newly opened text documents. The document's truth is now managed by the client
 * and the server must not try to read the document's truth using the document's
 * uri. Open in this sense means it is managed by the client. It doesn't necessarily
 * mean that its content is presented in an editor. An open notification must not
 * be sent more than once without a corresponding close notification send before.
 * This means open and close notification must be balanced and the max open count
 * is one.
 */
var DidOpenTextDocumentNotification;
(function (DidOpenTextDocumentNotification) {
    DidOpenTextDocumentNotification.method = 'textDocument/didOpen';
    DidOpenTextDocumentNotification.type = new messages$1.ProtocolNotificationType(DidOpenTextDocumentNotification.method);
})(DidOpenTextDocumentNotification = exports.DidOpenTextDocumentNotification || (exports.DidOpenTextDocumentNotification = {}));
var TextDocumentContentChangeEvent;
(function (TextDocumentContentChangeEvent) {
    /**
     * Checks whether the information describes a delta event.
     */
    function isIncremental(event) {
        let candidate = event;
        return candidate !== undefined && candidate !== null &&
            typeof candidate.text === 'string' && candidate.range !== undefined &&
            (candidate.rangeLength === undefined || typeof candidate.rangeLength === 'number');
    }
    TextDocumentContentChangeEvent.isIncremental = isIncremental;
    /**
     * Checks whether the information describes a full replacement event.
     */
    function isFull(event) {
        let candidate = event;
        return candidate !== undefined && candidate !== null &&
            typeof candidate.text === 'string' && candidate.range === undefined && candidate.rangeLength === undefined;
    }
    TextDocumentContentChangeEvent.isFull = isFull;
})(TextDocumentContentChangeEvent = exports.TextDocumentContentChangeEvent || (exports.TextDocumentContentChangeEvent = {}));
/**
 * The document change notification is sent from the client to the server to signal
 * changes to a text document.
 */
var DidChangeTextDocumentNotification;
(function (DidChangeTextDocumentNotification) {
    DidChangeTextDocumentNotification.method = 'textDocument/didChange';
    DidChangeTextDocumentNotification.type = new messages$1.ProtocolNotificationType(DidChangeTextDocumentNotification.method);
})(DidChangeTextDocumentNotification = exports.DidChangeTextDocumentNotification || (exports.DidChangeTextDocumentNotification = {}));
/**
 * The document close notification is sent from the client to the server when
 * the document got closed in the client. The document's truth now exists where
 * the document's uri points to (e.g. if the document's uri is a file uri the
 * truth now exists on disk). As with the open notification the close notification
 * is about managing the document's content. Receiving a close notification
 * doesn't mean that the document was open in an editor before. A close
 * notification requires a previous open notification to be sent.
 */
var DidCloseTextDocumentNotification;
(function (DidCloseTextDocumentNotification) {
    DidCloseTextDocumentNotification.method = 'textDocument/didClose';
    DidCloseTextDocumentNotification.type = new messages$1.ProtocolNotificationType(DidCloseTextDocumentNotification.method);
})(DidCloseTextDocumentNotification = exports.DidCloseTextDocumentNotification || (exports.DidCloseTextDocumentNotification = {}));
/**
 * The document save notification is sent from the client to the server when
 * the document got saved in the client.
 */
var DidSaveTextDocumentNotification;
(function (DidSaveTextDocumentNotification) {
    DidSaveTextDocumentNotification.method = 'textDocument/didSave';
    DidSaveTextDocumentNotification.type = new messages$1.ProtocolNotificationType(DidSaveTextDocumentNotification.method);
})(DidSaveTextDocumentNotification = exports.DidSaveTextDocumentNotification || (exports.DidSaveTextDocumentNotification = {}));
/**
 * Represents reasons why a text document is saved.
 */
var TextDocumentSaveReason;
(function (TextDocumentSaveReason) {
    /**
     * Manually triggered, e.g. by the user pressing save, by starting debugging,
     * or by an API call.
     */
    TextDocumentSaveReason.Manual = 1;
    /**
     * Automatic after a delay.
     */
    TextDocumentSaveReason.AfterDelay = 2;
    /**
     * When the editor lost focus.
     */
    TextDocumentSaveReason.FocusOut = 3;
})(TextDocumentSaveReason = exports.TextDocumentSaveReason || (exports.TextDocumentSaveReason = {}));
/**
 * A document will save notification is sent from the client to the server before
 * the document is actually saved.
 */
var WillSaveTextDocumentNotification;
(function (WillSaveTextDocumentNotification) {
    WillSaveTextDocumentNotification.method = 'textDocument/willSave';
    WillSaveTextDocumentNotification.type = new messages$1.ProtocolNotificationType(WillSaveTextDocumentNotification.method);
})(WillSaveTextDocumentNotification = exports.WillSaveTextDocumentNotification || (exports.WillSaveTextDocumentNotification = {}));
/**
 * A document will save request is sent from the client to the server before
 * the document is actually saved. The request can return an array of TextEdits
 * which will be applied to the text document before it is saved. Please note that
 * clients might drop results if computing the text edits took too long or if a
 * server constantly fails on this request. This is done to keep the save fast and
 * reliable.
 */
var WillSaveTextDocumentWaitUntilRequest;
(function (WillSaveTextDocumentWaitUntilRequest) {
    WillSaveTextDocumentWaitUntilRequest.method = 'textDocument/willSaveWaitUntil';
    WillSaveTextDocumentWaitUntilRequest.type = new messages$1.ProtocolRequestType(WillSaveTextDocumentWaitUntilRequest.method);
})(WillSaveTextDocumentWaitUntilRequest = exports.WillSaveTextDocumentWaitUntilRequest || (exports.WillSaveTextDocumentWaitUntilRequest = {}));
/**
 * The watched files notification is sent from the client to the server when
 * the client detects changes to file watched by the language client.
 */
var DidChangeWatchedFilesNotification;
(function (DidChangeWatchedFilesNotification) {
    DidChangeWatchedFilesNotification.type = new messages$1.ProtocolNotificationType('workspace/didChangeWatchedFiles');
})(DidChangeWatchedFilesNotification = exports.DidChangeWatchedFilesNotification || (exports.DidChangeWatchedFilesNotification = {}));
/**
 * The file event type
 */
var FileChangeType;
(function (FileChangeType) {
    /**
     * The file got created.
     */
    FileChangeType.Created = 1;
    /**
     * The file got changed.
     */
    FileChangeType.Changed = 2;
    /**
     * The file got deleted.
     */
    FileChangeType.Deleted = 3;
})(FileChangeType = exports.FileChangeType || (exports.FileChangeType = {}));
var WatchKind;
(function (WatchKind) {
    /**
     * Interested in create events.
     */
    WatchKind.Create = 1;
    /**
     * Interested in change events
     */
    WatchKind.Change = 2;
    /**
     * Interested in delete events
     */
    WatchKind.Delete = 4;
})(WatchKind = exports.WatchKind || (exports.WatchKind = {}));
/**
 * Diagnostics notification are sent from the server to the client to signal
 * results of validation runs.
 */
var PublishDiagnosticsNotification;
(function (PublishDiagnosticsNotification) {
    PublishDiagnosticsNotification.type = new messages$1.ProtocolNotificationType('textDocument/publishDiagnostics');
})(PublishDiagnosticsNotification = exports.PublishDiagnosticsNotification || (exports.PublishDiagnosticsNotification = {}));
/**
 * How a completion was triggered
 */
var CompletionTriggerKind;
(function (CompletionTriggerKind) {
    /**
     * Completion was triggered by typing an identifier (24x7 code
     * complete), manual invocation (e.g Ctrl+Space) or via API.
     */
    CompletionTriggerKind.Invoked = 1;
    /**
     * Completion was triggered by a trigger character specified by
     * the `triggerCharacters` properties of the `CompletionRegistrationOptions`.
     */
    CompletionTriggerKind.TriggerCharacter = 2;
    /**
     * Completion was re-triggered as current completion list is incomplete
     */
    CompletionTriggerKind.TriggerForIncompleteCompletions = 3;
})(CompletionTriggerKind = exports.CompletionTriggerKind || (exports.CompletionTriggerKind = {}));
/**
 * Request to request completion at a given text document position. The request's
 * parameter is of type [TextDocumentPosition](#TextDocumentPosition) the response
 * is of type [CompletionItem[]](#CompletionItem) or [CompletionList](#CompletionList)
 * or a Thenable that resolves to such.
 *
 * The request can delay the computation of the [`detail`](#CompletionItem.detail)
 * and [`documentation`](#CompletionItem.documentation) properties to the `completionItem/resolve`
 * request. However, properties that are needed for the initial sorting and filtering, like `sortText`,
 * `filterText`, `insertText`, and `textEdit`, must not be changed during resolve.
 */
var CompletionRequest;
(function (CompletionRequest) {
    CompletionRequest.method = 'textDocument/completion';
    CompletionRequest.type = new messages$1.ProtocolRequestType(CompletionRequest.method);
})(CompletionRequest = exports.CompletionRequest || (exports.CompletionRequest = {}));
/**
 * Request to resolve additional information for a given completion item.The request's
 * parameter is of type [CompletionItem](#CompletionItem) the response
 * is of type [CompletionItem](#CompletionItem) or a Thenable that resolves to such.
 */
var CompletionResolveRequest;
(function (CompletionResolveRequest) {
    CompletionResolveRequest.method = 'completionItem/resolve';
    CompletionResolveRequest.type = new messages$1.ProtocolRequestType(CompletionResolveRequest.method);
})(CompletionResolveRequest = exports.CompletionResolveRequest || (exports.CompletionResolveRequest = {}));
/**
 * Request to request hover information at a given text document position. The request's
 * parameter is of type [TextDocumentPosition](#TextDocumentPosition) the response is of
 * type [Hover](#Hover) or a Thenable that resolves to such.
 */
var HoverRequest;
(function (HoverRequest) {
    HoverRequest.method = 'textDocument/hover';
    HoverRequest.type = new messages$1.ProtocolRequestType(HoverRequest.method);
})(HoverRequest = exports.HoverRequest || (exports.HoverRequest = {}));
/**
 * How a signature help was triggered.
 *
 * @since 3.15.0
 */
var SignatureHelpTriggerKind;
(function (SignatureHelpTriggerKind) {
    /**
     * Signature help was invoked manually by the user or by a command.
     */
    SignatureHelpTriggerKind.Invoked = 1;
    /**
     * Signature help was triggered by a trigger character.
     */
    SignatureHelpTriggerKind.TriggerCharacter = 2;
    /**
     * Signature help was triggered by the cursor moving or by the document content changing.
     */
    SignatureHelpTriggerKind.ContentChange = 3;
})(SignatureHelpTriggerKind = exports.SignatureHelpTriggerKind || (exports.SignatureHelpTriggerKind = {}));
var SignatureHelpRequest;
(function (SignatureHelpRequest) {
    SignatureHelpRequest.method = 'textDocument/signatureHelp';
    SignatureHelpRequest.type = new messages$1.ProtocolRequestType(SignatureHelpRequest.method);
})(SignatureHelpRequest = exports.SignatureHelpRequest || (exports.SignatureHelpRequest = {}));
/**
 * A request to resolve the definition location of a symbol at a given text
 * document position. The request's parameter is of type [TextDocumentPosition]
 * (#TextDocumentPosition) the response is of either type [Definition](#Definition)
 * or a typed array of [DefinitionLink](#DefinitionLink) or a Thenable that resolves
 * to such.
 */
var DefinitionRequest;
(function (DefinitionRequest) {
    DefinitionRequest.method = 'textDocument/definition';
    DefinitionRequest.type = new messages$1.ProtocolRequestType(DefinitionRequest.method);
})(DefinitionRequest = exports.DefinitionRequest || (exports.DefinitionRequest = {}));
/**
 * A request to resolve project-wide references for the symbol denoted
 * by the given text document position. The request's parameter is of
 * type [ReferenceParams](#ReferenceParams) the response is of type
 * [Location[]](#Location) or a Thenable that resolves to such.
 */
var ReferencesRequest;
(function (ReferencesRequest) {
    ReferencesRequest.method = 'textDocument/references';
    ReferencesRequest.type = new messages$1.ProtocolRequestType(ReferencesRequest.method);
})(ReferencesRequest = exports.ReferencesRequest || (exports.ReferencesRequest = {}));
/**
 * Request to resolve a [DocumentHighlight](#DocumentHighlight) for a given
 * text document position. The request's parameter is of type [TextDocumentPosition]
 * (#TextDocumentPosition) the request response is of type [DocumentHighlight[]]
 * (#DocumentHighlight) or a Thenable that resolves to such.
 */
var DocumentHighlightRequest;
(function (DocumentHighlightRequest) {
    DocumentHighlightRequest.method = 'textDocument/documentHighlight';
    DocumentHighlightRequest.type = new messages$1.ProtocolRequestType(DocumentHighlightRequest.method);
})(DocumentHighlightRequest = exports.DocumentHighlightRequest || (exports.DocumentHighlightRequest = {}));
/**
 * A request to list all symbols found in a given text document. The request's
 * parameter is of type [TextDocumentIdentifier](#TextDocumentIdentifier) the
 * response is of type [SymbolInformation[]](#SymbolInformation) or a Thenable
 * that resolves to such.
 */
var DocumentSymbolRequest;
(function (DocumentSymbolRequest) {
    DocumentSymbolRequest.method = 'textDocument/documentSymbol';
    DocumentSymbolRequest.type = new messages$1.ProtocolRequestType(DocumentSymbolRequest.method);
})(DocumentSymbolRequest = exports.DocumentSymbolRequest || (exports.DocumentSymbolRequest = {}));
/**
 * A request to provide commands for the given text document and range.
 */
var CodeActionRequest;
(function (CodeActionRequest) {
    CodeActionRequest.method = 'textDocument/codeAction';
    CodeActionRequest.type = new messages$1.ProtocolRequestType(CodeActionRequest.method);
})(CodeActionRequest = exports.CodeActionRequest || (exports.CodeActionRequest = {}));
/**
 * Request to resolve additional information for a given code action.The request's
 * parameter is of type [CodeAction](#CodeAction) the response
 * is of type [CodeAction](#CodeAction) or a Thenable that resolves to such.
 */
var CodeActionResolveRequest;
(function (CodeActionResolveRequest) {
    CodeActionResolveRequest.method = 'codeAction/resolve';
    CodeActionResolveRequest.type = new messages$1.ProtocolRequestType(CodeActionResolveRequest.method);
})(CodeActionResolveRequest = exports.CodeActionResolveRequest || (exports.CodeActionResolveRequest = {}));
/**
 * A request to list project-wide symbols matching the query string given
 * by the [WorkspaceSymbolParams](#WorkspaceSymbolParams). The response is
 * of type [SymbolInformation[]](#SymbolInformation) or a Thenable that
 * resolves to such.
 */
var WorkspaceSymbolRequest;
(function (WorkspaceSymbolRequest) {
    WorkspaceSymbolRequest.method = 'workspace/symbol';
    WorkspaceSymbolRequest.type = new messages$1.ProtocolRequestType(WorkspaceSymbolRequest.method);
})(WorkspaceSymbolRequest = exports.WorkspaceSymbolRequest || (exports.WorkspaceSymbolRequest = {}));
/**
 * A request to provide code lens for the given text document.
 */
var CodeLensRequest;
(function (CodeLensRequest) {
    CodeLensRequest.method = 'textDocument/codeLens';
    CodeLensRequest.type = new messages$1.ProtocolRequestType(CodeLensRequest.method);
})(CodeLensRequest = exports.CodeLensRequest || (exports.CodeLensRequest = {}));
/**
 * A request to resolve a command for a given code lens.
 */
var CodeLensResolveRequest;
(function (CodeLensResolveRequest) {
    CodeLensResolveRequest.method = 'codeLens/resolve';
    CodeLensResolveRequest.type = new messages$1.ProtocolRequestType(CodeLensResolveRequest.method);
})(CodeLensResolveRequest = exports.CodeLensResolveRequest || (exports.CodeLensResolveRequest = {}));
/**
 * A request to refresh all code actions
 *
 * @since 3.16.0
 */
var CodeLensRefreshRequest;
(function (CodeLensRefreshRequest) {
    CodeLensRefreshRequest.method = `workspace/codeLens/refresh`;
    CodeLensRefreshRequest.type = new messages$1.ProtocolRequestType0(CodeLensRefreshRequest.method);
})(CodeLensRefreshRequest = exports.CodeLensRefreshRequest || (exports.CodeLensRefreshRequest = {}));
/**
 * A request to provide document links
 */
var DocumentLinkRequest;
(function (DocumentLinkRequest) {
    DocumentLinkRequest.method = 'textDocument/documentLink';
    DocumentLinkRequest.type = new messages$1.ProtocolRequestType(DocumentLinkRequest.method);
})(DocumentLinkRequest = exports.DocumentLinkRequest || (exports.DocumentLinkRequest = {}));
/**
 * Request to resolve additional information for a given document link. The request's
 * parameter is of type [DocumentLink](#DocumentLink) the response
 * is of type [DocumentLink](#DocumentLink) or a Thenable that resolves to such.
 */
var DocumentLinkResolveRequest;
(function (DocumentLinkResolveRequest) {
    DocumentLinkResolveRequest.method = 'documentLink/resolve';
    DocumentLinkResolveRequest.type = new messages$1.ProtocolRequestType(DocumentLinkResolveRequest.method);
})(DocumentLinkResolveRequest = exports.DocumentLinkResolveRequest || (exports.DocumentLinkResolveRequest = {}));
/**
 * A request to to format a whole document.
 */
var DocumentFormattingRequest;
(function (DocumentFormattingRequest) {
    DocumentFormattingRequest.method = 'textDocument/formatting';
    DocumentFormattingRequest.type = new messages$1.ProtocolRequestType(DocumentFormattingRequest.method);
})(DocumentFormattingRequest = exports.DocumentFormattingRequest || (exports.DocumentFormattingRequest = {}));
/**
 * A request to to format a range in a document.
 */
var DocumentRangeFormattingRequest;
(function (DocumentRangeFormattingRequest) {
    DocumentRangeFormattingRequest.method = 'textDocument/rangeFormatting';
    DocumentRangeFormattingRequest.type = new messages$1.ProtocolRequestType(DocumentRangeFormattingRequest.method);
})(DocumentRangeFormattingRequest = exports.DocumentRangeFormattingRequest || (exports.DocumentRangeFormattingRequest = {}));
/**
 * A request to format a document on type.
 */
var DocumentOnTypeFormattingRequest;
(function (DocumentOnTypeFormattingRequest) {
    DocumentOnTypeFormattingRequest.method = 'textDocument/onTypeFormatting';
    DocumentOnTypeFormattingRequest.type = new messages$1.ProtocolRequestType(DocumentOnTypeFormattingRequest.method);
})(DocumentOnTypeFormattingRequest = exports.DocumentOnTypeFormattingRequest || (exports.DocumentOnTypeFormattingRequest = {}));
//---- Rename ----------------------------------------------
var PrepareSupportDefaultBehavior;
(function (PrepareSupportDefaultBehavior) {
    /**
     * The client's default behavior is to select the identifier
     * according the to language's syntax rule.
     */
    PrepareSupportDefaultBehavior.Identifier = 1;
})(PrepareSupportDefaultBehavior = exports.PrepareSupportDefaultBehavior || (exports.PrepareSupportDefaultBehavior = {}));
/**
 * A request to rename a symbol.
 */
var RenameRequest;
(function (RenameRequest) {
    RenameRequest.method = 'textDocument/rename';
    RenameRequest.type = new messages$1.ProtocolRequestType(RenameRequest.method);
})(RenameRequest = exports.RenameRequest || (exports.RenameRequest = {}));
/**
 * A request to test and perform the setup necessary for a rename.
 *
 * @since 3.16 - support for default behavior
 */
var PrepareRenameRequest;
(function (PrepareRenameRequest) {
    PrepareRenameRequest.method = 'textDocument/prepareRename';
    PrepareRenameRequest.type = new messages$1.ProtocolRequestType(PrepareRenameRequest.method);
})(PrepareRenameRequest = exports.PrepareRenameRequest || (exports.PrepareRenameRequest = {}));
/**
 * A request send from the client to the server to execute a command. The request might return
 * a workspace edit which the client will apply to the workspace.
 */
var ExecuteCommandRequest;
(function (ExecuteCommandRequest) {
    ExecuteCommandRequest.type = new messages$1.ProtocolRequestType('workspace/executeCommand');
})(ExecuteCommandRequest = exports.ExecuteCommandRequest || (exports.ExecuteCommandRequest = {}));
/**
 * A request sent from the server to the client to modified certain resources.
 */
var ApplyWorkspaceEditRequest;
(function (ApplyWorkspaceEditRequest) {
    ApplyWorkspaceEditRequest.type = new messages$1.ProtocolRequestType('workspace/applyEdit');
})(ApplyWorkspaceEditRequest = exports.ApplyWorkspaceEditRequest || (exports.ApplyWorkspaceEditRequest = {}));

});

var connection$1 = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.createProtocolConnection = void 0;

function createProtocolConnection(input, output, logger, options) {
    if (main.ConnectionStrategy.is(options)) {
        options = { connectionStrategy: options };
    }
    return main.createMessageConnection(input, output, logger, options);
}
exports.createProtocolConnection = createProtocolConnection;

});

var require$$1 = /*@__PURE__*/getAugmentedNamespace(main$1);

var api$1 = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (commonjsGlobal && commonjsGlobal.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LSPErrorCodes = exports.createProtocolConnection = void 0;
__exportStar(main, exports);
__exportStar(require$$1, exports);
__exportStar(messages$1, exports);
__exportStar(protocol, exports);

Object.defineProperty(exports, "createProtocolConnection", { enumerable: true, get: function () { return connection$1.createProtocolConnection; } });
var LSPErrorCodes;
(function (LSPErrorCodes) {
    /**
    * This is the start range of LSP reserved error codes.
    * It doesn't denote a real error code.
    *
    * @since 3.16.0
    */
    LSPErrorCodes.lspReservedErrorRangeStart = -32899;
    LSPErrorCodes.ContentModified = -32801;
    LSPErrorCodes.RequestCancelled = -32800;
    /**
    * This is the end range of LSP reserved error codes.
    * It doesn't denote a real error code.
    *
    * @since 3.16.0
    */
    LSPErrorCodes.lspReservedErrorRangeEnd = -32800;
})(LSPErrorCodes = exports.LSPErrorCodes || (exports.LSPErrorCodes = {}));

});

var main$2 = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (commonjsGlobal && commonjsGlobal.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createProtocolConnection = void 0;

__exportStar(node, exports);
__exportStar(api$1, exports);
function createProtocolConnection(input, output, logger, options) {
    return node.createMessageConnection(input, output, logger, options);
}
exports.createProtocolConnection = createProtocolConnection;

});

var uuid = createCommonjsModule(function (module, exports) {
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateUuid = exports.parse = exports.isUUID = exports.v4 = exports.empty = void 0;
class ValueUUID {
    constructor(_value) {
        this._value = _value;
        // empty
    }
    asHex() {
        return this._value;
    }
    equals(other) {
        return this.asHex() === other.asHex();
    }
}
class V4UUID extends ValueUUID {
    constructor() {
        super([
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            '-',
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            '-',
            '4',
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            '-',
            V4UUID._oneOf(V4UUID._timeHighBits),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            '-',
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
            V4UUID._randomHex(),
        ].join(''));
    }
    static _oneOf(array) {
        return array[Math.floor(array.length * Math.random())];
    }
    static _randomHex() {
        return V4UUID._oneOf(V4UUID._chars);
    }
}
V4UUID._chars = ['0', '1', '2', '3', '4', '5', '6', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'];
V4UUID._timeHighBits = ['8', '9', 'a', 'b'];
/**
 * An empty UUID that contains only zeros.
 */
exports.empty = new ValueUUID('00000000-0000-0000-0000-000000000000');
function v4() {
    return new V4UUID();
}
exports.v4 = v4;
const _UUIDPattern = /^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;
function isUUID(value) {
    return _UUIDPattern.test(value);
}
exports.isUUID = isUUID;
/**
 * Parses a UUID that is of the format xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx.
 * @param value A uuid string.
 */
function parse(value) {
    if (!isUUID(value)) {
        throw new Error('invalid uuid');
    }
    return new ValueUUID(value);
}
exports.parse = parse;
function generateUuid() {
    return v4().asHex();
}
exports.generateUuid = generateUuid;

});

var progress = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.attachPartialResult = exports.ProgressFeature = exports.attachWorkDone = void 0;


class WorkDoneProgressReporterImpl {
    constructor(_connection, _token) {
        this._connection = _connection;
        this._token = _token;
        WorkDoneProgressReporterImpl.Instances.set(this._token, this);
    }
    begin(title, percentage, message, cancellable) {
        let param = {
            kind: 'begin',
            title,
            percentage,
            message,
            cancellable
        };
        this._connection.sendProgress(main$2.WorkDoneProgress.type, this._token, param);
    }
    report(arg0, arg1) {
        let param = {
            kind: 'report'
        };
        if (typeof arg0 === 'number') {
            param.percentage = arg0;
            if (arg1 !== undefined) {
                param.message = arg1;
            }
        }
        else {
            param.message = arg0;
        }
        this._connection.sendProgress(main$2.WorkDoneProgress.type, this._token, param);
    }
    done() {
        WorkDoneProgressReporterImpl.Instances.delete(this._token);
        this._connection.sendProgress(main$2.WorkDoneProgress.type, this._token, { kind: 'end' });
    }
}
WorkDoneProgressReporterImpl.Instances = new Map();
class WorkDoneProgressServerReporterImpl extends WorkDoneProgressReporterImpl {
    constructor(connection, token) {
        super(connection, token);
        this._source = new main$2.CancellationTokenSource();
    }
    get token() {
        return this._source.token;
    }
    done() {
        this._source.dispose();
        super.done();
    }
    cancel() {
        this._source.cancel();
    }
}
class NullProgressReporter {
    constructor() {
    }
    begin() {
    }
    report() {
    }
    done() {
    }
}
class NullProgressServerReporter extends NullProgressReporter {
    constructor() {
        super();
        this._source = new main$2.CancellationTokenSource();
    }
    get token() {
        return this._source.token;
    }
    done() {
        this._source.dispose();
    }
    cancel() {
        this._source.cancel();
    }
}
function attachWorkDone(connection, params) {
    if (params === undefined || params.workDoneToken === undefined) {
        return new NullProgressReporter();
    }
    const token = params.workDoneToken;
    delete params.workDoneToken;
    return new WorkDoneProgressReporterImpl(connection, token);
}
exports.attachWorkDone = attachWorkDone;
const ProgressFeature = (Base) => {
    return class extends Base {
        constructor() {
            super();
            this._progressSupported = false;
        }
        initialize(capabilities) {
            var _a;
            if (((_a = capabilities === null || capabilities === void 0 ? void 0 : capabilities.window) === null || _a === void 0 ? void 0 : _a.workDoneProgress) === true) {
                this._progressSupported = true;
                this.connection.onNotification(main$2.WorkDoneProgressCancelNotification.type, (params) => {
                    let progress = WorkDoneProgressReporterImpl.Instances.get(params.token);
                    if (progress instanceof WorkDoneProgressServerReporterImpl || progress instanceof NullProgressServerReporter) {
                        progress.cancel();
                    }
                });
            }
        }
        attachWorkDoneProgress(token) {
            if (token === undefined) {
                return new NullProgressReporter();
            }
            else {
                return new WorkDoneProgressReporterImpl(this.connection, token);
            }
        }
        createWorkDoneProgress() {
            if (this._progressSupported) {
                const token = uuid.generateUuid();
                return this.connection.sendRequest(main$2.WorkDoneProgressCreateRequest.type, { token }).then(() => {
                    const result = new WorkDoneProgressServerReporterImpl(this.connection, token);
                    return result;
                });
            }
            else {
                return Promise.resolve(new NullProgressServerReporter());
            }
        }
    };
};
exports.ProgressFeature = ProgressFeature;
var ResultProgress;
(function (ResultProgress) {
    ResultProgress.type = new main$2.ProgressType();
})(ResultProgress || (ResultProgress = {}));
class ResultProgressReporterImpl {
    constructor(_connection, _token) {
        this._connection = _connection;
        this._token = _token;
    }
    report(data) {
        this._connection.sendProgress(ResultProgress.type, this._token, data);
    }
}
function attachPartialResult(connection, params) {
    if (params === undefined || params.partialResultToken === undefined) {
        return undefined;
    }
    const token = params.partialResultToken;
    delete params.partialResultToken;
    return new ResultProgressReporterImpl(connection, token);
}
exports.attachPartialResult = attachPartialResult;

});

var configuration = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigurationFeature = void 0;


const ConfigurationFeature = (Base) => {
    return class extends Base {
        getConfiguration(arg) {
            if (!arg) {
                return this._getConfiguration({});
            }
            else if (is.string(arg)) {
                return this._getConfiguration({ section: arg });
            }
            else {
                return this._getConfiguration(arg);
            }
        }
        _getConfiguration(arg) {
            let params = {
                items: Array.isArray(arg) ? arg : [arg]
            };
            return this.connection.sendRequest(main$2.ConfigurationRequest.type, params).then((result) => {
                return Array.isArray(arg) ? result : result[0];
            });
        }
    };
};
exports.ConfigurationFeature = ConfigurationFeature;

});

/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */

var workspaceFolders = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkspaceFoldersFeature = void 0;

const WorkspaceFoldersFeature = (Base) => {
    return class extends Base {
        initialize(capabilities) {
            let workspaceCapabilities = capabilities.workspace;
            if (workspaceCapabilities && workspaceCapabilities.workspaceFolders) {
                this._onDidChangeWorkspaceFolders = new main$2.Emitter();
                this.connection.onNotification(main$2.DidChangeWorkspaceFoldersNotification.type, (params) => {
                    this._onDidChangeWorkspaceFolders.fire(params.event);
                });
            }
        }
        getWorkspaceFolders() {
            return this.connection.sendRequest(main$2.WorkspaceFoldersRequest.type);
        }
        get onDidChangeWorkspaceFolders() {
            if (!this._onDidChangeWorkspaceFolders) {
                throw new Error('Client doesn\'t support sending workspace folder change events.');
            }
            if (!this._unregistration) {
                this._unregistration = this.connection.client.register(main$2.DidChangeWorkspaceFoldersNotification.type);
            }
            return this._onDidChangeWorkspaceFolders.event;
        }
    };
};
exports.WorkspaceFoldersFeature = WorkspaceFoldersFeature;

});

/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */

var callHierarchy = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.CallHierarchyFeature = void 0;

const CallHierarchyFeature = (Base) => {
    return class extends Base {
        get callHierarchy() {
            return {
                onPrepare: (handler) => {
                    this.connection.onRequest(main$2.CallHierarchyPrepareRequest.type, (params, cancel) => {
                        return handler(params, cancel, this.attachWorkDoneProgress(params), undefined);
                    });
                },
                onIncomingCalls: (handler) => {
                    const type = main$2.CallHierarchyIncomingCallsRequest.type;
                    this.connection.onRequest(type, (params, cancel) => {
                        return handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params));
                    });
                },
                onOutgoingCalls: (handler) => {
                    const type = main$2.CallHierarchyOutgoingCallsRequest.type;
                    this.connection.onRequest(type, (params, cancel) => {
                        return handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params));
                    });
                }
            };
        }
    };
};
exports.CallHierarchyFeature = CallHierarchyFeature;

});

var semanticTokens = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.SemanticTokensBuilder = exports.SemanticTokensFeature = void 0;

const SemanticTokensFeature = (Base) => {
    return class extends Base {
        get semanticTokens() {
            return {
                on: (handler) => {
                    const type = main$2.SemanticTokensRequest.type;
                    this.connection.onRequest(type, (params, cancel) => {
                        return handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params));
                    });
                },
                onDelta: (handler) => {
                    const type = main$2.SemanticTokensDeltaRequest.type;
                    this.connection.onRequest(type, (params, cancel) => {
                        return handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params));
                    });
                },
                onRange: (handler) => {
                    const type = main$2.SemanticTokensRangeRequest.type;
                    this.connection.onRequest(type, (params, cancel) => {
                        return handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params));
                    });
                }
            };
        }
    };
};
exports.SemanticTokensFeature = SemanticTokensFeature;
class SemanticTokensBuilder {
    constructor() {
        this._prevData = undefined;
        this.initialize();
    }
    initialize() {
        this._id = Date.now();
        this._prevLine = 0;
        this._prevChar = 0;
        this._data = [];
        this._dataLen = 0;
    }
    push(line, char, length, tokenType, tokenModifiers) {
        let pushLine = line;
        let pushChar = char;
        if (this._dataLen > 0) {
            pushLine -= this._prevLine;
            if (pushLine === 0) {
                pushChar -= this._prevChar;
            }
        }
        this._data[this._dataLen++] = pushLine;
        this._data[this._dataLen++] = pushChar;
        this._data[this._dataLen++] = length;
        this._data[this._dataLen++] = tokenType;
        this._data[this._dataLen++] = tokenModifiers;
        this._prevLine = line;
        this._prevChar = char;
    }
    get id() {
        return this._id.toString();
    }
    previousResult(id) {
        if (this.id === id) {
            this._prevData = this._data;
        }
        this.initialize();
    }
    build() {
        this._prevData = undefined;
        return {
            resultId: this.id,
            data: this._data
        };
    }
    canBuildEdits() {
        return this._prevData !== undefined;
    }
    buildEdits() {
        if (this._prevData !== undefined) {
            const prevDataLength = this._prevData.length;
            const dataLength = this._data.length;
            let startIndex = 0;
            while (startIndex < dataLength && startIndex < prevDataLength && this._prevData[startIndex] === this._data[startIndex]) {
                startIndex++;
            }
            if (startIndex < dataLength && startIndex < prevDataLength) {
                // Find end index
                let endIndex = 0;
                while (endIndex < dataLength && endIndex < prevDataLength && this._prevData[prevDataLength - 1 - endIndex] === this._data[dataLength - 1 - endIndex]) {
                    endIndex++;
                }
                const newData = this._data.slice(startIndex, dataLength - endIndex);
                const result = {
                    resultId: this.id,
                    edits: [
                        { start: startIndex, deleteCount: prevDataLength - endIndex - startIndex, data: newData }
                    ]
                };
                return result;
            }
            else if (startIndex < dataLength) {
                return { resultId: this.id, edits: [
                        { start: startIndex, deleteCount: 0, data: this._data.slice(startIndex) }
                    ] };
            }
            else if (startIndex < prevDataLength) {
                return { resultId: this.id, edits: [
                        { start: startIndex, deleteCount: prevDataLength - startIndex }
                    ] };
            }
            else {
                return { resultId: this.id, edits: [] };
            }
        }
        else {
            return this.build();
        }
    }
}
exports.SemanticTokensBuilder = SemanticTokensBuilder;

});

var showDocument = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShowDocumentFeature = void 0;

const ShowDocumentFeature = (Base) => {
    return class extends Base {
        showDocument(params) {
            return this.connection.sendRequest(main$2.ShowDocumentRequest.type, params);
        }
    };
};
exports.ShowDocumentFeature = ShowDocumentFeature;

});

var fileOperations = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileOperationsFeature = void 0;

const FileOperationsFeature = (Base) => {
    return class extends Base {
        onDidCreateFiles(handler) {
            this.connection.onNotification(main$2.DidCreateFilesNotification.type, (params) => {
                handler(params);
            });
        }
        onDidRenameFiles(handler) {
            this.connection.onNotification(main$2.DidRenameFilesNotification.type, (params) => {
                handler(params);
            });
        }
        onDidDeleteFiles(handler) {
            this.connection.onNotification(main$2.DidDeleteFilesNotification.type, (params) => {
                handler(params);
            });
        }
        onWillCreateFiles(handler) {
            return this.connection.onRequest(main$2.WillCreateFilesRequest.type, (params, cancel) => {
                return handler(params, cancel);
            });
        }
        onWillRenameFiles(handler) {
            return this.connection.onRequest(main$2.WillRenameFilesRequest.type, (params, cancel) => {
                return handler(params, cancel);
            });
        }
        onWillDeleteFiles(handler) {
            return this.connection.onRequest(main$2.WillDeleteFilesRequest.type, (params, cancel) => {
                return handler(params, cancel);
            });
        }
    };
};
exports.FileOperationsFeature = FileOperationsFeature;

});

var linkedEditingRange = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkedEditingRangeFeature = void 0;

const LinkedEditingRangeFeature = (Base) => {
    return class extends Base {
        onLinkedEditingRange(handler) {
            this.connection.onRequest(main$2.LinkedEditingRangeRequest.type, (params, cancel) => {
                return handler(params, cancel, this.attachWorkDoneProgress(params), undefined);
            });
        }
    };
};
exports.LinkedEditingRangeFeature = LinkedEditingRangeFeature;

});

/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */

var moniker = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", { value: true });
exports.MonikerFeature = void 0;

const MonikerFeature = (Base) => {
    return class extends Base {
        get moniker() {
            return {
                on: (handler) => {
                    const type = main$2.MonikerRequest.type;
                    this.connection.onRequest(type, (params, cancel) => {
                        return handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params));
                    });
                },
            };
        }
    };
};
exports.MonikerFeature = MonikerFeature;

});

var server = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.createConnection = exports.combineFeatures = exports.combineLanguagesFeatures = exports.combineWorkspaceFeatures = exports.combineWindowFeatures = exports.combineClientFeatures = exports.combineTracerFeatures = exports.combineTelemetryFeatures = exports.combineConsoleFeatures = exports._LanguagesImpl = exports.BulkUnregistration = exports.BulkRegistration = exports.ErrorMessageTracker = exports.TextDocuments = void 0;












function null2Undefined(value) {
    if (value === null) {
        return undefined;
    }
    return value;
}
/**
 * A manager for simple text documents
 */
class TextDocuments {
    /**
     * Create a new text document manager.
     */
    constructor(configuration) {
        this._documents = Object.create(null);
        this._configuration = configuration;
        this._onDidChangeContent = new main$2.Emitter();
        this._onDidOpen = new main$2.Emitter();
        this._onDidClose = new main$2.Emitter();
        this._onDidSave = new main$2.Emitter();
        this._onWillSave = new main$2.Emitter();
    }
    /**
     * An event that fires when a text document managed by this manager
     * has been opened or the content changes.
     */
    get onDidChangeContent() {
        return this._onDidChangeContent.event;
    }
    /**
     * An event that fires when a text document managed by this manager
     * has been opened.
     */
    get onDidOpen() {
        return this._onDidOpen.event;
    }
    /**
     * An event that fires when a text document managed by this manager
     * will be saved.
     */
    get onWillSave() {
        return this._onWillSave.event;
    }
    /**
     * Sets a handler that will be called if a participant wants to provide
     * edits during a text document save.
     */
    onWillSaveWaitUntil(handler) {
        this._willSaveWaitUntil = handler;
    }
    /**
     * An event that fires when a text document managed by this manager
     * has been saved.
     */
    get onDidSave() {
        return this._onDidSave.event;
    }
    /**
     * An event that fires when a text document managed by this manager
     * has been closed.
     */
    get onDidClose() {
        return this._onDidClose.event;
    }
    /**
     * Returns the document for the given URI. Returns undefined if
     * the document is not managed by this instance.
     *
     * @param uri The text document's URI to retrieve.
     * @return the text document or `undefined`.
     */
    get(uri) {
        return this._documents[uri];
    }
    /**
     * Returns all text documents managed by this instance.
     *
     * @return all text documents.
     */
    all() {
        return Object.keys(this._documents).map(key => this._documents[key]);
    }
    /**
     * Returns the URIs of all text documents managed by this instance.
     *
     * @return the URI's of all text documents.
     */
    keys() {
        return Object.keys(this._documents);
    }
    /**
     * Listens for `low level` notification on the given connection to
     * update the text documents managed by this instance.
     *
     * Please note that the connection only provides handlers not an event model. Therefore
     * listening on a connection will overwrite the following handlers on a connection:
     * `onDidOpenTextDocument`, `onDidChangeTextDocument`, `onDidCloseTextDocument`,
     * `onWillSaveTextDocument`, `onWillSaveTextDocumentWaitUntil` and `onDidSaveTextDocument`.
     *
     * Use the corresponding events on the TextDocuments instance instead.
     *
     * @param connection The connection to listen on.
     */
    listen(connection) {
        connection.__textDocumentSync = main$2.TextDocumentSyncKind.Full;
        connection.onDidOpenTextDocument((event) => {
            let td = event.textDocument;
            let document = this._configuration.create(td.uri, td.languageId, td.version, td.text);
            this._documents[td.uri] = document;
            let toFire = Object.freeze({ document });
            this._onDidOpen.fire(toFire);
            this._onDidChangeContent.fire(toFire);
        });
        connection.onDidChangeTextDocument((event) => {
            let td = event.textDocument;
            let changes = event.contentChanges;
            if (changes.length === 0) {
                return;
            }
            let document = this._documents[td.uri];
            const { version } = td;
            if (version === null || version === undefined) {
                throw new Error(`Received document change event for ${td.uri} without valid version identifier`);
            }
            document = this._configuration.update(document, changes, version);
            this._documents[td.uri] = document;
            this._onDidChangeContent.fire(Object.freeze({ document }));
        });
        connection.onDidCloseTextDocument((event) => {
            let document = this._documents[event.textDocument.uri];
            if (document) {
                delete this._documents[event.textDocument.uri];
                this._onDidClose.fire(Object.freeze({ document }));
            }
        });
        connection.onWillSaveTextDocument((event) => {
            let document = this._documents[event.textDocument.uri];
            if (document) {
                this._onWillSave.fire(Object.freeze({ document, reason: event.reason }));
            }
        });
        connection.onWillSaveTextDocumentWaitUntil((event, token) => {
            let document = this._documents[event.textDocument.uri];
            if (document && this._willSaveWaitUntil) {
                return this._willSaveWaitUntil(Object.freeze({ document, reason: event.reason }), token);
            }
            else {
                return [];
            }
        });
        connection.onDidSaveTextDocument((event) => {
            let document = this._documents[event.textDocument.uri];
            if (document) {
                this._onDidSave.fire(Object.freeze({ document }));
            }
        });
    }
}
exports.TextDocuments = TextDocuments;
/**
 * Helps tracking error message. Equal occurrences of the same
 * message are only stored once. This class is for example
 * useful if text documents are validated in a loop and equal
 * error message should be folded into one.
 */
class ErrorMessageTracker {
    constructor() {
        this._messages = Object.create(null);
    }
    /**
     * Add a message to the tracker.
     *
     * @param message The message to add.
     */
    add(message) {
        let count = this._messages[message];
        if (!count) {
            count = 0;
        }
        count++;
        this._messages[message] = count;
    }
    /**
     * Send all tracked messages to the connection's window.
     *
     * @param connection The connection established between client and server.
     */
    sendErrors(connection) {
        Object.keys(this._messages).forEach(message => {
            connection.window.showErrorMessage(message);
        });
    }
}
exports.ErrorMessageTracker = ErrorMessageTracker;
class RemoteConsoleImpl {
    constructor() {
    }
    rawAttach(connection) {
        this._rawConnection = connection;
    }
    attach(connection) {
        this._connection = connection;
    }
    get connection() {
        if (!this._connection) {
            throw new Error('Remote is not attached to a connection yet.');
        }
        return this._connection;
    }
    fillServerCapabilities(_capabilities) {
    }
    initialize(_capabilities) {
    }
    error(message) {
        this.send(main$2.MessageType.Error, message);
    }
    warn(message) {
        this.send(main$2.MessageType.Warning, message);
    }
    info(message) {
        this.send(main$2.MessageType.Info, message);
    }
    log(message) {
        this.send(main$2.MessageType.Log, message);
    }
    send(type, message) {
        if (this._rawConnection) {
            this._rawConnection.sendNotification(main$2.LogMessageNotification.type, { type, message });
        }
    }
}
class _RemoteWindowImpl {
    constructor() {
    }
    attach(connection) {
        this._connection = connection;
    }
    get connection() {
        if (!this._connection) {
            throw new Error('Remote is not attached to a connection yet.');
        }
        return this._connection;
    }
    initialize(_capabilities) {
    }
    fillServerCapabilities(_capabilities) {
    }
    showErrorMessage(message, ...actions) {
        let params = { type: main$2.MessageType.Error, message, actions };
        return this.connection.sendRequest(main$2.ShowMessageRequest.type, params).then(null2Undefined);
    }
    showWarningMessage(message, ...actions) {
        let params = { type: main$2.MessageType.Warning, message, actions };
        return this.connection.sendRequest(main$2.ShowMessageRequest.type, params).then(null2Undefined);
    }
    showInformationMessage(message, ...actions) {
        let params = { type: main$2.MessageType.Info, message, actions };
        return this.connection.sendRequest(main$2.ShowMessageRequest.type, params).then(null2Undefined);
    }
}
const RemoteWindowImpl = showDocument.ShowDocumentFeature(progress.ProgressFeature(_RemoteWindowImpl));
var BulkRegistration;
(function (BulkRegistration) {
    /**
     * Creates a new bulk registration.
     * @return an empty bulk registration.
     */
    function create() {
        return new BulkRegistrationImpl();
    }
    BulkRegistration.create = create;
})(BulkRegistration = exports.BulkRegistration || (exports.BulkRegistration = {}));
class BulkRegistrationImpl {
    constructor() {
        this._registrations = [];
        this._registered = new Set();
    }
    add(type, registerOptions) {
        const method = is.string(type) ? type : type.method;
        if (this._registered.has(method)) {
            throw new Error(`${method} is already added to this registration`);
        }
        const id = uuid.generateUuid();
        this._registrations.push({
            id: id,
            method: method,
            registerOptions: registerOptions || {}
        });
        this._registered.add(method);
    }
    asRegistrationParams() {
        return {
            registrations: this._registrations
        };
    }
}
var BulkUnregistration;
(function (BulkUnregistration) {
    function create() {
        return new BulkUnregistrationImpl(undefined, []);
    }
    BulkUnregistration.create = create;
})(BulkUnregistration = exports.BulkUnregistration || (exports.BulkUnregistration = {}));
class BulkUnregistrationImpl {
    constructor(_connection, unregistrations) {
        this._connection = _connection;
        this._unregistrations = new Map();
        unregistrations.forEach(unregistration => {
            this._unregistrations.set(unregistration.method, unregistration);
        });
    }
    get isAttached() {
        return !!this._connection;
    }
    attach(connection) {
        this._connection = connection;
    }
    add(unregistration) {
        this._unregistrations.set(unregistration.method, unregistration);
    }
    dispose() {
        let unregistrations = [];
        for (let unregistration of this._unregistrations.values()) {
            unregistrations.push(unregistration);
        }
        let params = {
            unregisterations: unregistrations
        };
        this._connection.sendRequest(main$2.UnregistrationRequest.type, params).then(undefined, (_error) => {
            this._connection.console.info(`Bulk unregistration failed.`);
        });
    }
    disposeSingle(arg) {
        const method = is.string(arg) ? arg : arg.method;
        const unregistration = this._unregistrations.get(method);
        if (!unregistration) {
            return false;
        }
        let params = {
            unregisterations: [unregistration]
        };
        this._connection.sendRequest(main$2.UnregistrationRequest.type, params).then(() => {
            this._unregistrations.delete(method);
        }, (_error) => {
            this._connection.console.info(`Un-registering request handler for ${unregistration.id} failed.`);
        });
        return true;
    }
}
class RemoteClientImpl {
    attach(connection) {
        this._connection = connection;
    }
    get connection() {
        if (!this._connection) {
            throw new Error('Remote is not attached to a connection yet.');
        }
        return this._connection;
    }
    initialize(_capabilities) {
    }
    fillServerCapabilities(_capabilities) {
    }
    register(typeOrRegistrations, registerOptionsOrType, registerOptions) {
        if (typeOrRegistrations instanceof BulkRegistrationImpl) {
            return this.registerMany(typeOrRegistrations);
        }
        else if (typeOrRegistrations instanceof BulkUnregistrationImpl) {
            return this.registerSingle1(typeOrRegistrations, registerOptionsOrType, registerOptions);
        }
        else {
            return this.registerSingle2(typeOrRegistrations, registerOptionsOrType);
        }
    }
    registerSingle1(unregistration, type, registerOptions) {
        const method = is.string(type) ? type : type.method;
        const id = uuid.generateUuid();
        let params = {
            registrations: [{ id, method, registerOptions: registerOptions || {} }]
        };
        if (!unregistration.isAttached) {
            unregistration.attach(this.connection);
        }
        return this.connection.sendRequest(main$2.RegistrationRequest.type, params).then((_result) => {
            unregistration.add({ id: id, method: method });
            return unregistration;
        }, (_error) => {
            this.connection.console.info(`Registering request handler for ${method} failed.`);
            return Promise.reject(_error);
        });
    }
    registerSingle2(type, registerOptions) {
        const method = is.string(type) ? type : type.method;
        const id = uuid.generateUuid();
        let params = {
            registrations: [{ id, method, registerOptions: registerOptions || {} }]
        };
        return this.connection.sendRequest(main$2.RegistrationRequest.type, params).then((_result) => {
            return main$2.Disposable.create(() => {
                this.unregisterSingle(id, method);
            });
        }, (_error) => {
            this.connection.console.info(`Registering request handler for ${method} failed.`);
            return Promise.reject(_error);
        });
    }
    unregisterSingle(id, method) {
        let params = {
            unregisterations: [{ id, method }]
        };
        return this.connection.sendRequest(main$2.UnregistrationRequest.type, params).then(undefined, (_error) => {
            this.connection.console.info(`Un-registering request handler for ${id} failed.`);
        });
    }
    registerMany(registrations) {
        let params = registrations.asRegistrationParams();
        return this.connection.sendRequest(main$2.RegistrationRequest.type, params).then(() => {
            return new BulkUnregistrationImpl(this._connection, params.registrations.map(registration => { return { id: registration.id, method: registration.method }; }));
        }, (_error) => {
            this.connection.console.info(`Bulk registration failed.`);
            return Promise.reject(_error);
        });
    }
}
class _RemoteWorkspaceImpl {
    constructor() {
    }
    attach(connection) {
        this._connection = connection;
    }
    get connection() {
        if (!this._connection) {
            throw new Error('Remote is not attached to a connection yet.');
        }
        return this._connection;
    }
    initialize(_capabilities) {
    }
    fillServerCapabilities(_capabilities) {
    }
    applyEdit(paramOrEdit) {
        function isApplyWorkspaceEditParams(value) {
            return value && !!value.edit;
        }
        let params = isApplyWorkspaceEditParams(paramOrEdit) ? paramOrEdit : { edit: paramOrEdit };
        return this.connection.sendRequest(main$2.ApplyWorkspaceEditRequest.type, params);
    }
}
const RemoteWorkspaceImpl = fileOperations.FileOperationsFeature(workspaceFolders.WorkspaceFoldersFeature(configuration.ConfigurationFeature(_RemoteWorkspaceImpl)));
class TracerImpl {
    constructor() {
        this._trace = main$2.Trace.Off;
    }
    attach(connection) {
        this._connection = connection;
    }
    get connection() {
        if (!this._connection) {
            throw new Error('Remote is not attached to a connection yet.');
        }
        return this._connection;
    }
    initialize(_capabilities) {
    }
    fillServerCapabilities(_capabilities) {
    }
    set trace(value) {
        this._trace = value;
    }
    log(message, verbose) {
        if (this._trace === main$2.Trace.Off) {
            return;
        }
        this.connection.sendNotification(main$2.LogTraceNotification.type, {
            message: message,
            verbose: this._trace === main$2.Trace.Verbose ? verbose : undefined
        });
    }
}
class TelemetryImpl {
    constructor() {
    }
    attach(connection) {
        this._connection = connection;
    }
    get connection() {
        if (!this._connection) {
            throw new Error('Remote is not attached to a connection yet.');
        }
        return this._connection;
    }
    initialize(_capabilities) {
    }
    fillServerCapabilities(_capabilities) {
    }
    logEvent(data) {
        this.connection.sendNotification(main$2.TelemetryEventNotification.type, data);
    }
}
class _LanguagesImpl {
    constructor() {
    }
    attach(connection) {
        this._connection = connection;
    }
    get connection() {
        if (!this._connection) {
            throw new Error('Remote is not attached to a connection yet.');
        }
        return this._connection;
    }
    initialize(_capabilities) {
    }
    fillServerCapabilities(_capabilities) {
    }
    attachWorkDoneProgress(params) {
        return progress.attachWorkDone(this.connection, params);
    }
    attachPartialResultProgress(_type, params) {
        return progress.attachPartialResult(this.connection, params);
    }
}
exports._LanguagesImpl = _LanguagesImpl;
const LanguagesImpl = moniker.MonikerFeature(linkedEditingRange.LinkedEditingRangeFeature(semanticTokens.SemanticTokensFeature(callHierarchy.CallHierarchyFeature(_LanguagesImpl))));
function combineConsoleFeatures(one, two) {
    return function (Base) {
        return two(one(Base));
    };
}
exports.combineConsoleFeatures = combineConsoleFeatures;
function combineTelemetryFeatures(one, two) {
    return function (Base) {
        return two(one(Base));
    };
}
exports.combineTelemetryFeatures = combineTelemetryFeatures;
function combineTracerFeatures(one, two) {
    return function (Base) {
        return two(one(Base));
    };
}
exports.combineTracerFeatures = combineTracerFeatures;
function combineClientFeatures(one, two) {
    return function (Base) {
        return two(one(Base));
    };
}
exports.combineClientFeatures = combineClientFeatures;
function combineWindowFeatures(one, two) {
    return function (Base) {
        return two(one(Base));
    };
}
exports.combineWindowFeatures = combineWindowFeatures;
function combineWorkspaceFeatures(one, two) {
    return function (Base) {
        return two(one(Base));
    };
}
exports.combineWorkspaceFeatures = combineWorkspaceFeatures;
function combineLanguagesFeatures(one, two) {
    return function (Base) {
        return two(one(Base));
    };
}
exports.combineLanguagesFeatures = combineLanguagesFeatures;
function combineFeatures(one, two) {
    function combine(one, two, func) {
        if (one && two) {
            return func(one, two);
        }
        else if (one) {
            return one;
        }
        else {
            return two;
        }
    }
    let result = {
        __brand: 'features',
        console: combine(one.console, two.console, combineConsoleFeatures),
        tracer: combine(one.tracer, two.tracer, combineTracerFeatures),
        telemetry: combine(one.telemetry, two.telemetry, combineTelemetryFeatures),
        client: combine(one.client, two.client, combineClientFeatures),
        window: combine(one.window, two.window, combineWindowFeatures),
        workspace: combine(one.workspace, two.workspace, combineWorkspaceFeatures)
    };
    return result;
}
exports.combineFeatures = combineFeatures;
function createConnection(connectionFactory, watchDog, factories) {
    const logger = (factories && factories.console ? new (factories.console(RemoteConsoleImpl))() : new RemoteConsoleImpl());
    const connection = connectionFactory(logger);
    logger.rawAttach(connection);
    const tracer = (factories && factories.tracer ? new (factories.tracer(TracerImpl))() : new TracerImpl());
    const telemetry = (factories && factories.telemetry ? new (factories.telemetry(TelemetryImpl))() : new TelemetryImpl());
    const client = (factories && factories.client ? new (factories.client(RemoteClientImpl))() : new RemoteClientImpl());
    const remoteWindow = (factories && factories.window ? new (factories.window(RemoteWindowImpl))() : new RemoteWindowImpl());
    const workspace = (factories && factories.workspace ? new (factories.workspace(RemoteWorkspaceImpl))() : new RemoteWorkspaceImpl());
    const languages = (factories && factories.languages ? new (factories.languages(LanguagesImpl))() : new LanguagesImpl());
    const allRemotes = [logger, tracer, telemetry, client, remoteWindow, workspace, languages];
    function asPromise(value) {
        if (value instanceof Promise) {
            return value;
        }
        else if (is.thenable(value)) {
            return new Promise((resolve, reject) => {
                value.then((resolved) => resolve(resolved), (error) => reject(error));
            });
        }
        else {
            return Promise.resolve(value);
        }
    }
    let shutdownHandler = undefined;
    let initializeHandler = undefined;
    let exitHandler = undefined;
    let protocolConnection = {
        listen: () => connection.listen(),
        sendRequest: (type, ...params) => connection.sendRequest(is.string(type) ? type : type.method, ...params),
        onRequest: (type, handler) => connection.onRequest(type, handler),
        sendNotification: (type, param) => {
            const method = is.string(type) ? type : type.method;
            if (arguments.length === 1) {
                connection.sendNotification(method);
            }
            else {
                connection.sendNotification(method, param);
            }
        },
        onNotification: (type, handler) => connection.onNotification(type, handler),
        onProgress: connection.onProgress,
        sendProgress: connection.sendProgress,
        onInitialize: (handler) => initializeHandler = handler,
        onInitialized: (handler) => connection.onNotification(main$2.InitializedNotification.type, handler),
        onShutdown: (handler) => shutdownHandler = handler,
        onExit: (handler) => exitHandler = handler,
        get console() { return logger; },
        get telemetry() { return telemetry; },
        get tracer() { return tracer; },
        get client() { return client; },
        get window() { return remoteWindow; },
        get workspace() { return workspace; },
        get languages() { return languages; },
        onDidChangeConfiguration: (handler) => connection.onNotification(main$2.DidChangeConfigurationNotification.type, handler),
        onDidChangeWatchedFiles: (handler) => connection.onNotification(main$2.DidChangeWatchedFilesNotification.type, handler),
        __textDocumentSync: undefined,
        onDidOpenTextDocument: (handler) => connection.onNotification(main$2.DidOpenTextDocumentNotification.type, handler),
        onDidChangeTextDocument: (handler) => connection.onNotification(main$2.DidChangeTextDocumentNotification.type, handler),
        onDidCloseTextDocument: (handler) => connection.onNotification(main$2.DidCloseTextDocumentNotification.type, handler),
        onWillSaveTextDocument: (handler) => connection.onNotification(main$2.WillSaveTextDocumentNotification.type, handler),
        onWillSaveTextDocumentWaitUntil: (handler) => connection.onRequest(main$2.WillSaveTextDocumentWaitUntilRequest.type, handler),
        onDidSaveTextDocument: (handler) => connection.onNotification(main$2.DidSaveTextDocumentNotification.type, handler),
        sendDiagnostics: (params) => connection.sendNotification(main$2.PublishDiagnosticsNotification.type, params),
        onHover: (handler) => connection.onRequest(main$2.HoverRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), undefined);
        }),
        onCompletion: (handler) => connection.onRequest(main$2.CompletionRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onCompletionResolve: (handler) => connection.onRequest(main$2.CompletionResolveRequest.type, handler),
        onSignatureHelp: (handler) => connection.onRequest(main$2.SignatureHelpRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), undefined);
        }),
        onDeclaration: (handler) => connection.onRequest(main$2.DeclarationRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onDefinition: (handler) => connection.onRequest(main$2.DefinitionRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onTypeDefinition: (handler) => connection.onRequest(main$2.TypeDefinitionRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onImplementation: (handler) => connection.onRequest(main$2.ImplementationRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onReferences: (handler) => connection.onRequest(main$2.ReferencesRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onDocumentHighlight: (handler) => connection.onRequest(main$2.DocumentHighlightRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onDocumentSymbol: (handler) => connection.onRequest(main$2.DocumentSymbolRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onWorkspaceSymbol: (handler) => connection.onRequest(main$2.WorkspaceSymbolRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onCodeAction: (handler) => connection.onRequest(main$2.CodeActionRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onCodeActionResolve: (handler) => connection.onRequest(main$2.CodeActionResolveRequest.type, (params, cancel) => {
            return handler(params, cancel);
        }),
        onCodeLens: (handler) => connection.onRequest(main$2.CodeLensRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onCodeLensResolve: (handler) => connection.onRequest(main$2.CodeLensResolveRequest.type, (params, cancel) => {
            return handler(params, cancel);
        }),
        onDocumentFormatting: (handler) => connection.onRequest(main$2.DocumentFormattingRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), undefined);
        }),
        onDocumentRangeFormatting: (handler) => connection.onRequest(main$2.DocumentRangeFormattingRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), undefined);
        }),
        onDocumentOnTypeFormatting: (handler) => connection.onRequest(main$2.DocumentOnTypeFormattingRequest.type, (params, cancel) => {
            return handler(params, cancel);
        }),
        onRenameRequest: (handler) => connection.onRequest(main$2.RenameRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), undefined);
        }),
        onPrepareRename: (handler) => connection.onRequest(main$2.PrepareRenameRequest.type, (params, cancel) => {
            return handler(params, cancel);
        }),
        onDocumentLinks: (handler) => connection.onRequest(main$2.DocumentLinkRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onDocumentLinkResolve: (handler) => connection.onRequest(main$2.DocumentLinkResolveRequest.type, (params, cancel) => {
            return handler(params, cancel);
        }),
        onDocumentColor: (handler) => connection.onRequest(main$2.DocumentColorRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onColorPresentation: (handler) => connection.onRequest(main$2.ColorPresentationRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onFoldingRanges: (handler) => connection.onRequest(main$2.FoldingRangeRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onSelectionRanges: (handler) => connection.onRequest(main$2.SelectionRangeRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), progress.attachPartialResult(connection, params));
        }),
        onExecuteCommand: (handler) => connection.onRequest(main$2.ExecuteCommandRequest.type, (params, cancel) => {
            return handler(params, cancel, progress.attachWorkDone(connection, params), undefined);
        }),
        dispose: () => connection.dispose()
    };
    for (let remote of allRemotes) {
        remote.attach(protocolConnection);
    }
    connection.onRequest(main$2.InitializeRequest.type, (params) => {
        watchDog.initialize(params);
        if (is.string(params.trace)) {
            tracer.trace = main$2.Trace.fromString(params.trace);
        }
        for (let remote of allRemotes) {
            remote.initialize(params.capabilities);
        }
        if (initializeHandler) {
            let result = initializeHandler(params, new main$2.CancellationTokenSource().token, progress.attachWorkDone(connection, params), undefined);
            return asPromise(result).then((value) => {
                if (value instanceof main$2.ResponseError) {
                    return value;
                }
                let result = value;
                if (!result) {
                    result = { capabilities: {} };
                }
                let capabilities = result.capabilities;
                if (!capabilities) {
                    capabilities = {};
                    result.capabilities = capabilities;
                }
                if (capabilities.textDocumentSync === undefined || capabilities.textDocumentSync === null) {
                    capabilities.textDocumentSync = is.number(protocolConnection.__textDocumentSync) ? protocolConnection.__textDocumentSync : main$2.TextDocumentSyncKind.None;
                }
                else if (!is.number(capabilities.textDocumentSync) && !is.number(capabilities.textDocumentSync.change)) {
                    capabilities.textDocumentSync.change = is.number(protocolConnection.__textDocumentSync) ? protocolConnection.__textDocumentSync : main$2.TextDocumentSyncKind.None;
                }
                for (let remote of allRemotes) {
                    remote.fillServerCapabilities(capabilities);
                }
                return result;
            });
        }
        else {
            let result = { capabilities: { textDocumentSync: main$2.TextDocumentSyncKind.None } };
            for (let remote of allRemotes) {
                remote.fillServerCapabilities(result.capabilities);
            }
            return result;
        }
    });
    connection.onRequest(main$2.ShutdownRequest.type, () => {
        watchDog.shutdownReceived = true;
        if (shutdownHandler) {
            return shutdownHandler(new main$2.CancellationTokenSource().token);
        }
        else {
            return undefined;
        }
    });
    connection.onNotification(main$2.ExitNotification.type, () => {
        try {
            if (exitHandler) {
                exitHandler();
            }
        }
        finally {
            if (watchDog.shutdownReceived) {
                watchDog.exit(0);
            }
            else {
                watchDog.exit(1);
            }
        }
    });
    connection.onNotification(main$2.SetTraceNotification.type, (params) => {
        tracer.trace = main$2.Trace.fromString(params.value);
    });
    return protocolConnection;
}
exports.createConnection = createConnection;

});

var files = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveModulePath = exports.FileSystem = exports.resolveGlobalYarnPath = exports.resolveGlobalNodePath = exports.resolve = exports.uriToFilePath = void 0;




/**
 * @deprecated Use the `vscode-uri` npm module which provides a more
 * complete implementation of handling VS Code URIs.
 */
function uriToFilePath(uri) {
    let parsed = url__default['default'].parse(uri);
    if (parsed.protocol !== 'file:' || !parsed.path) {
        return undefined;
    }
    let segments = parsed.path.split('/');
    for (var i = 0, len = segments.length; i < len; i++) {
        segments[i] = decodeURIComponent(segments[i]);
    }
    if (process.platform === 'win32' && segments.length > 1) {
        let first = segments[0];
        let second = segments[1];
        // Do we have a drive letter and we started with a / which is the
        // case if the first segement is empty (see split above)
        if (first.length === 0 && second.length > 1 && second[1] === ':') {
            // Remove first slash
            segments.shift();
        }
    }
    return path__default['default'].normalize(segments.join('/'));
}
exports.uriToFilePath = uriToFilePath;
function isWindows() {
    return process.platform === 'win32';
}
function resolve(moduleName, nodePath, cwd, tracer) {
    const nodePathKey = 'NODE_PATH';
    const app = [
        'var p = process;',
        'p.on(\'message\',function(m){',
        'if(m.c===\'e\'){',
        'p.exit(0);',
        '}',
        'else if(m.c===\'rs\'){',
        'try{',
        'var r=require.resolve(m.a);',
        'p.send({c:\'r\',s:true,r:r});',
        '}',
        'catch(err){',
        'p.send({c:\'r\',s:false});',
        '}',
        '}',
        '});'
    ].join('');
    return new Promise((resolve, reject) => {
        let env = process.env;
        let newEnv = Object.create(null);
        Object.keys(env).forEach(key => newEnv[key] = env[key]);
        if (nodePath && fs__default['default'].existsSync(nodePath) /* see issue 545 */) {
            if (newEnv[nodePathKey]) {
                newEnv[nodePathKey] = nodePath + path__default['default'].delimiter + newEnv[nodePathKey];
            }
            else {
                newEnv[nodePathKey] = nodePath;
            }
            if (tracer) {
                tracer(`NODE_PATH value is: ${newEnv[nodePathKey]}`);
            }
        }
        newEnv['ELECTRON_RUN_AS_NODE'] = '1';
        try {
            let cp = child_process_1__default['default'].fork('', [], {
                cwd: cwd,
                env: newEnv,
                execArgv: ['-e', app]
            });
            if (cp.pid === void 0) {
                reject(new Error(`Starting process to resolve node module  ${moduleName} failed`));
                return;
            }
            cp.on('error', (error) => {
                reject(error);
            });
            cp.on('message', (message) => {
                if (message.c === 'r') {
                    cp.send({ c: 'e' });
                    if (message.s) {
                        resolve(message.r);
                    }
                    else {
                        reject(new Error(`Failed to resolve module: ${moduleName}`));
                    }
                }
            });
            let message = {
                c: 'rs',
                a: moduleName
            };
            cp.send(message);
        }
        catch (error) {
            reject(error);
        }
    });
}
exports.resolve = resolve;
/**
 * Resolve the global npm package path.
 * @deprecated Since this depends on the used package manager and their version the best is that servers
 * implement this themselves since they know best what kind of package managers to support.
 * @param tracer the tracer to use
 */
function resolveGlobalNodePath(tracer) {
    let npmCommand = 'npm';
    const env = Object.create(null);
    Object.keys(process.env).forEach(key => env[key] = process.env[key]);
    env['NO_UPDATE_NOTIFIER'] = 'true';
    const options = {
        encoding: 'utf8',
        env
    };
    if (isWindows()) {
        npmCommand = 'npm.cmd';
        options.shell = true;
    }
    let handler = () => { };
    try {
        process.on('SIGPIPE', handler);
        let stdout = child_process_1__default['default'].spawnSync(npmCommand, ['config', 'get', 'prefix'], options).stdout;
        if (!stdout) {
            if (tracer) {
                tracer(`'npm config get prefix' didn't return a value.`);
            }
            return undefined;
        }
        let prefix = stdout.trim();
        if (tracer) {
            tracer(`'npm config get prefix' value is: ${prefix}`);
        }
        if (prefix.length > 0) {
            if (isWindows()) {
                return path__default['default'].join(prefix, 'node_modules');
            }
            else {
                return path__default['default'].join(prefix, 'lib', 'node_modules');
            }
        }
        return undefined;
    }
    catch (err) {
        return undefined;
    }
    finally {
        process.removeListener('SIGPIPE', handler);
    }
}
exports.resolveGlobalNodePath = resolveGlobalNodePath;
/*
 * Resolve the global yarn pakage path.
 * @deprecated Since this depends on the used package manager and their version the best is that servers
 * implement this themselves since they know best what kind of package managers to support.
 * @param tracer the tracer to use
 */
function resolveGlobalYarnPath(tracer) {
    let yarnCommand = 'yarn';
    let options = {
        encoding: 'utf8'
    };
    if (isWindows()) {
        yarnCommand = 'yarn.cmd';
        options.shell = true;
    }
    let handler = () => { };
    try {
        process.on('SIGPIPE', handler);
        let results = child_process_1__default['default'].spawnSync(yarnCommand, ['global', 'dir', '--json'], options);
        let stdout = results.stdout;
        if (!stdout) {
            if (tracer) {
                tracer(`'yarn global dir' didn't return a value.`);
                if (results.stderr) {
                    tracer(results.stderr);
                }
            }
            return undefined;
        }
        let lines = stdout.trim().split(/\r?\n/);
        for (let line of lines) {
            try {
                let yarn = JSON.parse(line);
                if (yarn.type === 'log') {
                    return path__default['default'].join(yarn.data, 'node_modules');
                }
            }
            catch (e) {
                // Do nothing. Ignore the line
            }
        }
        return undefined;
    }
    catch (err) {
        return undefined;
    }
    finally {
        process.removeListener('SIGPIPE', handler);
    }
}
exports.resolveGlobalYarnPath = resolveGlobalYarnPath;
var FileSystem;
(function (FileSystem) {
    let _isCaseSensitive = undefined;
    function isCaseSensitive() {
        if (_isCaseSensitive !== void 0) {
            return _isCaseSensitive;
        }
        if (process.platform === 'win32') {
            _isCaseSensitive = false;
        }
        else {
            // convert current file name to upper case / lower case and check if file exists
            // (guards against cases when name is already all uppercase or lowercase)
            _isCaseSensitive = !fs__default['default'].existsSync(__filename.toUpperCase()) || !fs__default['default'].existsSync(__filename.toLowerCase());
        }
        return _isCaseSensitive;
    }
    FileSystem.isCaseSensitive = isCaseSensitive;
    function isParent(parent, child) {
        if (isCaseSensitive()) {
            return path__default['default'].normalize(child).indexOf(path__default['default'].normalize(parent)) === 0;
        }
        else {
            return path__default['default'].normalize(child).toLowerCase().indexOf(path__default['default'].normalize(parent).toLowerCase()) === 0;
        }
    }
    FileSystem.isParent = isParent;
})(FileSystem = exports.FileSystem || (exports.FileSystem = {}));
function resolveModulePath(workspaceRoot, moduleName, nodePath, tracer) {
    if (nodePath) {
        if (!path__default['default'].isAbsolute(nodePath)) {
            nodePath = path__default['default'].join(workspaceRoot, nodePath);
        }
        return resolve(moduleName, nodePath, nodePath, tracer).then((value) => {
            if (FileSystem.isParent(nodePath, value)) {
                return value;
            }
            else {
                return Promise.reject(new Error(`Failed to load ${moduleName} from node path location.`));
            }
        }).then(undefined, (_error) => {
            return resolve(moduleName, resolveGlobalNodePath(tracer), workspaceRoot, tracer);
        });
    }
    else {
        return resolve(moduleName, resolveGlobalNodePath(tracer), workspaceRoot, tracer);
    }
}
exports.resolveModulePath = resolveModulePath;

});

/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ----------------------------------------------------------------------------------------- */

var node$1 = main$2;

var api$2 = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (commonjsGlobal && commonjsGlobal.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProposedFeatures = exports.SemanticTokensBuilder = void 0;

Object.defineProperty(exports, "SemanticTokensBuilder", { enumerable: true, get: function () { return semanticTokens.SemanticTokensBuilder; } });
__exportStar(main$2, exports);
__exportStar(server, exports);
var ProposedFeatures;
(function (ProposedFeatures) {
    ProposedFeatures.all = {
        __brand: 'features'
    };
})(ProposedFeatures = exports.ProposedFeatures || (exports.ProposedFeatures = {}));

});

var main$3 = createCommonjsModule(function (module, exports) {
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
/// <reference path="../../typings/thenable.d.ts" />
var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (commonjsGlobal && commonjsGlobal.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createConnection = exports.Files = void 0;




__exportStar(node$1, exports);
__exportStar(api$2, exports);
var Files;
(function (Files) {
    Files.uriToFilePath = files.uriToFilePath;
    Files.resolveGlobalNodePath = files.resolveGlobalNodePath;
    Files.resolveGlobalYarnPath = files.resolveGlobalYarnPath;
    Files.resolve = files.resolve;
    Files.resolveModulePath = files.resolveModulePath;
})(Files = exports.Files || (exports.Files = {}));
function endProtocolConnection() {
    {
        return;
    }
}
let _shutdownReceived = false;
let exitTimer = undefined;
function setupExitTimer() {
    const argName = '--clientProcessId';
    function runTimer(value) {
        try {
            let processId = parseInt(value);
            if (!isNaN(processId)) {
                exitTimer = setInterval(() => {
                    try {
                        process.kill(processId, 0);
                    }
                    catch (ex) {
                        // Parent process doesn't exist anymore. Exit the server.
                        endProtocolConnection();
                        process.exit(_shutdownReceived ? 0 : 1);
                    }
                }, 3000);
            }
        }
        catch (e) {
            // Ignore errors;
        }
    }
    for (let i = 2; i < process.argv.length; i++) {
        let arg = process.argv[i];
        if (arg === argName && i + 1 < process.argv.length) {
            runTimer(process.argv[i + 1]);
            return;
        }
        else {
            let args = arg.split('=');
            if (args[0] === argName) {
                runTimer(args[1]);
            }
        }
    }
}
setupExitTimer();
const watchDog = {
    initialize: (params) => {
        const processId = params.processId;
        if (is.number(processId) && exitTimer === undefined) {
            // We received a parent process id. Set up a timer to periodically check
            // if the parent is still alive.
            setInterval(() => {
                try {
                    process.kill(processId, 0);
                }
                catch (ex) {
                    // Parent process doesn't exist anymore. Exit the server.
                    process.exit(_shutdownReceived ? 0 : 1);
                }
            }, 3000);
        }
    },
    get shutdownReceived() {
        return _shutdownReceived;
    },
    set shutdownReceived(value) {
        _shutdownReceived = value;
    },
    exit: (code) => {
        process.exit(code);
    }
};
function createConnection(arg1, arg2, arg3, arg4) {
    let factories;
    let input;
    let output;
    let options;
    if (arg1 !== void 0 && arg1.__brand === 'features') {
        factories = arg1;
        arg1 = arg2;
        arg2 = arg3;
        arg3 = arg4;
    }
    if (node$1.ConnectionStrategy.is(arg1) || node$1.ConnectionOptions.is(arg1)) {
        options = arg1;
    }
    else {
        input = arg1;
        output = arg2;
        options = arg3;
    }
    return _createConnection(input, output, options, factories);
}
exports.createConnection = createConnection;
function _createConnection(input, output, options, factories) {
    if (!input && !output && process.argv.length > 2) {
        let port = void 0;
        let pipeName = void 0;
        let argv = process.argv.slice(2);
        for (let i = 0; i < argv.length; i++) {
            let arg = argv[i];
            if (arg === '--node-ipc') {
                input = new node$1.IPCMessageReader(process);
                output = new node$1.IPCMessageWriter(process);
                break;
            }
            else if (arg === '--stdio') {
                input = process.stdin;
                output = process.stdout;
                break;
            }
            else if (arg === '--socket') {
                port = parseInt(argv[i + 1]);
                break;
            }
            else if (arg === '--pipe') {
                pipeName = argv[i + 1];
                break;
            }
            else {
                var args = arg.split('=');
                if (args[0] === '--socket') {
                    port = parseInt(args[1]);
                    break;
                }
                else if (args[0] === '--pipe') {
                    pipeName = args[1];
                    break;
                }
            }
        }
        if (port) {
            let transport = node$1.createServerSocketTransport(port);
            input = transport[0];
            output = transport[1];
        }
        else if (pipeName) {
            let transport = node$1.createServerPipeTransport(pipeName);
            input = transport[0];
            output = transport[1];
        }
    }
    var commandLineMessage = 'Use arguments of createConnection or set command line parameters: \'--node-ipc\', \'--stdio\' or \'--socket={number}\'';
    if (!input) {
        throw new Error('Connection input stream is not set. ' + commandLineMessage);
    }
    if (!output) {
        throw new Error('Connection output stream is not set. ' + commandLineMessage);
    }
    // Backwards compatibility
    if (is.func(input.read) && is.func(input.on)) {
        let inputStream = input;
        inputStream.on('end', () => {
            process.exit(_shutdownReceived ? 0 : 1);
        });
        inputStream.on('close', () => {
            process.exit(_shutdownReceived ? 0 : 1);
        });
    }
    const connectionFactory = (logger) => {
        const result = node$1.createProtocolConnection(input, output, logger, options);
        return result;
    };
    return server.createConnection(connectionFactory, watchDog, factories);
}

});

/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ----------------------------------------------------------------------------------------- */

var node$2 = main$3;

/* --------------------------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
var FullTextDocument$1 = /** @class */ (function () {
    function FullTextDocument(uri, languageId, version, content) {
        this._uri = uri;
        this._languageId = languageId;
        this._version = version;
        this._content = content;
        this._lineOffsets = undefined;
    }
    Object.defineProperty(FullTextDocument.prototype, "uri", {
        get: function () {
            return this._uri;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FullTextDocument.prototype, "languageId", {
        get: function () {
            return this._languageId;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FullTextDocument.prototype, "version", {
        get: function () {
            return this._version;
        },
        enumerable: true,
        configurable: true
    });
    FullTextDocument.prototype.getText = function (range) {
        if (range) {
            var start = this.offsetAt(range.start);
            var end = this.offsetAt(range.end);
            return this._content.substring(start, end);
        }
        return this._content;
    };
    FullTextDocument.prototype.update = function (changes, version) {
        for (var _i = 0, changes_1 = changes; _i < changes_1.length; _i++) {
            var change = changes_1[_i];
            if (FullTextDocument.isIncremental(change)) {
                // makes sure start is before end
                var range = getWellformedRange(change.range);
                // update content
                var startOffset = this.offsetAt(range.start);
                var endOffset = this.offsetAt(range.end);
                this._content = this._content.substring(0, startOffset) + change.text + this._content.substring(endOffset, this._content.length);
                // update the offsets
                var startLine = Math.max(range.start.line, 0);
                var endLine = Math.max(range.end.line, 0);
                var lineOffsets = this._lineOffsets;
                var addedLineOffsets = computeLineOffsets(change.text, false, startOffset);
                if (endLine - startLine === addedLineOffsets.length) {
                    for (var i = 0, len = addedLineOffsets.length; i < len; i++) {
                        lineOffsets[i + startLine + 1] = addedLineOffsets[i];
                    }
                }
                else {
                    if (addedLineOffsets.length < 10000) {
                        lineOffsets.splice.apply(lineOffsets, [startLine + 1, endLine - startLine].concat(addedLineOffsets));
                    }
                    else { // avoid too many arguments for splice
                        this._lineOffsets = lineOffsets = lineOffsets.slice(0, startLine + 1).concat(addedLineOffsets, lineOffsets.slice(endLine + 1));
                    }
                }
                var diff = change.text.length - (endOffset - startOffset);
                if (diff !== 0) {
                    for (var i = startLine + 1 + addedLineOffsets.length, len = lineOffsets.length; i < len; i++) {
                        lineOffsets[i] = lineOffsets[i] + diff;
                    }
                }
            }
            else if (FullTextDocument.isFull(change)) {
                this._content = change.text;
                this._lineOffsets = undefined;
            }
            else {
                throw new Error('Unknown change event received');
            }
        }
        this._version = version;
    };
    FullTextDocument.prototype.getLineOffsets = function () {
        if (this._lineOffsets === undefined) {
            this._lineOffsets = computeLineOffsets(this._content, true);
        }
        return this._lineOffsets;
    };
    FullTextDocument.prototype.positionAt = function (offset) {
        offset = Math.max(Math.min(offset, this._content.length), 0);
        var lineOffsets = this.getLineOffsets();
        var low = 0, high = lineOffsets.length;
        if (high === 0) {
            return { line: 0, character: offset };
        }
        while (low < high) {
            var mid = Math.floor((low + high) / 2);
            if (lineOffsets[mid] > offset) {
                high = mid;
            }
            else {
                low = mid + 1;
            }
        }
        // low is the least x for which the line offset is larger than the current offset
        // or array.length if no line offset is larger than the current offset
        var line = low - 1;
        return { line: line, character: offset - lineOffsets[line] };
    };
    FullTextDocument.prototype.offsetAt = function (position) {
        var lineOffsets = this.getLineOffsets();
        if (position.line >= lineOffsets.length) {
            return this._content.length;
        }
        else if (position.line < 0) {
            return 0;
        }
        var lineOffset = lineOffsets[position.line];
        var nextLineOffset = (position.line + 1 < lineOffsets.length) ? lineOffsets[position.line + 1] : this._content.length;
        return Math.max(Math.min(lineOffset + position.character, nextLineOffset), lineOffset);
    };
    Object.defineProperty(FullTextDocument.prototype, "lineCount", {
        get: function () {
            return this.getLineOffsets().length;
        },
        enumerable: true,
        configurable: true
    });
    FullTextDocument.isIncremental = function (event) {
        var candidate = event;
        return candidate !== undefined && candidate !== null &&
            typeof candidate.text === 'string' && candidate.range !== undefined &&
            (candidate.rangeLength === undefined || typeof candidate.rangeLength === 'number');
    };
    FullTextDocument.isFull = function (event) {
        var candidate = event;
        return candidate !== undefined && candidate !== null &&
            typeof candidate.text === 'string' && candidate.range === undefined && candidate.rangeLength === undefined;
    };
    return FullTextDocument;
}());
var TextDocument$1;
(function (TextDocument) {
    /**
     * Creates a new text document.
     *
     * @param uri The document's uri.
     * @param languageId  The document's language Id.
     * @param version The document's initial version number.
     * @param content The document's content.
     */
    function create(uri, languageId, version, content) {
        return new FullTextDocument$1(uri, languageId, version, content);
    }
    TextDocument.create = create;
    /**
     * Updates a TextDocument by modifing its content.
     *
     * @param document the document to update. Only documents created by TextDocument.create are valid inputs.
     * @param changes the changes to apply to the document.
     * @returns The updated TextDocument. Note: That's the same document instance passed in as first parameter.
     *
     */
    function update(document, changes, version) {
        if (document instanceof FullTextDocument$1) {
            document.update(changes, version);
            return document;
        }
        else {
            throw new Error('TextDocument.update: document must be created by TextDocument.create');
        }
    }
    TextDocument.update = update;
    function applyEdits(document, edits) {
        var text = document.getText();
        var sortedEdits = mergeSort(edits.map(getWellformedEdit), function (a, b) {
            var diff = a.range.start.line - b.range.start.line;
            if (diff === 0) {
                return a.range.start.character - b.range.start.character;
            }
            return diff;
        });
        var lastModifiedOffset = 0;
        var spans = [];
        for (var _i = 0, sortedEdits_1 = sortedEdits; _i < sortedEdits_1.length; _i++) {
            var e = sortedEdits_1[_i];
            var startOffset = document.offsetAt(e.range.start);
            if (startOffset < lastModifiedOffset) {
                throw new Error('Overlapping edit');
            }
            else if (startOffset > lastModifiedOffset) {
                spans.push(text.substring(lastModifiedOffset, startOffset));
            }
            if (e.newText.length) {
                spans.push(e.newText);
            }
            lastModifiedOffset = document.offsetAt(e.range.end);
        }
        spans.push(text.substr(lastModifiedOffset));
        return spans.join('');
    }
    TextDocument.applyEdits = applyEdits;
})(TextDocument$1 || (TextDocument$1 = {}));
function mergeSort(data, compare) {
    if (data.length <= 1) {
        // sorted
        return data;
    }
    var p = (data.length / 2) | 0;
    var left = data.slice(0, p);
    var right = data.slice(p);
    mergeSort(left, compare);
    mergeSort(right, compare);
    var leftIdx = 0;
    var rightIdx = 0;
    var i = 0;
    while (leftIdx < left.length && rightIdx < right.length) {
        var ret = compare(left[leftIdx], right[rightIdx]);
        if (ret <= 0) {
            // smaller_equal -> take left to preserve order
            data[i++] = left[leftIdx++];
        }
        else {
            // greater -> take right
            data[i++] = right[rightIdx++];
        }
    }
    while (leftIdx < left.length) {
        data[i++] = left[leftIdx++];
    }
    while (rightIdx < right.length) {
        data[i++] = right[rightIdx++];
    }
    return data;
}
function computeLineOffsets(text, isAtLineStart, textOffset) {
    if (textOffset === void 0) { textOffset = 0; }
    var result = isAtLineStart ? [textOffset] : [];
    for (var i = 0; i < text.length; i++) {
        var ch = text.charCodeAt(i);
        if (ch === 13 /* CarriageReturn */ || ch === 10 /* LineFeed */) {
            if (ch === 13 /* CarriageReturn */ && i + 1 < text.length && text.charCodeAt(i + 1) === 10 /* LineFeed */) {
                i++;
            }
            result.push(textOffset + i + 1);
        }
    }
    return result;
}
function getWellformedRange(range) {
    var start = range.start;
    var end = range.end;
    if (start.line > end.line || (start.line === end.line && start.character > end.character)) {
        return { start: end, end: start };
    }
    return range;
}
function getWellformedEdit(textEdit) {
    var range = getWellformedRange(textEdit.range);
    if (range !== textEdit.range) {
        return { newText: textEdit.newText, range: range };
    }
    return textEdit;
}

// A sprintf-like implementation using `%index` placeholders (index based on 1)
// to insert arguments to the message format.
//
// Example:
//   // Unexpected function in token
//   formatMessage('Unexpected %2 in %1.', 'token', 'function')

function formatMessage (format, ...args) {
  return format.replace(/%(\d)/g, (match, index) => '' + args[index - 1])
}

let warning = false;
let debug = false;



function setLevel (level) {
  warning = debug = false;
  switch (level) {
    case 'debug':
      debug = true;
    case 'warning': // eslint-disable-line no-fallthrough
      warning = true;
  }
}

function wantDebug () {
  return debug
}

function logError (error, format, ...args) {
  console.error('[oscript]', formatMessage(format, ...args));
  console.error('[oscript]', error);
}

function logWarning (error, format, ...args) {
  if (warning) {
    console.warn('[oscript]', formatMessage(format, ...args));
    console.info('[oscript]', error);
  }
}

function logDebug (format, ...args) {
  if (debug) console.log('[oscript]', formatMessage(format, ...args));
}

const readFileAsync = util_1.promisify(fs.readFile);

let completionItemKinds;










let objectMembers;

function doInitialize() {
  // backward conversion - keep in sync with CompletionItemKind
  completionItemKinds = new Map([
    ['Text', 1], ['Method', 2], ['Function', 3], ['Constructor', 4],
    ['Field', 5], ['Variable', 6], ['Class', 7], ['Interface', 8],
    ['Module', 9], ['Property', 10], ['Unit', 11], ['Value', 12], ['Enum', 13],
    ['Keyword', 14], ['Snippet', 15], ['Color', 16], ['File', 17],
    ['Reference', 18], ['Folder', 19], ['EnumMember', 20], ['Constant', 21],
    ['Struct', 22], ['Event', 23], ['Operator', 24], ['TypeParameter', 25]]);
  return loadApi()
}

async function loadApi() {
  objectMembers = new Map;
  // create the global members ahead to be able to add built-in objects there
  const globals = new Map;
  objectMembers.set('globals', globals);
  // api contains object names as keys pointing to their members as arrays
  logDebug('loading api.json');
  const api = JSON.parse(await readFileAsync(`${__dirname}/api.json`, 'utf8'));
  Object.keys(api).forEach((name) => {
    logDebug('registering %1', name);
    const global = name === 'globals';
    // built-in objects with a capital letter (ignore "globals" and "directives")
    if (name.charCodeAt(0) < 97) {
      globals.set(name.toLowerCase(),
        { id: name, type: 'Struct', synopsis: name, comment: '', commit: '.' });
    }
    // the map for globals has been already created
    const members = global ? globals : new Map;
    for (const entry of api[name]) {
      if (entry.synopsis === undefined) entry.synopsis = entry.id;
      if (entry.comment === undefined) entry.comment = '';
      if (entry.type === 'Function' || entry.type === 'Method') {
        entry.commit = '(';
        entry.insert = `${entry.id}($0)`;
      }
      members.set(entry.id.toLowerCase(), entry);
    }
    // the map for globals has been already added
    if (!global) objectMembers.set(name.toLowerCase(), members);
  });
}

const EOF = 1;
const Whitespace = 2;
const Comment = 4;
const PreprocessorDirective = 8;
const PreprocessedAway = 16;
const Punctuator = 32;
const Keyword = 64;
const Identifier = 128;
const StringLiteral = 256;
const IntegerLiteral = 512;
const BooleanLiteral = 1024;
const UndefinedLiteral = 2048;
const RealLiteral = 4096;
const DateLiteral = 8192;
const ObjRef = 16384;
const LegacyAlias = 32768;
const KeywordOrIdentifier = Keyword | Identifier;
const PunctuatorOrKeyword = Punctuator | Keyword;
const Literal = StringLiteral | IntegerLiteral | RealLiteral | DateLiteral |
  BooleanLiteral | UndefinedLiteral | ObjRef;
const NoCode = Whitespace | Comment | PreprocessorDirective | PreprocessedAway;

var tokenTypes = /*#__PURE__*/Object.freeze({
  __proto__: null,
  EOF: EOF,
  Whitespace: Whitespace,
  Comment: Comment,
  PreprocessorDirective: PreprocessorDirective,
  PreprocessedAway: PreprocessedAway,
  Punctuator: Punctuator,
  Keyword: Keyword,
  Identifier: Identifier,
  StringLiteral: StringLiteral,
  IntegerLiteral: IntegerLiteral,
  RealLiteral: RealLiteral,
  DateLiteral: DateLiteral,
  BooleanLiteral: BooleanLiteral,
  UndefinedLiteral: UndefinedLiteral,
  ObjRef: ObjRef,
  LegacyAlias: LegacyAlias,
  Literal: Literal,
  KeywordOrIdentifier: KeywordOrIdentifier,
  PunctuatorOrKeyword: PunctuatorOrKeyword,
  NoCode: NoCode
});

function isLineTerminator (charCode) {
  return charCode === 10 || charCode === 13
}
function isWhitespace (charCode) {
  return charCode === 32 || isLineTerminator(charCode) || charCode === 9 ||
    charCode === 0xB || charCode === 0xC
}
function isDecimalDigit (charCode) {
  return charCode >= 48 && charCode <= 57
}
function isHexadecimalDigit (charCode) {
  return (charCode >= 48 && charCode <= 57) ||
    (charCode >= 65 && charCode <= 70) || (charCode >= 97 && charCode <= 102)
}
function isIdentifierStart (charCode) {
  return (charCode >= 65 && charCode <= 90) || (charCode >= 97 && charCode <= 122) || charCode === 95 || charCode === 36
}
function isIdentifierPart (charCode) {
  return isIdentifierStart(charCode) || (charCode >= 48 && charCode <= 57)
}
function isKeyword (id, oldVersion) {
  switch (id.length) {
    case 2:
      return id === 'if' || id === 'in' || id === 'to' || id === 'by' ||
        id === 'or' || id === 'eq' || id === 'ne' || id === 'lt' ||
        id === 'gt' || id === 'le' || id === 'ge' || id === 'do'
    case 3:
      return id === 'end' || id === 'for' || id === 'not' || id === 'and' ||
        (oldVersion && id === 'set')
    case 4:
      if (id === 'else' || id === 'case' || id === 'goto' || id === 'then') {
        return true
      }
      return !oldVersion && (id === 'this' || id === 'super' || id === 'none')
    case 5:
      if (id === 'while' || id === 'until' || id === 'break') {
        return true
      }
      return !oldVersion && (id === 'final' || id === 'using')
    case 6:
      if (id === 'return' || id === 'elseif' || id === 'repeat' ||
          id === 'switch' || id === 'script' || id === 'downto') {
        return true
      }
      return !oldVersion && (id === 'public' || id === 'object')
    case 7:
      if (id === 'default' || id === 'breakif' || id === 'nodebug') {
        return true
      }
      return !oldVersion && (id === 'private' || id === 'package')
    case 8:
      if (id === 'function' || id === 'continue') {
        return true
      }
      return !oldVersion && (id === 'override' || id === 'inherits')
    case 9:
      return id === 'endscript' || (!oldVersion && id === 'interface') ||
      (oldVersion && id === 'scriptend')
    case 10:
      return id === 'continueif' || (oldVersion && id === 'addfeature')
  }
  return false
}
function isType (id) {
  switch (id.length) {
    case 3:
      return id === 'set' || id === 'vis'
    case 4:
      return id === 'date' || id === 'file' || id === 'guid' ||
        id === 'list' || id === 'long' || id === 'real' || id === 'void'
    case 5:
      return id === 'assoc' || id === 'bytes' || id === 'frame' ||
      id === 'point' || id === 'regex' || id === 'error'
    case 6:
      return id === 'string' || id === 'record' || id === 'object' ||
        id === 'objref' || id === 'script' || id === 'socket' ||
        id === 'dialog'
    case 7:
      return id === 'boolean' || id === 'integer' || id === 'hashmap' ||
        id === 'capierr' || id === 'capilog' || id === 'dynamic' ||
        id === 'patfind' || id === 'wapimap' || id === 'domattr' ||
        id === 'domnode' || id === 'domtext' || id === 'otquery'
    case 8:
      return id === 'recarray' || id === 'dapinode' || id === 'filecopy' ||
        id === 'uapiuser' || id === 'wapiwork' || id === 'otsearch'
    case 9:
      return id === 'cachetree' || id === 'capilogin' || id === 'fileprefs' ||
        id === 'patchange' || id === 'sqlcursor' || id === 'domentity' ||
        id === 'domparser' || id === 'saxparser'
    case 10:
      return id === 'dapistream' || id === 'javaobject' || id === 'restclient' ||
      id === 'ssloptions' || id === 'domcomment' || id === 'domelement'
    case 11:
      return id === 'capiconnect' || id === 'dapisession' ||
        id === 'dapiversion' || id === 'mailmessage' || id === 'pop3session' ||
        id === 'smtpsession' || id === 'uapisession' || id === 'wapisession' ||
        id === 'wapimaptask' || id === 'wapisubwork' || id === 'domdocument' ||
        id === 'domnodelist' || id === 'domnotation' || id === 'ipoolobject'
    case 12:
      return id === 'xslprocessor'
    case 13:
      return id === 'sqlconnection'
    case 15:
      return id === 'domcdatasection' || id === 'domdocumenttype' ||
        id === 'domnamednodemap' || id === 'ipoolconnection'
    case 16:
      return id === 'domcharacterdata' || id === 'ipooltransaction'
    case 17:
      return id === 'domimplementation'
    case 18:
      return id === 'domentityreference'
    case 19:
      return id === 'domdocumentfragment'
    case 24:
      return id === 'domprocessinginstruction'
  }
  return false
}
function isUnaryOperator (symbol) {
  switch (symbol.length) {
    case 1:
      return symbol === '!' || symbol === '-' || symbol === '~'
    case 3:
      return symbol === 'not'
  }
  return false
}
function isBinaryOperator (symbol) {
  switch (symbol.length) {
    case 1:
      return symbol === '=' || symbol === '+' || symbol === '-' ||
        symbol === '*' || symbol === '/' || symbol === '<' || symbol === '>' ||
        symbol === '%' || symbol === '&' || symbol === '|' || symbol === '^'
    case 2:
      return symbol === '==' || symbol === '!=' || symbol === '<>' ||
        symbol === '<=' || symbol === '>=' || symbol === '&&' ||
        symbol === '||' || symbol === 'in' || symbol === '+=' ||
        symbol === '-=' || symbol === '*=' || symbol === '&=' ||
        symbol === '|=' || symbol === '^=' || symbol === '^^' ||
        symbol === '~=' || symbol === '<<' || symbol === '>>' ||
        symbol === 'or' || symbol === 'eq' || symbol === 'ne' ||
        symbol === 'lt' || symbol === 'le' || symbol === 'gt' ||
        symbol === 'ge'
    case 3:
      return symbol === 'and' || symbol === 'xor'
  }
  return false
}

var ast = {
  program (body) {
    return { type: 'Program', body }
  },
  packageDeclaration (name, object) {
    return { type: 'PackageDeclaration', name, object }
  },
  scriptSource (body) {
    return { type: 'ScriptSource', body }
  },
  dumpSource (id, parent, fatures, assignments, scripts) {
    return { type: 'DumpSource', id, parent, fatures, assignments, scripts }
  },
  featureAddition (id) {
    return { type: 'FeatureAddition', id }
  },
  featureInitialization (id, value) {
    return { type: 'FeatureInitialization', id, value }
  },
  objectDeclaration (id, modifier, superObject, body) {
    return { type: 'ObjectDeclaration', modifier, id, superObject, body }
  },
  featureDeclaration (id, featureType, modifier, init) {
    return { type: 'FeatureDeclaration', id, featureType, modifier, init }
  },
  scriptDeclaration (id, modifier, body) {
    return { type: 'ScriptDeclaration', id, modifier, body }
  },
  objectName (name) {
    return { type: 'ObjectName', name }
  },
  xlateExpression (ospace, string) {
    return { type: 'XlateExpression', ospace, string }
  },
  identifier (value, raw) {
    return { type: 'Identifier', value, raw }
  },
  legacyAlias (value, raw) {
    return { type: 'LegacyAlias', value, raw }
  },
  literal (type, value, raw) {
    const literalType = type === StringLiteral
      ? 'string'
      : type === IntegerLiteral
        ? 'integer'
        : type === BooleanLiteral
          ? 'boolean'
          : type === UndefinedLiteral
            ? 'undefined'
            : type === RealLiteral
              ? 'real'
              : type === DateLiteral
                ? 'date'
                : 'objref';
    return { type: 'Literal', literalType, value, raw }
  },
  functionDeclaration (id, functionType, modifier, params, variadic, nodebug, body) {
    return { type: 'FunctionDeclaration', id, functionType, modifier, variadic, nodebug, params, body }
  },
  parameter (id, parameterType, init) {
    return { type: 'Parameter', id, parameterType, init }
  },
  emptyStatement () {
    return { type: 'EmptyStatement' }
  },
  labelStatement (id) {
    return { type: 'LabelStatement', id }
  },
  variableDeclaration (variableType, declarations) {
    return { type: 'VariableDeclaration', variableType, declarations }
  },
  variableDeclarator (id, init) {
    return { type: 'VariableDeclarator', id, init }
  },
  conditionalExpression (test, consequent, alternate) {
    return { type: 'ConditionalExpression', test, consequent, alternate }
  },
  breakStatement () {
    return { type: 'BreakStatement' }
  },
  continueStatement () {
    return { type: 'ContinueStatement' }
  },
  breakIfStatement (test) {
    return { type: 'BreakIfStatement', test }
  },
  continueIfStatement (test) {
    return { type: 'ContinueIfStatement', test }
  },
  gotoStatement (label) {
    return { type: 'GotoStatement', label }
  },
  returnStatement (argument) {
    return { type: 'ReturnStatement', argument }
  },
  ifStatement (test, consequent, otherClauses, alternate) {
    return { type: 'IfStatement', test, consequent, otherClauses, alternate }
  },
  elseifClause (test, consequent) {
    return { type: 'ElseIfClause', test, consequent }
  },
  switchStatement (discriminant, cases) {
    return { type: 'SwitchStatement', discriminant, cases }
  },
  switchCase (tests, consequent) {
    return { type: 'SwitchCase', tests, consequent }
  },
  whileStatement (test, body) {
    return { type: 'WhileStatement', test, body }
  },
  repeatStatement (test, body) {
    return { type: 'RepeatStatement', test, body }
  },
  thisExpression () {
    return { type: 'ThisExpression' }
  },
  superExpression () {
    return { type: 'SuperExpression' }
  },
  forStatement (init, test, update, body) {
    return { type: 'ForStatement', init, test, update, body }
  },
  forEachStatement (left, right, body) {
    return { type: 'ForEachStatement', left, right, body }
  },
  structuredForStatement (variable, start, end, down, step, body) {
    return { type: 'StructuredForStatement', variable, start, end, down, step, body }
  },
  listExpression (elements) {
    return { type: 'ListExpression', elements }
  },
  listComprehension (expression, left, right, test) {
    return { type: 'ListComprehension', expression, left, right, test }
  },
  atExpression (expression) {
    return { type: 'AtExpression', expression }
  },
  assocExpression (properties) {
    return { type: 'ObjectExpression', properties }
  },
  property (key, value) {
    return { type: 'Property', key, value }
  },
  parenthesisExpression (expression) {
    return { type: 'ParenthesisExpression', expression }
  },
  binaryExpression (operator, left, right) {
    return { type: 'BinaryExpression', operator, left, right }
  },
  unaryExpression (operator, argument) {
    return { type: 'UnaryExpression', operator, argument }
  },
  memberExpression (object, property, boxed) {
    return { type: 'MemberExpression', object, property, boxed }
  },
  sliceExpression (object, start, end) {
    return { type: 'SliceExpression', object, start, end }
  },
  indexExpression (object, index) {
    return { type: 'IndexExpression', object, index }
  },
  callExpression (callee, args) {
    return { type: 'CallExpression', callee, arguments: args }
  }
};

var messages$2 = {
  unexpected: {
    code: 'E001',
    text: 'unexpected %1 \'%2\' near \'%3\''
  },
  unexpectedEOF: {
    code: 'E002',
    text: 'unexpected symbol near \'<eof>\''
  },
  expected: {
    code: 'E003',
    text: '\'%1\' expected near \'%2\''
  },
  expectedToken: {
    code: 'E004',
    text: '%1 expected near \'%2\''
  },
  malformedNumber: {
    code: 'E005',
    text: 'malformed number near \'%1\''
  },
  malformedDate: {
    code: 'E006',
    text: 'malformed date near \'%1\''
  },
  malformedHash: {
    code: 'E007',
    text: 'malformed hashquote or objref near \'%1\''
  },
  unfinishedString: {
    code: 'E008',
    text: 'unfinished string near \'%1\''
  },
  unfinishedLongString: {
    code: 'E009',
    text: 'unfinished long string (starting at line %1) near \'%2\''
  },
  unfinishedLongComment: {
    code: 'E010',
    text: 'unfinished long comment (starting at line %1) near \'%2\''
  },
  unfinishedHashQuote: {
    code: 'E011',
    text: 'unfinished hash quote (starting at line %1) near \'%2\''
  },
  unfinishedPrepDirective: {
    code: 'E012',
    text: 'unfinished preprocessor directive (starting at line %1) near \'%2\''
  },
  lineBreakInString: {
    code: 'W001',
    text: 'multi-line string not delimited by back-ticks: %1%2%1'
  },
  uselessBackslash: {
    code: 'W002',
    text: 'backslash not followed by a line-break near \'%1\''
  },
  prepDirectiveWithoutName: {
    code: 'W003',
    text: 'missing name identifier after %1 near \'%2\''
  },
  objectNotPublic: {
    code: 'W004',
    text: 'modifier %1 used instead of public for an object'
  },
  charactersAfterPrepDirective: {
    code: 'W005',
    text: 'unexpected characters after %1 near \'%2\''
  },
  unexpectedSemicolon: {
    code: 'W006',
    text: 'unexpected semicolon after %1 declaration near \'%2\''
  },
  unfinishedStatement: {
    code: 'W007',
    text: 'missing semicolon after the %1 statement near \'%2\''
  }
};

function formatMessage$1 (format, ...args) {
  return format.replace(/%(\d)/g, (match, index) => '' + args[index - 1])
}

var defaultOptions = {
  defines: {},
  tokens: false,
  preprocessor: false,
  comments: false,
  whitespace: false,
  locations: false,
  ranges: false,
  raw: false,
  rawIdentifiers: false,
  rawLiterals: false,
  sourceType: 'script',
  oldVersion: undefined,
  sourceFile: 'snippet'
};

const {
  EOF: EOF$1, Punctuator: Punctuator$1, Keyword: Keyword$1, PunctuatorOrKeyword: PunctuatorOrKeyword$1, Identifier: Identifier$1,
  KeywordOrIdentifier: KeywordOrIdentifier$1, Literal: Literal$1, StringLiteral: StringLiteral$1, IntegerLiteral: IntegerLiteral$1, RealLiteral: RealLiteral$1,
  DateLiteral: DateLiteral$1, BooleanLiteral: BooleanLiteral$1, UndefinedLiteral: UndefinedLiteral$1, ObjRef: ObjRef$1, LegacyAlias: LegacyAlias$1,
  Whitespace: Whitespace$1, Comment: Comment$1, PreprocessorDirective: PreprocessorDirective$1, PreprocessedAway: PreprocessedAway$1
} = tokenTypes;
let sourceFile;
let input;
let offset;
let lineStart;
let line;
let tokens;
let warnings;
function createError (message, code, offset, line, column, length, warning) {
  const error = new SyntaxError(message);
  const properties = {
    code: { writable: true, value: code },
    source: { writable: true, value: sourceFile },
    offset: { writable: true, value: offset },
    line: { writable: true, value: line },
    column: { writable: true, value: column },
    length: { writable: true, value: length }
  };
  if (!warning) {
    properties.tokens = { writable: true, value: tokens };
    properties.warnings = { writable: true, value: warnings };
  }
  return Object.create(error, properties)
}
function createErrorForToken (token, warning, id, ...args) {
  const { code, text } = id;
  const message = formatMessage$1(text, ...args);
  let errorOffset, errorLine, errorColumn, errorLength;
  if (token === null || typeof token.line === 'undefined') {
    errorOffset = offset;
    errorLine = line;
    errorColumn = offset - lineStart + 1;
    errorLength = 1;
  } else {
    errorOffset = token.range[0];
    errorLine = token.line;
    errorColumn = errorOffset - token.lineStart + 1;
    errorLength = token.range[1] - token.range[0];
  }
  return createError(message, code, errorOffset, errorLine, errorColumn, errorLength, warning)
}
function throwError (token, ...args) {
  throw createErrorForToken(token, false, ...args)
}
function getTokenText (token) {
  return token.raw !== undefined ? token.raw : input.slice(token.range[0], token.range[1])
}
function handleUnexpectedToken (found, expected) {
  if (expected) throwError(found, messages$2.expectedToken, expected, getTokenText(nextToken));
  if (typeof found.type !== 'undefined') {
    let type;
    switch (found.type) {
      case EOF$1: throwError(found, messages$2.unexpectedEOF); break
      case Punctuator$1: type = 'symbol'; break
      case Keyword$1: type = 'keyword'; break
      case Identifier$1: type = 'identifier'; break
      case StringLiteral$1: type = 'string'; break
      case IntegerLiteral$1: type = 'integer'; break
      case RealLiteral$1: type = 'real'; break
      case DateLiteral$1: type = 'date'; break
      case BooleanLiteral$1: type = 'boolean'; break
      case ObjRef$1: type = 'objref'; break
      case LegacyAlias$1: type = 'legacyalias'; break
      case UndefinedLiteral$1:
        throwError(found, messages$2.unexpected, 'literal', 'undefined', getTokenText(nextToken));
    }
    throwError(found, messages$2.unexpected, type, getTokenText(found), getTokenText(nextToken));
  }
  throwError(found, messages$2.unexpected, 'symbol', found, getTokenText(nextToken));
}
let length;
let tokenStart;
let afterLineBreak;
let afterScript;
let enableTokenization;
let includeWhitespace;
let includePreprocessor;
let onCreateToken;
function getTokenFromInput () {
  let charCode, peekCharCode, asterisk;
  let offsetWhitespace, lineStartWhitespace, lineWhitespace;
  let joinLines = false;
  afterLineBreak = false;
  offsetWhitespace = offset;
  lineStartWhitespace = lineStart;
  lineWhitespace = line;
  while (offset < length) {
    charCode = input.charCodeAt(offset);
    peekCharCode = input.charCodeAt(offset + 1);
    switch (charCode) {
      case 32: case 9: case 0xB: case 0xC:
        ++offset;
        continue
      case 10: case 13:
        if (charCode === 13 && peekCharCode === 10) ++offset;
        ++line;
        lineStart = ++offset;
        if (!joinLines) afterLineBreak = true;
        else joinLines = false;
        continue
      case 47:
        asterisk = peekCharCode === 42;
        if (!(asterisk || peekCharCode === 47)) break
        mayNotifyAboutWhiteSpace();
        scanComment(asterisk, true);
        joinLines = false;
        offsetWhitespace = offset;
        lineStartWhitespace = lineStart;
        lineWhitespace = line;
        continue
      case 35:
        if (!((peekCharCode === 39 && !oldVersion) || isDecimalDigit(peekCharCode))) {
          mayNotifyAboutWhiteSpace();
          if (scanPreprocessorDirective(true) === false) scanSkippedByPreprocessor();
          joinLines = false;
          offsetWhitespace = offset;
          lineStartWhitespace = lineStart;
          lineWhitespace = line;
          continue
        }
        break
      case 92:
        if (isWhitespace(peekCharCode)) {
          joinLines = true;
        } else if (peekCharCode !== '/') {
          const peekAnotherCharCode = input.charCodeAt(offset + 2);
          if (peekAnotherCharCode !== 47 && peekAnotherCharCode !== 42) {
            warnings.push(createErrorForToken({
              type: Whitespace$1,
              line,
              lineStart: lineStart,
              lastLine: line,
              lastLineStart: lineStart,
              range: [offset, offset + 1]
            }, true, messages$2.uselessBackslash, '\\'));
          }
        }
        ++offset;
        continue
    }
    break
  }
  mayNotifyAboutWhiteSpace();
  tokenStart = offset;
  if (offset >= length) {
    const token = placeToken({ type: EOF$1, value: '<eof>' });
    if (onCreateToken) onCreateToken(token);
    return token
  }
  if (isIdentifierStart(charCode)) {
    const token = scanIdentifierOrKeyword();
    afterScript = token.value === 'script';
    if (onCreateToken) onCreateToken(token);
    return token
  }
  const token = scanOtherToken(charCode, peekCharCode);
  afterScript = false;
  if (onCreateToken) onCreateToken(token);
  return token
  function mayNotifyAboutWhiteSpace () {
    if (onCreateToken && includeWhitespace && offsetWhitespace < offset) {
      onCreateToken({
        type: Whitespace$1,
        value: input.slice(offsetWhitespace, offset),
        line: lineWhitespace,
        lineStart: lineStartWhitespace,
        lastLine: line,
        lastLineStart: lineStart,
        range: [offsetWhitespace, offset],
        afterLineBreak
      });
    }
  }
}
function scanSkippedByPreprocessor () {
  let charCode, peekCharCode, asterisk;
  const offsetToSkip = offset;
  const lineStartToSkip = lineStart;
  const lineToSkip = line;
  while (offset < length) {
    charCode = input.charCodeAt(offset);
    peekCharCode = input.charCodeAt(offset + 1);
    switch (charCode) {
      case 10: case 13:
        if (charCode === 13 && peekCharCode === 10) ++offset;
        ++line;
        lineStart = ++offset;
        continue
      case 47:
        asterisk = peekCharCode === 42;
        if (!(asterisk || peekCharCode === 47)) break
        scanComment(asterisk, false);
        continue
      case 35:
        if ((peekCharCode === 39 && !oldVersion) || isDecimalDigit(peekCharCode)) break
        if (scanPreprocessorDirective(false) === true) {
          if (onCreateToken && includePreprocessor) {
            onCreateToken({
              type: PreprocessedAway$1,
              value: input.slice(offsetToSkip, offset),
              line: lineToSkip,
              lineStart: lineStartToSkip,
              lastLine: line,
              lastLineStart: lineStart,
              range: [offsetToSkip, offset]
            });
          }
          return
        }
        continue
    }
    ++offset;
  }
}
function scanOtherToken (charCode, peekCharCode) {
  switch (charCode) {
    case 39: case 34:
      return scanStringLiteral(false)
    case 96:
      if (oldVersion) break
      return scanStringLiteral(true)
    case 35:
      if (peekCharCode === 39 && !oldVersion) return scanHashQuote()
      if (isHexadecimalDigit(peekCharCode)) return scanObjRef()
      throwError(null, messages$2.malformedHash, input.slice(offset, offset + 2));
      break
    case 48: case 49: case 50: case 51: case 52: case 53:
    case 54: case 55: case 56: case 57:
      return scanNumericOrDateLiteral(true)
    case 46:
      if (isDecimalDigit(peekCharCode)) return scanNumericOrDateLiteral(false)
      if (peekCharCode === 46) {
        if (input.charCodeAt(offset + 2) === 46) return scanPunctuator('...')
        return scanPunctuator('..')
      }
      return scanPunctuator('.')
    case 58:
      if (!oldVersion && peekCharCode === 58) return scanPunctuator('::')
      return scanPunctuator(':')
    case 60:
      if (peekCharCode === 60) return scanPunctuator('<<')
      if (peekCharCode === 62) return scanPunctuator('<>')
      if (peekCharCode === 61) return scanPunctuator('<=')
      return scanPunctuator('<')
    case 62:
      if (peekCharCode === 62) return scanPunctuator('>>')
      if (peekCharCode === 61) return scanPunctuator('>=')
      return scanPunctuator('>')
    case 38:
      if (peekCharCode === 38) return scanPunctuator('&&')
      if (peekCharCode === 61) return scanPunctuator('&=')
      if (isHexadecimalDigit(peekCharCode)) return scanLegacyAlias()
      return scanPunctuator('&')
    case 94:
      if (peekCharCode === 94) return scanPunctuator('^^')
      if (peekCharCode === 61) return scanPunctuator('^=')
      return scanPunctuator('^')
    case 124:
      if (peekCharCode === 124) return scanPunctuator('||')
      if (peekCharCode === 61) return scanPunctuator('|=')
      return scanPunctuator('|')
    case 33:
      if (peekCharCode === 61) return scanPunctuator('!=')
      return scanPunctuator('!')
    case 42:
      if (peekCharCode === 61) return scanPunctuator('*=')
      return scanPunctuator('*')
    case 43:
      if (peekCharCode === 61) return scanPunctuator('+=')
      return scanPunctuator('+')
    case 45:
      if (peekCharCode === 61) return scanPunctuator('-=')
      return scanPunctuator('-')
    case 61:
      if (peekCharCode === 61) return scanPunctuator('==')
      return scanPunctuator('=')
    case 126:
      if (peekCharCode === 61) return scanPunctuator('~=')
      return scanPunctuator('~')
    case 37: case 44: case 47: case 63: case 64: case 123: case 125: case 91:
    case 92: case 93: case 40: case 41: case 59:
      return scanPunctuator(input.charAt(offset))
  }
  handleUnexpectedToken(String.fromCharCode(charCode));
}
function scanIdentifierOrKeyword () {
  const startsWithDollar = input.charCodeAt(offset) === 36;
  let value, type;
  if (afterScript) {
    let wordEnd = offset;
    let charCode, space, dash;
    for (;;) {
      charCode = input.charCodeAt(++offset);
      if (charCode === 32 || charCode === 9) {
        space = true;
        continue
      }
      if (charCode === 45) {
        dash = true;
        continue
      }
      if (space && !dash) {
        offset = wordEnd + 1;
        break
      }
      if (!isIdentifierPart(charCode)) break
      space = dash = false;
      wordEnd = offset;
    }
    value = input.slice(tokenStart, offset).toLowerCase().replace(/ /g, '');
  } else if (startsWithDollar) {
    let charCode;
    do {
      charCode = input.charCodeAt(++offset);
    } while (charCode === 32 || charCode === 9 || charCode === 36)
    const nameStart = offset;
    while (isIdentifierPart(input.charCodeAt(offset))) ++offset;
    value = input.slice(tokenStart, nameStart).replace(/ /g, '') +
      input.slice(nameStart, offset).toLowerCase();
  } else {
    while (isIdentifierPart(input.charCodeAt(++offset)));
    value = input.slice(tokenStart, offset).toLowerCase();
  }
  if (isKeyword(value, oldVersion)) {
    type = Keyword$1;
  } else if (value === 'true' || value === 'false') {
    type = BooleanLiteral$1;
    value = value === 'true';
  } else if (value === 'undefined') {
    type = UndefinedLiteral$1;
    value = null;
  } else {
    type = Identifier$1;
  }
  return placeToken({ type, value })
}
function scanHashQuote () {
  offset += 2;
  for (;;) {
    const charCode = input.charCodeAt(offset++);
    if (charCode === 39 && input.charCodeAt(offset) === 35) {
      ++offset;
      break
    }
    if (offset > length || isLineTerminator(charCode)) {
      throwError(null, messages$2.unfinishedHashQuote, input.slice(tokenStart, offset - 1));
    }
  }
  const value = input.slice(tokenStart + 2, offset - 2).toLowerCase();
  return placeToken({ type: Identifier$1, value, hashQuote: true })
}
function scanObjRef () {
  const stringStart = ++offset;
  while (isHexadecimalDigit((input.charCodeAt(offset)))) ++offset;
  const value = parseInt(input.slice(stringStart, offset), 16);
  return placeToken({ type: ObjRef$1, value })
}
function scanLegacyAlias () {
  const stringStart = ++offset;
  while (isHexadecimalDigit((input.charCodeAt(offset)))) ++offset;
  const value = parseInt(input.slice(stringStart, offset), 16);
  return placeToken({ type: LegacyAlias$1, value })
}
function scanPunctuator (value) {
  offset += value.length;
  return placeToken({ type: Punctuator$1, value })
}
function scanStringLiteral (multiline) {
  const delimiter = input.charCodeAt(offset++);
  const beginLine = line;
  const beginLineStart = lineStart;
  let stringStart = offset;
  let string = '';
  let wrongMultiline;
  out: for (;;) {
    const charCode = input.charCodeAt(offset++);
    switch (charCode) {
      case delimiter:
        if (input.charCodeAt(offset) !== delimiter) break out
        string += input.slice(stringStart, offset);
        stringStart = ++offset;
        break
      case 10: case 13:
        if (charCode === 13 && input.charCodeAt(offset) === 10) ++offset;
        ++line;
        lineStart = offset;
        if (!multiline) {
          wrongMultiline = true;
        }
    }
    if (offset > length) {
      if (multiline) throwError(token, messages$2.unfinishedLongString, beginLineStart, getTokenText(token));
      throwError(null, messages$2.unfinishedString, input.slice(tokenStart, offset - 1));
    }
  }
  string += input.slice(stringStart, offset - 1);
  const result = {
    type: StringLiteral$1,
    value: string,
    line: beginLine,
    lineStart: beginLineStart,
    lastLine: line,
    lastLineStart: lineStart,
    range: [tokenStart, offset],
    afterLineBreak
  };
  if (wrongMultiline) {
    const quote = String.fromCharCode(delimiter);
    warnings.push(createErrorForToken(result, true, messages$2.lineBreakInString, quote, string));
  }
  return result
}
function scanNumericOrDateLiteral (allowDate) {
  let charCode, real;
  while (isDecimalDigit((charCode = input.charCodeAt(offset)))) ++offset;
  const beforeDate = offset;
  if (charCode === 45 && allowDate) {
    ++offset;
    while (isDecimalDigit((charCode = input.charCodeAt(offset)))) ++offset;
    if (charCode === 45) {
      ++offset;
      while (isDecimalDigit((charCode = input.charCodeAt(offset)))) ++offset;
      if (charCode === 84) {
        ++offset;
        while (isDecimalDigit((charCode = input.charCodeAt(offset)))) ++offset;
        if (charCode !== 58) {
          throwError(null, messages$2.malformedDate, input.slice(tokenStart, offset));
        }
        ++offset;
        while (isDecimalDigit((charCode = input.charCodeAt(offset)))) ++offset;
        if (charCode !== 58) {
          throwError(null, messages$2.malformedDate, input.slice(tokenStart, offset));
        }
        ++offset;
        while (isDecimalDigit((charCode = input.charCodeAt(offset)))) ++offset;
        return placeToken({ type: DateLiteral$1, value: input.slice(tokenStart, offset) })
      }
    }
    offset = beforeDate;
  }
  if (charCode === 46) {
    real = true;
    ++offset;
    while (isDecimalDigit((charCode = input.charCodeAt(offset)))) ++offset;
  }
  if (charCode === 101 || charCode === 69) {
    real = true;
    ++offset;
    if (input.charCodeAt(offset) === 45) ++offset;
    if (!isDecimalDigit(input.charCodeAt(offset))) {
      throwError(null, messages$2.malformedNumber, input.slice(tokenStart, offset));
    }
    while (isDecimalDigit(input.charCodeAt(offset))) ++offset;
  }
  let type, parseNumber;
  if (real) {
    type = RealLiteral$1;
    parseNumber = parseFloat;
  } else {
    type = IntegerLiteral$1;
    parseNumber = parseInt;
  }
  const value = parseNumber(input.slice(tokenStart, offset));
  return placeToken({ type, value })
}
let includeComments;
function scanComment (multiline, notify) {
  const lineStartComment = lineStart;
  const lineComment = line;
  tokenStart = offset;
  offset += 2;
  const [commentStart, commentEnd] = (multiline ? scanMultilineComment : scanSingleLineComment)();
  if (notify && onCreateToken && includeComments) {
    onCreateToken({
      type: Comment$1,
      value: input.slice(commentStart, commentEnd),
      line: lineComment,
      lineStart: lineStartComment,
      lastLine: line,
      lastLineStart: lineStart,
      range: [tokenStart, offset],
      afterLineBreak
    });
  }
}
function scanSingleLineComment () {
  const commentStart = offset;
  while (offset < length) {
    if (isLineTerminator(input.charCodeAt(offset))) break
    ++offset;
  }
  return [commentStart, offset]
}
function scanMultilineComment () {
  const commentLine = line;
  const commentStart = offset;
  let charCode;
  while (offset < length) {
    charCode = input.charCodeAt(offset++);
    switch (charCode) {
      case 42:
        if (input.charCodeAt(offset) === 47) {
          ++offset;
          return [commentStart + 2, offset - 2]
        }
        break
      case 10: case 13:
        if (charCode === 13 && input.charCodeAt(offset) === 10) ++offset;
        ++line;
        lineStart = offset;
    }
  }
  throwError(null, messages$2.unfinishedLongComment, commentLine, '<eof>');
}
let defines;
function scanPreprocessorDirective (full) {
  const comments = [];
  let offsetComment, lineStartComment, lineComment, asterisk;
  const directiveOffset = tokenStart = offset;
  const startOffset = ++offset;
  out: while (offset < length) {
    const charCode = input.charCodeAt(offset);
    let peekCharCode;
    switch (charCode) {
      case 47:
        peekCharCode = input.charCodeAt(offset + 1);
        asterisk = peekCharCode === 42;
        if (!(asterisk || peekCharCode === 47)) break
        offsetComment = offset;
        lineStartComment = lineStart;
        lineComment = line;
        scanComment(asterisk, full);
        tokenStart = directiveOffset;
        if (line !== lineComment) {
          offset = offsetComment;
          lineStart = lineStartComment;
          line = lineComment;
          break out
        }
        comments.unshift([offsetComment - startOffset, offset - startOffset]);
        continue
      case 10: case 13:
        break out
    }
    ++offset;
  }
  let content = input.slice(startOffset, offset);
  for (const [start, end] of comments) {
    content = content.substr(0, start) + content.substr(end);
  }
  const [type, name, value] = full
    ? splitFullPreprocessorDirective(content)
    : trySplitPartialPreprocessorDirective(content);
  if (!type) return
  const result = executePreprocessorDirective(type, name, value);
  if ((full || result === true) && onCreateToken && includePreprocessor) {
    onCreateToken(placeToken({
      type: PreprocessorDirective$1,
      value: content,
      directive: type,
      name,
      namedValue: value
    }));
  }
  return result
}
function splitFullPreprocessorDirective (content) {
  let [, type, name, value] = /^\s*(\w+)(?:\s+(\w+))?(?:\s*(.+))?\s*$/.exec(content) || [];
  if (!type) {
    throwError(null, messages$2.unfinishedPrepDirective, line, input.slice(tokenStart, offset - 1));
  }
  type = type.toLowerCase();
  if (value) {
    value = value.trim();
    if (!value.length) value = undefined;
  }
  if (type === 'define' || type === 'undef' || type === 'ifdef' || type === 'ifndef') {
    if (name) {
      name = name.toLowerCase();
      if (type === 'define' && value === undefined) value = '1';
    } else if (type === 'define' || type === 'undef') {
      throwError(null, messages$2.unfinishedPrepDirective, line, input.slice(tokenStart, offset - 1));
    } else {
      const result = placeToken({ type: PreprocessorDirective$1, value: content });
      warnings.push(createErrorForToken(result, true, messages$2.prepDirectiveWithoutName, type, content));
    }
    if (value && (type === 'ifdef' || type === 'ifndef')) {
      const result = placeToken({ type: PreprocessorDirective$1, value: content });
      warnings.push(createErrorForToken(result, true, messages$2.charactersAfterPrepDirective, type, content));
    }
  } else if (type === 'else' || type === 'endif') {
    if (name || value) {
      const result = placeToken({ type: PreprocessorDirective$1, value: content });
      warnings.push(createErrorForToken(result, true, messages$2.charactersAfterPrepDirective, type, content));
    }
  } else {
    throwError(null, messages$2.unfinishedPrepDirective, line, input.slice(tokenStart, offset - 1));
  }
  return [type, name, value]
}
function trySplitPartialPreprocessorDirective (content) {
  let [, type, rest] = /^\s*(\w+)?(?:\s*(.+))?\s*$/.exec(content) || [];
  if (!type) return []
  type = type.toLowerCase();
  if (!(type === 'else' || type === 'endif')) return []
  if (rest && rest.trim()) {
    const result = placeToken({ type: PreprocessorDirective$1, value: content });
    warnings.push(createErrorForToken(result, true, messages$2.charactersAfterPrepDirective, type, content));
  }
  return [type]
}
function executePreprocessorDirective (directive, name, value) {
  const prevIncludeContent = enableTokenization;
  if (directive === 'define') {
    defines.set(name, value.replace(/^'|"/, '').replace(/'|"$/, ''));
  } else if (directive === 'undef') {
    delete defines.get(name);
  } else if (directive === 'ifdef') {
    enterIncludeScope(defines.has(name));
  } else if (directive === 'ifndef') {
    enterIncludeScope(!defines.has(name));
  } else if (directive === 'else') {
    flipIncludeScope();
  } else {
    leaveIncludeScope();
  }
  return prevIncludeContent !== enableTokenization ? enableTokenization : undefined
}
let includeScope;
let inclusionScopes;
let tokenBackup;
let prevTokenBackup;
let nextTokenBackup;
function enterIncludeScope (_include) {
  inclusionScopes.push(includeScope);
  includeScope = _include;
  updateIncludeScope();
}
function leaveIncludeScope () {
  checkIncludeScope();
  includeScope = inclusionScopes.pop();
  updateIncludeScope();
}
function flipIncludeScope () {
  checkIncludeScope();
  includeScope = !includeScope;
  updateIncludeScope();
}
function checkIncludeScope () {
  if (inclusionScopes.length === 0) {
    throwError(null, messages$2.unfinishedPrepDirective, line, input.slice(tokenStart, offset - 1));
  }
}
function updateIncludeScope () {
  const prevEnableTokenization = enableTokenization;
  enableTokenization = includeScope && inclusionScopes.every(scope => scope);
  if (prevEnableTokenization !== enableTokenization) {
    if (enableTokenization) {
      prevToken = prevTokenBackup;
      token = tokenBackup;
      nextToken = nextTokenBackup;
    } else {
      prevTokenBackup = prevToken;
      tokenBackup = token;
      nextTokenBackup = nextToken;
    }
  }
}
function placeToken (token) {
  token.line = token.lastLine = line;
  token.lineStart = token.lastLineStart = lineStart;
  token.range = [tokenStart, offset];
  token.afterLineBreak = afterLineBreak;
  return token
}
let token;
let prevToken;
let nextToken;
let advanceToNextToken;
function advanceToNextTokenFromInput () {
  prevToken = token;
  token = nextToken;
  nextToken = getTokenFromInput();
}
function consumePunctuator (value) {
  if (token.type === Punctuator$1 && value === token.value) {
    advanceToNextToken();
    return true
  }
  return false
}
function consumeKeyword (value) {
  if (token.type & KeywordOrIdentifier$1 && value === token.value) {
    advanceToNextToken();
    return true
  }
  return false
}
function expectPunctuator (value) {
  if (token.type === Punctuator$1 && value === token.value) advanceToNextToken();
  else throwError(token, messages$2.expected, value, getTokenText(token));
}
function expectKeyword (value) {
  if (token.type & KeywordOrIdentifier$1 && value === token.value) advanceToNextToken();
  else throwError(token, messages$2.expected, value, getTokenText(token));
}
function requirePrecedingLineBreak () {
  if (!token.afterLineBreak) {
    throwError(token, messages$2.expected, 'line break', getTokenText(token));
  }
}
function advanceToNextStatement () {
  if (token.afterLineBreak) return
  expectPunctuator(';');
}
function canAdvanceToNextStatement () {
  if (token.afterLineBreak) return true
  return consumePunctuator(';')
}
let locationsOrRanges;
let includeLocations;
let includeRanges;
let onCreateNode;
function placeNode (node, startToken) {
  if (locationsOrRanges) {
    if (includeLocations) {
      node.loc = {
        start: {
          line: startToken.line,
          column: startToken.range[0] - startToken.lineStart
        },
        end: {
          line: prevToken.lastLine,
          column: prevToken.range[1] - prevToken.lastLineStart
        }
      };
    }
    if (includeRanges) node.range = [startToken.range[0], prevToken.range[1]];
  }
  if (onCreateNode) onCreateNode(node);
  return node
}
let includeRawIdentifiers;
let includeRawLiterals;
let sourceType;
let oldVersion;
function parseProgram () {
  advanceToNextToken();
  const startToken = token;
  let body;
  switch (sourceType) {
    case 'object': body = parsePackageDeclaration(); break
    case 'script': body = parseScriptSource(); break
    case 'dump': body = parseDumpSource(); break
  }
  if (EOF$1 !== token.type) handleUnexpectedToken(token);
  return placeNode(ast.program(body), startToken)
}
function parsePackageDeclaration () {
  const startToken = token;
  expectKeyword('package');
  const name = parseObjectName();
  const object = parseObjectDeclaration();
  return placeNode(ast.packageDeclaration(name, object), startToken)
}
function parseScriptSource () {
  const startToken = token;
  const body = [];
  let encounteredFunction;
  while (token.type !== EOF$1) {
    let node;
    if (consumeKeyword('function')) {
      node = parseFunctionDeclaration(prevToken);
      encounteredFunction = true;
    } else {
      if (encounteredFunction) handleUnexpectedToken(token, 'function');
      node = parseStatement();
    }
    body.push(node);
  }
  return placeNode(ast.scriptSource(body), startToken)
}
function parseDumpSource () {
  const startToken = token;
  expectKeyword('name');
  convertSpecialLiteralsToIdentifier();
  const id = parseIdentifier();
  expectKeyword('parent');
  const parent = parseObjRef();
  const features = [];
  while (consumeKeyword('addFeature')) {
    const startToken = prevToken;
    const id = parseIdentifier();
    features.push(placeNode(ast.featureAddition(id), startToken));
  }
  const assignments = [];
  while (consumeKeyword('set')) {
    const startToken = prevToken;
    const id = parseIdentifier();
    expectPunctuator('=');
    const value = parseLiteral(true);
    assignments.push(placeNode(ast.featureInitialization(id, value), startToken));
  }
  const scripts = [];
  while (consumeKeyword('script')) scripts.push(parseScriptDeclaration(prevToken));
  return placeNode(ast.dumpSource(id, parent, features, assignments, scripts), startToken)
}
function parseObjectDeclaration () {
  const startToken = token;
  const modifier = tryModifier();
  if (!modifier) handleUnexpectedToken(token, '<modifier>');
  if (modifier !== 'public') {
    warnings.push(createErrorForToken(prevToken, true, messages$2.objectNotPublic, modifier));
  }
  expectKeyword('object');
  convertSpecialLiteralsToIdentifier();
  const id = parseIdentifierOrHashQuote();
  const superObject = consumeKeyword('inherits') ? parseObjectName() : [];
  requirePrecedingLineBreak();
  const body = [];
  while (!consumeKeyword('end')) {
    if (!(token.type & KeywordOrIdentifier$1)) handleUnexpectedToken(token, '<modifier>, <type>, function, script or end');
    const startToken = token;
    const modifier = tryModifier();
    if (!(token.type & KeywordOrIdentifier$1)) {
      let expected = '<type>, function or script';
      if (!modifier) expected = `<modifier>, ${expected}`;
      handleUnexpectedToken(token, expected);
    }
    let member = token.value;
    let node;
    switch (member) {
      case 'function':
        advanceToNextToken();
        node = parseFunctionDeclaration(startToken, modifier);
        break
      case 'script':
        advanceToNextToken();
        node = parseScriptDeclaration(startToken, modifier);
        break
      default:
        member = 'feature';
        node = parseFeatureDeclaration(startToken, modifier);
    }
    body.push(node);
    if (consumePunctuator(';')) {
      warnings.push(createErrorForToken(prevToken, true, messages$2.unexpectedSemicolon, member, ';'));
      do { body.push(parseEmptyStatement()); } while (consumePunctuator(';'))
    }
  }
  return placeNode(ast.objectDeclaration(id, modifier, superObject, body), startToken)
}
function parseFeatureDeclaration (startToken, modifier) {
  const type = checkType();
  const id = parseIdentifierOrHashQuote();
  let init;
  if (consumePunctuator('=')) init = parseExpression();
  return placeNode(ast.featureDeclaration(id, type, modifier, init), startToken)
}
function parseFunctionDeclaration (startToken, modifier) {
  let nodebug;
  if (token.type === Keyword$1 && token.value === 'nodebug') {
    advanceToNextToken();
    nodebug = true;
  }
  const type = tryType();
  const id = parseIdentifierOrHashQuote();
  const parameters = [];
  let variadic;
  if (!token.afterLineBreak) {
    expectPunctuator('(');
    while (!consumePunctuator(')')) {
      if (parameters.length) expectPunctuator(',');
      if (consumePunctuator('...')) {
        variadic = true;
        expectPunctuator(')');
        break
      }
      parameters.push(parseParameter());
    }
    requirePrecedingLineBreak();
  }
  const body = [];
  while (!consumeKeyword('end')) {
    body.push(parseStatement());
  }
  return placeNode(ast.functionDeclaration(id, type, modifier, parameters, variadic, nodebug, body), startToken)
}
function parseParameter () {
  const startToken = token;
  let type = tryType();
  let id;
  if (type && token.type === Punctuator$1) {
    id = type;
    type = undefined;
  } else {
    id = parseIdentifier();
  }
  let init;
  if (consumePunctuator('=')) init = parseExpression();
  return placeNode(ast.parameter(id, type, init), startToken)
}
function parseScriptDeclaration (startToken, modifier) {
  const id = parseIdentifierOrHashQuote();
  requirePrecedingLineBreak();
  const body = [];
  out: for (;;) {
    if (Keyword$1 === token.type) {
      switch (token.value) {
        case 'function':
          advanceToNextToken();
          body.push(parseFunctionDeclaration(prevToken));
          continue
        case 'endscript': case 'scriptend':
          requirePrecedingLineBreak();
          advanceToNextToken();
          break out
      }
    }
    body.push(parseStatement());
  }
  return placeNode(ast.scriptDeclaration(id, modifier, body), startToken)
}
function parseStatement () {
  if (token.type & KeywordOrIdentifier$1 &&
      nextToken.type === Punctuator$1 && nextToken.value === ':') {
    return parseLabel()
  }
  if (Keyword$1 === token.type) {
    switch (token.value) {
      case 'if': return parseIfStatement()
      case 'switch': return parseSwitchStatement()
      case 'while': return parseWhileStatement()
      case 'repeat': return parseRepeatStatement()
      case 'for': return parseForStatements()
      case 'goto': return parseGotoStatement()
      case 'return': return parseReturnStatement()
      case 'break': return parseBreakStatement()
      case 'continue': return parseContinueStatement()
      case 'breakif': return parseBreakIfStatement()
      case 'continueif': return parseContinueIfStatement()
    }
  }
  const type = tryTypeOfVariable();
  if (type) return parseVariableDeclaration(type)
  if (consumePunctuator(';')) return parseEmptyStatement()
  return parseExpression()
}
function parseEmptyStatement () {
  return placeNode(ast.emptyStatement(), prevToken)
}
function parseVariableDeclaration (type) {
  const startToken = prevToken;
  const variables = [];
  do {
    const startToken = token;
    const id = parseIdentifier();
    let init;
    if (consumePunctuator('=')) init = parseExpression();
    variables.push(placeNode(ast.variableDeclarator(id, init), startToken));
  } while (consumePunctuator(','))
  return placeNode(ast.variableDeclaration(type, variables), startToken)
}
function parseIfStatement () {
  const startToken = token;
  advanceToNextToken();
  const test = parseExpression();
  advanceToNextStatement();
  let consequent, otherToken, otherTest;
  const otherClauses = [];
  let alternate = [];
  let statements = [];
  for (;;) {
    if (Keyword$1 === token.type) {
      switch (token.value) {
        case 'elseif':
          if (alternate.length) throwError(token, messages$2.expected, 'end', getTokenText(token));
          savePrevClause();
          statements = [];
          otherToken = token;
          advanceToNextToken();
          otherTest = parseExpression();
          advanceToNextStatement();
          continue
        case 'else':
          savePrevClause();
          statements = [];
          advanceToNextToken();
          advanceToNextStatement();
          continue
        case 'end':
          savePrevClause();
          advanceToNextToken();
          return placeNode(ast.ifStatement(test, consequent, otherClauses, alternate), startToken)
      }
    }
    statements.push(parseStatement());
  }
  function savePrevClause () {
    if (!consequent) {
      consequent = statements;
    } else if (otherTest) {
      otherClauses.push(placeNode(ast.elseifClause(otherTest, statements), otherToken));
      otherTest = undefined;
    } else {
      alternate = statements;
    }
  }
}
function parseSwitchStatement () {
  const startToken = token;
  advanceToNextToken();
  const discriminant = parseExpression();
  advanceToNextStatement();
  let caseOrDefault, defaultCase;
  let caseToken, tests, statements;
  const cases = [];
  for (;;) {
    if (Keyword$1 === token.type) {
      switch (token.value) {
        case 'case':
          if (defaultCase) throwError(token, messages$2.expected, 'end', getTokenText(token));
          startCase();
          do { tests.push(parseExpression()); } while (consumePunctuator(','))
          break
        case 'default':
          startCase();
          defaultCase = true;
          break
        case 'end':
          if (caseOrDefault) {
            endCase();
            continue
          }
          advanceToNextToken();
          return placeNode(ast.switchStatement(discriminant, cases), startToken)
      }
      if (Keyword$1 === token.type && token.value === 'end') {
        endCase();
        continue
      }
    }
    statements.push(parseStatement());
  }
  function startCase () {
    savePrevCase();
    caseToken = token;
    advanceToNextToken();
    tests = [];
    statements = [];
    caseOrDefault = true;
  }
  function endCase () {
    savePrevCase();
    caseOrDefault = false;
    advanceToNextToken();
  }
  function savePrevCase () {
    cases.push(placeNode(ast.switchCase(tests, statements), caseToken));
  }
}
function parseWhileStatement () {
  const startToken = token;
  advanceToNextToken();
  const test = parseExpression();
  advanceToNextStatement();
  const body = parseLoopBody();
  return placeNode(ast.whileStatement(test, body), startToken)
}
function parseRepeatStatement () {
  const startToken = token;
  advanceToNextToken();
  advanceToNextStatement();
  const statements = [];
  for (;;) {
    if (consumeKeyword('until')) {
      const test = parseExpression();
      return placeNode(ast.repeatStatement(test, statements), startToken)
    }
    statements.push(parseStatement());
  }
}
function parseForStatements () {
  const startToken = token;
  advanceToNextToken();
  if (consumePunctuator('(')) return parseForStatement(startToken)
  const id = parseIdentifier();
  if (consumeKeyword('in')) return parseForEachStatement(startToken, id)
  expectPunctuator('=');
  return parseStructuredForStatement(startToken, id)
}
function parseForStatement (startToken) {
  let init, test, update;
  if (!canAdvanceToNextStatement()) {
    init = parseExpression();
    advanceToNextStatement();
  }
  if (!canAdvanceToNextStatement()) {
    test = parseExpression();
    advanceToNextStatement();
  }
  if (!consumePunctuator(')')) {
    update = parseExpression();
    expectPunctuator(')');
  }
  if (!canAdvanceToNextStatement()) {
    warnings.push(createErrorForToken(prevToken, true, messages$2.unfinishedStatement, 'for', String(token.value)));
  }
  return placeNode(ast.forStatement(init, test, update, parseLoopBody()), startToken)
}
function parseForEachStatement (startToken, left) {
  const right = parseExpression();
  advanceToNextStatement();
  return placeNode(ast.forEachStatement(left, right, parseLoopBody()), startToken)
}
function parseStructuredForStatement (startToken, variable) {
  const start = parseExpression();
  let down;
  if (consumeKeyword('downto')) {
    down = true;
  } else if (!consumeKeyword('to')) {
    throwError(token, messages$2.expected, 'to or downto', getTokenText(token));
  }
  const end = parseExpression();
  let step;
  if (consumeKeyword('by')) step = parseExpression();
  advanceToNextStatement();
  const body = parseLoopBody();
  return placeNode(ast.structuredForStatement(variable, start, end, down, step, body), startToken)
}
function parseLoopBody () {
  const body = [];
  while (!consumeKeyword('end')) body.push(parseStatement());
  return body
}
function parseGotoStatement () {
  const startToken = token;
  advanceToNextToken();
  const label = parseIdentifier();
  return placeNode(ast.gotoStatement(label), startToken)
}
function parseLabel () {
  const startToken = token;
  const id = parseIdentifier();
  advanceToNextToken();
  return placeNode(ast.labelStatement(id), startToken)
}
function parseReturnStatement () {
  const startToken = token;
  advanceToNextToken();
  const argument = token.afterLineBreak || (token.type === Punctuator$1 && token.value === ';')
    ? undefined
    : parseExpression();
  return placeNode(ast.returnStatement(argument), startToken)
}
function parseBreakStatement () {
  advanceToNextToken();
  return placeNode(ast.breakStatement(), prevToken)
}
function parseContinueStatement () {
  advanceToNextToken();
  return placeNode(ast.continueStatement(), prevToken)
}
function parseBreakIfStatement () {
  const startToken = token;
  advanceToNextToken();
  const test = parseExpression();
  return placeNode(ast.breakIfStatement(test), startToken)
}
function parseContinueIfStatement () {
  const startToken = token;
  advanceToNextToken();
  const test = parseExpression();
  return placeNode(ast.continueIfStatement(test), startToken)
}
function parsePrimaryExpression () {
  const tokenType = token.type;
  if (tokenType === Punctuator$1) {
    switch (token.value) {
      case '[': return parseXlate()
      case '{': return parseListExpressionOrComprehension()
      case '(': return parseParenthesisExpression()
    }
  } else if (tokenType & KeywordOrIdentifier$1) {
    switch (token.value) {
      case 'this': return parseSpecialIdentifier('thisExpression')
      case 'super': return parseSpecialIdentifier('superExpression')
      case 'assoc':
        if (nextToken.type === Punctuator$1 && nextToken.value === '{') {
          return parseAssocExpression()
        }
    }
    return parseObjectName(true)
  }
  return parseLiteral()
}
function parseSpecialIdentifier (type) {
  advanceToNextToken();
  return placeNode(ast[type](), prevToken)
}
function parseListExpressionOrComprehension () {
  const startToken = token;
  advanceToNextToken();
  if (consumePunctuator('}')) {
    return placeNode(ast.listExpression([]), startToken)
  }
  const firstElement = parseListElement();
  if (consumePunctuator('}')) {
    return placeNode(ast.listExpression([firstElement]), startToken)
  }
  if (consumePunctuator(',')) {
    for (const elements = [firstElement]; ;) {
      elements.push(parseListElement());
      if (token.type === Punctuator$1) {
        switch (token.value) {
          case ',': advanceToNextToken(); continue
          case '}':
            advanceToNextToken();
            return placeNode(ast.listExpression(elements), startToken)
        }
      }
    }
  }
  expectKeyword('for');
  const left = parseIdentifier();
  expectKeyword('in');
  const right = parseExpression();
  let test;
  if (consumeKeyword('if')) {
    test = parseExpression();
  }
  expectPunctuator('}');
  return placeNode(ast.listComprehension(firstElement, left, right, test), startToken)
}
function parseListElement () {
  if (consumePunctuator('@')) {
    const startToken = prevToken;
    return placeNode(ast.atExpression(parseExpression()), startToken)
  }
  return parseExpression()
}
function parseAssocExpression () {
  const startToken = token;
  advanceToNextToken();
  advanceToNextToken();
  const properties = [];
  while (!consumePunctuator('}')) {
    if (properties.length) expectPunctuator(',');
    const startToken = token;
    const key = parseExpression();
    expectPunctuator(':');
    const value = parseExpression();
    properties.push(placeNode(ast.property(key, value), startToken));
  }
  return placeNode(ast.assocExpression(properties), startToken)
}
function parseParenthesisExpression () {
  const startToken = token;
  advanceToNextToken();
  const expression = parseExpression();
  expectPunctuator(')');
  return placeNode(ast.parenthesisExpression(expression), startToken)
}
function parseMemberSliceCallExpression () {
  const startToken = token;
  let left = consumePunctuator('.')
    ? parseMemberExpression(placeNode(ast.thisExpression(), prevToken))
    : parsePrimaryExpression();
  for (;;) {
    if (consumePunctuator('.')) {
      left = parseMemberExpression(startToken, left);
    } else if (consumePunctuator('[')) {
      left = parseSliceExpression(startToken, left);
    } else if (consumePunctuator('(')) {
      left = parseCallExpression(startToken, left);
    } else {
      return left
    }
  }
}
function parseMemberExpression (startToken, object) {
  if (consumePunctuator('(')) {
    const startToken = prevToken;
    const property = parseExpression();
    expectPunctuator(')');
    return placeNode(ast.memberExpression(object, property, true), startToken)
  }
  let property;
  switch (token.type) {
    case Keyword$1: case Identifier$1:
      property = parseIdentifier();
      break
    default:
      property = parseLiteral();
  }
  return placeNode(ast.memberExpression(object, property), startToken)
}
function parseSliceExpression (startToken, object) {
  let start, end;
  if (consumePunctuator(':')) {
    end = parseExpression();
    expectPunctuator(']');
  } else {
    start = parseExpression();
    if (consumePunctuator(':')) {
      if (!consumePunctuator(']')) {
        end = parseExpression();
        expectPunctuator(']');
      }
    } else {
      expectPunctuator(']');
    }
  }
  return placeNode(end
    ? ast.sliceExpression(object, start, end)
    : ast.indexExpression(object, start), startToken)
}
function parseCallExpression (startToken, callee) {
  const args = [];
  while (!consumePunctuator(')')) {
    if (args.length) expectPunctuator(',');
    args.push(parseExpression());
  }
  return placeNode(ast.callExpression(callee, args), startToken)
}
function parseUnaryExpression () {
  if (token.type & PunctuatorOrKeyword$1 && isUnaryOperator(token.value)) {
    const startToken = token;
    const operator = token.value;
    advanceToNextToken();
    const argument = parseUnaryExpression();
    return placeNode(ast.unaryExpression(operator, argument), startToken)
  }
  return parseMemberSliceCallExpression()
}
function parseBinaryExpression () {
  const startToken = token;
  let left = parseUnaryExpression();
  for (;;) {
    if (!(token.type & PunctuatorOrKeyword$1 && isBinaryOperator(token.value))) return left
    const operator = token.value;
    advanceToNextToken();
    const right = parseUnaryExpression();
    left = placeNode(ast.binaryExpression(operator, left, right), startToken);
  }
}
function parseExpression () {
  const test = parseBinaryExpression();
  if (consumePunctuator('?')) {
    const startToken = prevToken;
    const consequent = parseExpression();
    expectPunctuator(':');
    const alternate = parseExpression();
    return placeNode(ast.conditionalExpression(test, consequent, alternate), startToken)
  }
  return test
}
function parseXlate () {
  const startToken = token;
  advanceToNextToken();
  const ospace = parseIdentifier();
  expectPunctuator('.');
  convertSpecialLiteralsToIdentifier();
  const string = parseIdentifier();
  expectPunctuator(']');
  return placeNode(ast.xlateExpression(ospace, string), startToken)
}
function parseObjectName (expression) {
  const startToken = token;
  convertSpecialLiteralsToIdentifier();
  const name = [parseIdentifier()];
  while (consumePunctuator('::')) {
    convertSpecialLiteralsToIdentifier();
    name.push(parseIdentifierOrHashQuoteOrLegacyAlias());
  }
  return expression && name.length === 1
    ? createIdentifier()
    : placeNode(ast.objectName(name), startToken)
}
function parseIdentifier () {
  if (!(token.type & KeywordOrIdentifier$1)) handleUnexpectedToken(token, '<identifier>');
  if (token.hashQuote) handleUnexpectedToken(token);
  return finishIdentifier()
}
function parseIdentifierOrHashQuote () {
  if (!(token.type & KeywordOrIdentifier$1)) handleUnexpectedToken(token, '<identifier>');
  return finishIdentifier()
}
function parseIdentifierOrHashQuoteOrLegacyAlias () {
  const tokenType = token.type;
  if (!(tokenType & KeywordOrIdentifier$1 || tokenType === LegacyAlias$1)) handleUnexpectedToken(token, '<identifier>');
  return finishIdentifier()
}
function finishIdentifier () {
  advanceToNextToken();
  return createIdentifier()
}
function createIdentifier () {
  const raw = includeRawIdentifiers
    ? input.slice(prevToken.range[0], prevToken.range[1])
    : undefined;
  return placeNode(prevToken.type === LegacyAlias$1
    ? ast.legacyAlias(prevToken.value, raw)
    : ast.identifier(prevToken.value, raw), prevToken)
}
function convertSpecialLiteralsToIdentifier () {
  switch (token.type) {
    case UndefinedLiteral$1:
      token.type = Identifier$1;
      token.value = 'Undefined';
      break
    case BooleanLiteral$1:
      token.type = Identifier$1;
      token.value = token.value ? 'True' : 'False';
  }
}
function parseLiteral (allowXlate) {
  const startToken = token;
  let tokenType = token.type;
  let tokenValue = token.value;
  let negative;
  if (tokenType === Punctuator$1) {
    if (tokenValue === '{') return parseListExpressionOrComprehension()
    if (allowXlate && tokenValue === '[') return parseXlate()
    if (tokenValue === '-') {
      advanceToNextToken();
      tokenType = token.type;
      tokenValue = token.value;
      negative = true;
    }
  } else if (tokenType & KeywordOrIdentifier$1 && tokenValue === 'assoc' &&
      nextToken.type === Punctuator$1 && nextToken.value === '{') {
    return parseAssocExpression()
  }
  if (!(tokenType & Literal$1)) handleUnexpectedToken(token, '<literal>');
  advanceToNextToken();
  let raw = includeRawLiterals
    ? input.slice(prevToken.range[0], prevToken.range[1])
    : undefined;
  if (negative) {
    tokenValue = -tokenValue;
    if (includeRawLiterals) raw = `-${raw}`;
  }
  return placeNode(ast.literal(tokenType, tokenValue, raw), startToken)
}
function parseObjRef () {
  if (token.type !== ObjRef$1) handleUnexpectedToken(token, '<objref>');
  return parseLiteral()
}
function tryModifier () {
  const value = token.value;
  switch (value) {
    case 'override': case 'public': case 'private':
      advanceToNextToken();
      return value
  }
}
function tryType () {
  const value = token.value;
  if (value !== null && isType(value)) {
    advanceToNextToken();
    return value
  }
}
function tryTypeOfVariable () {
  const value = token.value;
  if (value !== null && isType(value) && (nextToken.type & KeywordOrIdentifier$1)) {
    advanceToNextToken();
    return value
  }
}
function checkType () {
  const type = tryType();
  if (!type) handleUnexpectedToken(token, '<type>');
  return type
}
let includeTokens;
function parseText (_input, _options) {
  initialize(_input, _options);
  if (includeTokens) {
    tokens = [];
    onCreateToken = token => tokens.push(token);
  }
  advanceToNextToken = advanceToNextTokenFromInput;
  nextToken = getTokenFromInput();
  const program = parseProgram();
  program.tokens = tokens && tokens.slice(0, tokens.length - 1);
  program.warnings = warnings;
  return program
}
function initialize (_input, _options) {
  const options = Object.assign({}, defaultOptions, _options);
  let includeRaw;
  ({
    tokens: includeTokens,
    preprocessor: includePreprocessor,
    comments: includeComments,
    whitespace: includeWhitespace,
    locations: includeLocations,
    ranges: includeRanges,
    raw: includeRaw,
    rawIdentifiers: includeRawIdentifiers,
    rawLiterals: includeRawLiterals,
    sourceType,
    oldVersion,
    sourceFile,
    onCreateNode,
    onCreateToken
  } = options);
  if (sourceType !== 'object' && sourceType !== 'script' && sourceType !== 'dump') {
    throw new Error(`Source type "${sourceType}" not supported.`)
  }
  if (oldVersion === undefined) {
    oldVersion = sourceType === 'dump';
  } else if (oldVersion && sourceType === 'object') {
    throw new Error('Source type "object" requires the new OScript version.')
  } else if (!oldVersion && sourceType === 'dump') {
    throw new Error('Source type "dump" requires the old OScript version.')
  }
  if (includePreprocessor || includeComments || includeWhitespace) includeTokens = true;
  if (includeRaw) includeRawIdentifiers = includeRawLiterals = true;
  locationsOrRanges = includeLocations || includeRanges;
  const _defines = options.defines;
  defines = new Map(_defines && Object.keys(_defines).map(key => [key, _defines[key]]));
  input = _input;
  offset = 0;
  line = 1;
  lineStart = 0;
  length = input.length;
  enableTokenization = includeScope = true;
  afterLineBreak = afterScript = false;
  inclusionScopes = [];
  warnings = [];
}

const sourceTypes = {
  '.e': 'script',
  '.os': 'object',
  '.osx': 'dump'
};










function ensureParsedDocument(textDocument, extras) {
  if (extras.ast === undefined) {
    const sourceFile = extras.path;
    const sourceType = sourceTypes[path.extname(sourceFile)];
    try {
      const program = parseText(textDocument.getText(), {
        tokens: true, locations: true, ranges: true, rawIdentifiers: true,
        sourceType, sourceFile
      });
      logDebug('document parsed: %1 tokens, %2 warnings',
        program.tokens.length, program.warnings.length);
      extras.error = null;
      extras.ast = program;
      extras.tokens = program.tokens || [];
      extras.warnings = program.warnings;
    } catch (error) {
      logWarning(error, 'document parsing failed: %1 tokens, %2 warnings',
        error.tokens.length, error.warnings.length);
      extras.error = error;
      extras.ast = null;
      extras.tokens = error.tokens || [];
      extras.warnings = error.warnings;
    }
  }
  return extras
}

function doValidation(textDocument, originalExtras, options) {
  const { uri } = textDocument;
  const { error, warnings } = ensureParsedDocument(textDocument, originalExtras);
  const diagnostics = warnings.map(warning => diagnoseWarning(warning, uri, options));
  if (error) diagnostics.push(diagnoseError(error));
  return diagnostics
}

function diagnoseError(error) {
  return node$2.Diagnostic.create(getErrorRange(error), error.message,
    node$2.DiagnosticSeverity.Error, error.code, 'oslint')
}

function diagnoseWarning(warning, uri, options) {
  const range = getErrorRange(warning);
  const relatedInformation = options.relatedInformation
    ? [node$2.DiagnosticRelatedInformation.create(
      node$2.Location.create(uri, range),
      'The OScript VM is forgiving and this code will be parsed and executed without problems. However, the language specification is stricter and you should adhere to it.')]
    : undefined;
  return node$2.Diagnostic.create(range, warning.message,
    node$2.DiagnosticSeverity.Warning, warning.code, 'oslint', relatedInformation)
}

function getErrorRange(error) {
  let line, start,  end;
  if (error.line) {
    line = error.line - 1;
    start = error.column - 1;
    end = start + error.length;
  } else {
    line = start = end = 0;
  }
  return node$2.Range.create(node$2.Position.create(line, start), node$2.Position.create(line, end))
}

// eslint-disable-next-line @typescript-eslint/naming-convention
const { Identifier: Identifier$2, Punctuator: Punctuator$2, KeywordOrIdentifier: KeywordOrIdentifier$2 } = tokenTypes;

function resolveDirective(textDocument, position, empty) {
  const line = textDocument.getText(node$2.Range.create(
    node$2.Position.create(position.line, Math.max(position.character - 6, 0)),
    node$2.Position.create(position.line, position.character + 6))); // 6 is ifndef length
  const regexp = empty ? /^\s*#(\w+)?/ : /^\s*#(\w+)/;
  const match = regexp.exec(line);
  if (match) {
    const directive = match[1];
    logDebug('directive %1 matched', directive);
    return ['directives', directive || '']
  } else {
    logDebug('no directive matched');
  }
}

function resolveIdentifier(tokens, position, empty) {
  let index = findTokenIndex(tokens, position);
  // sanity check; a token should be always found
  if (index < 0) {
    logDebug('no token found');
    return
  }
  const token = tokens[index];
  let member;
  if (token.type & KeywordOrIdentifier$2) {
    // remember the identifier and try if it is not a member of an object
    member = String(token.value);
    if (index > 1) {
      const symbol = tokens[index - 1];
      if (isDotSymbol(symbol)) index -= 2;
      else index = -1;
    } else {
      index = -1;
    }
  } else if (empty && isDotSymbol(token)) {
    // allow all identifiers and point to the object
    member = '';
    --index;
  } else {
    // only keywords, types, constants, functions, objects and methods are completable
    logDebug('no keyword or identifier matched (%1)', token.type);
    return
  }
  // complete members of the dereferenced object
  let object = 'globals';
  if (index >= 0) {
    const objectToken = tokens[index];
    if (objectToken.type !== Identifier$2) {
      logDebug('no identifier matched (*%1)', objectToken.type);
      return
    }
    object = String(objectToken.value);
  }
  logDebug('matched identifier %1.%2', object, member || '*');
  return [object, member]
}

function isDotSymbol(token) {
  return token.type === Punctuator$2 && token.value === '.'
}

function findTokenIndex(tokens, position) {
  const line = position.line + 1;
  let token, tokenIndex;
  // find the line with the token using binary search
  let startToken = 0;
  let endToken = tokens.length;
  for (;;) {
    tokenIndex = startToken + Math.floor((endToken - startToken) / 2);
    token = tokens[tokenIndex];
    if (line === token.line) break
    if (line < token.line) endToken = tokenIndex;
    else startToken = tokenIndex + 1;
    if (startToken >= endToken) return -1
  }
  // try matching tokens on the same line in left or right directions
  const column = position.character;
  const lastToken = tokens.length - 1;
  for (;;) {
    const { lineStart } = token;
    const startColumn = token.range[0] - lineStart;
    const endColumn = token.range[1] - lineStart;
    if (column >= startColumn && column < endColumn) return tokenIndex
    if (column < startColumn) {
      if (tokenIndex === 0) return tokenIndex
      token = tokens[--tokenIndex];
      if (token.line !== line) return tokenIndex + 1
    } else {
      if (tokenIndex === lastToken) return tokenIndex
      token = tokens[++tokenIndex];
      if (token.line !== line) return tokenIndex - 1
    }
  }
}

function doCompletion(textDocument, position, extras) {
  let object, member;
  // try directives at first; incomplete ones fail the tokenization
  const matched = resolveDirective(textDocument, position, true);
  if (matched) {
    [object, member] = matched;
  } else {
    const { tokens } = ensureParsedDocument(textDocument, extras);
    // skip invalid documents
    if (!tokens.length) {
      logDebug('invalid or empty document');
      return
    }
    // point to the last typed character
    if (position.character > 0) --position.character; 
    const matched = resolveIdentifier(tokens, position, true);
    // skip other than object or member identifiers
    if (!matched) return
    ;[object, member] = matched;
  }

  const entries = objectMembers.get(object);
  if (!entries) {
    logDebug('no object matched %1', object);
    return
  }

  // find all members starting with the typed identifier part
  const items = [];
  for (const [key, entry] of entries.entries()) {
    if (!key.startsWith(member)) continue
    const kind = completionItemKinds.get(entry.type) || node$2.CompletionItemKind.Text;
    items.push({
      // sortText/preselect ranks higher than other completions and shows up first
      label: entry.id, kind, sortText: '-1', preselect: true, data: entry
    });
  }
  if (wantDebug()) {
    logDebug('complete with %1', JSON.stringify(items.map(({ label }) => label)));
  }
  return { items, isIncomplete: true }
}

function doCompletionResolve(item) {
  const entry = item.data;
  if (entry) {
    const { synopsis } = entry;
    logDebug('complete %1 with %2', item.label, synopsis);
    item.detail = synopsis;
    item.documentation = {
      kind: node$2.MarkupKind.Markdown,
      value: entry.comment
    };
    if (entry.space) {
      item.commitCharacters = [' '];
      item.insertText = `${entry.id} `;
    } else {
      if (entry.commit) item.commitCharacters = [entry.commit];
      if (entry.insert) {
        item.insertTextFormat = node$2.InsertTextFormat.Snippet;
        item.insertText = entry.insert;
      }
    }
  } else {
    logDebug('no complete resolution for %1', item.label);
  }
  return item
}

function doHover(textDocument, position, extras) {
  let object, member;
  // try directives at first; incomplete ones fail the tokenization
  const matched = resolveDirective(textDocument, position, false);
  if (matched) {
    [object, member] = matched;
  } else {
    const { tokens } = ensureParsedDocument(textDocument, extras);
    // skip invalid documents
    if (!tokens.length) {
      logDebug('invalid document');
      return
    }
    const matched = resolveIdentifier(tokens, position, false);
    // skip other than object or member identifiers
    if (!matched) return
    ;[object, member] = matched;
  }

  const entries = objectMembers.get(object);
  if (!entries) {
    logDebug('no object matched %1', object);
    return
  }
  const entry = entries.get(member);
  if (!entry) {
    logDebug('no member matched %1', member);
    return
  }

  const { synopsis, comment } = entry;
  logDebug('hover "%1" and %2 characters of comment', synopsis, comment.length);
  return {
    contents: {
      kind: node$2.MarkupKind.Markdown,
      value: `\`${synopsis}\`\n\n${comment}`
    },
    range: node$2.Range.create(position,
      node$2.Position.create(position.line, position.character + member.length))
  }
}

function simple (node, visitors, baseVisitor, state) {
  if (!baseVisitor) baseVisitor = base;
  walk(node, null, state);
  function walk (node, parent, state) {
    const { type } = node;
    const callbacks = visitors[type];
    let pre, post;
    if (callbacks) ({ pre, post } = callbacks);
    if (pre && pre(node, state, parent)) return
    baseVisitor[type](node, state, walk);
    if (post) post(node, state, parent);
  }
}
function findNodeAround (node, position, test, baseVisitor, state) {
  const { line, column } = position;
  const { pre, post } = makeFindTest(test);
  if (!baseVisitor) baseVisitor = base;
  try {
    walk(node, null, state);
  } catch (error) {
    if (error instanceof FoundWithParent) return { node: error.node, state, parent: error.parent }
    throw error
  }
  function walk (node, parent, state) {
    const { type, loc } = node;
    const { start, end } = loc;
    if (start.line > line || end.line < line ||
        (start.line  === line && start.line === end.line &&
        (start.column > column || end.column < column))) return
    if (pre && pre(node, state, parent)) return
    baseVisitor[type](node, state, walk);
    if (post(node, state, parent)) throw new FoundWithParent(node, parent)
  }
}
function makeFindTest (test) {
  if (typeof test === 'string') return { post: ({ type }) => type === test }
  else if (typeof test === 'function') return { post: test }
  else if (!test) return { post: () => true }
  else return test
}
class FoundWithParent {
  constructor (node, parent) { this.node = node; this.parent = parent; }
}
function ignore () {}
const base = {};
base.Program = (node, state, walk) => {
  walk(node.body, node, state);
};
base.PackageDeclaration = (node, state, walk) => {
  walk(node.name, node, state);
  walk(node.object, node, state);
};
base.ObjectDeclaration = (node, state, walk) => {
  walk(node.id, node, state);
  if (node.superObject) walk(node.superObject, node, state);
  for (const declaration of node.body) walk(declaration, node, state);
};
base.FeatureDeclaration = (node, state, walk) => {
  walk(node.id, node, state);
  if (node.init) walk(node.init, node, state);
};
base.ObjectName = (node, state, walk) => {
  for (const identifier of node.name) walk(identifier, node, state);
};
base.ScriptSource = (node, state, walk) => {
  for (const statement of node.body) walk(statement, node, state);
};
base.DumpSource = (node, state, walk) => {
  walk(node.id, node, state);
  walk(node.parent, node, state);
  for (const feature of node.assignments) walk(feature, node, state);
  for (const assignment of node.assignments) walk(assignment, node, state);
  for (const script of node.scripts) walk(script, node, state);
};
base.FeatureAddition = base.LabelStatement = (node, state, walk) => {
  walk(node.id, node, state);
};
base.FeatureInitialization = (node, state, walk) => {
  walk(node.id, node, state);
  walk(node.value, node, state);
};
base.ScriptDeclaration = (node, state, walk) => {
  walk(node.id, node, state);
  for (const part of node.body) walk(part, node, state);
};
base.FunctionDeclaration = (node, state, walk) => {
  walk(node.id, node, state);
  for (const param of node.params) walk(param, node, state);
  for (const statement of node.body) walk(statement, node, state);
};
base.Parameter = (node, state, walk) => {
  walk(node.id, node, state);
  if (node.init) walk(node.init, node, state);
};
base.IfStatement = (node, state, walk) => {
  walk(node.test, node, state);
  for (const statement of node.consequent) walk(statement, node, state);
  for (const statement of node.otherClauses) walk(statement, node, state);
  for (const statement of node.alternate) walk(statement, node, state);
};
base.ElseIfClause = (node, state, walk) => {
  walk(node.test, node, state);
  for (const statement of node.consequent) walk(statement, node, state);
};
base.SwitchStatement = (node, state, walk) => {
  walk(node.discriminant, node, state);
  for (const switchCase of node.cases) walk(switchCase, node, state);
};
base.SwitchCase = (node, state, walk) => {
  for (const test of node.tests) walk(test, node, state);
  for (const switchCase of node.consequent) walk(switchCase, node, state);
};
base.WhileStatement = base.RepeatStatement = (node, state, walk) => {
  walk(node.test, node, state);
  for (const statement of node.body) walk(statement, node, state);
};
base.ForStatement = (node, state, walk) => {
  if (node.init) walk(node.test, node, state);
  if (node.test) walk(node.test, node, state);
  if (node.update) walk(node.update, node, state);
  for (const statement of node.body) walk(statement, node, state);
};
base.ForEachStatement = (node, state, walk) => {
  walk(node.left, node, state);
  walk(node.right, node, state);
  for (const statement of node.body) walk(statement, node, state);
};
base.StructuredForStatement = (node, state, walk) => {
  walk(node.variable, node, state);
  walk(node.start, node, state);
  walk(node.end, node, state);
  if (node.step) walk(node.step, node, state);
  for (const statement of node.body) walk(statement, node, state);
};
base.BreakStatement = base.ContinueStatement = base.EmptyStatement = ignore;
base.BreakIfStatement = base.ContinueIfStatement = (node, state, walk) => {
  walk(node.test, node, state);
};
base.GotoStatement = (node, state, walk) => {
  walk(node.label, node, state);
};
base.ReturnStatement = (node, state, walk) => {
  if (node.argument) walk(node.argument, node, state);
};
base.VariableDeclaration = (node, state, walk) => {
  for (const declaration of node.declarations) walk(declaration, node, state);
};
base.VariableDeclarator = (node, state, walk) => {
  walk(node.id, node, state);
  if (node.init) walk(node.init, node, state);
};
base.ConditionalExpression = (node, state, walk) => {
  walk(node.test, node, state);
  for (const statement of node.consequent) walk(statement, node, state);
  for (const statement of node.alternate) walk(statement, node, state);
};
base.BinaryExpression = (node, state, walk) => {
  walk(node.left, node, state);
  walk(node.right, node, state);
};
base.UnaryExpression = (node, state, walk) => {
  walk(node.argument, node, state);
};
base.MemberExpression = (node, state, walk) => {
  walk(node.object, node, state);
  walk(node.property, node, state);
};
base.SliceExpression = (node, state, walk) => {
  walk(node.object, node, state);
  walk(node.start, node, state);
  walk(node.end, node, state);
};
base.IndexExpression = (node, state, walk) => {
  walk(node.object, node, state);
  walk(node.index, node, state);
};
base.CallExpression = (node, state, walk) => {
  walk(node.callee, node, state);
  for (const argument of node.arguments) walk(argument, node, state);
};
base.ThisExpression = base.SuperExpression = ignore;
base.AssocExpression = (node, state, walk) => {
  for (const property of node.properties) walk(property, node, state);
};
base.Property = (node, state, walk) => {
  walk(node.key, node, state);
  walk(node.value, node, state);
};
base.ListExpression = (node, state, walk) => {
  for (const element of node.elements) walk(element, node, state);
};
base.ListComprehension = (node, state, walk) => {
  walk(node.expression, node, state);
  walk(node.left, node, state);
  walk(node.right, node, state);
  if (node.test) walk(node.test, node, state);
};
base.AtExpression = base.ParenthesisExpression = (node, state, walk) => {
  walk(node.expression, node, state);
};
base.XlateExpression = (node, state, walk) => {
  walk(node.ospace, node, state);
  walk(node.string, node, state);
};
base.Identifier = base.LegacyAlias = base.Literal = ignore;

function getNodeRange (node) {
  const { start, end } = node.loc;
  return node$2.Range.create(node$2.Position.create(start.line - 1, start.column),
    node$2.Position.create(end.line - 1, end.column))
}

function doFlatSymbols(textDocument, extras) {
  const { ast } = ensureParsedDocument(textDocument, extras);
  if (!ast) { // skip invalid documents
    logDebug('invalid document');
    return
  }
  const symbols = [];
  simple(ast, {
    PackageDeclaration: {
      pre(node) {
        symbols.push(node$2.SymbolInformation.create(
          getPackageName(node), node$2.SymbolKind.Module, getNodeRange(node)));
      }
    },
    ObjectDeclaration: {
      pre(node) {
        symbols.push(node$2.SymbolInformation.create(
          node.id.raw, node$2.SymbolKind.Object, getNodeRange(node)));
      }
    },
    ScriptDeclaration: {
      pre(node) {
        symbols.push(node$2.SymbolInformation.create(
          node.id.raw, node$2.SymbolKind.Function, getNodeRange(node)));
      }
    },
    FunctionDeclaration: {
      pre(node) {
        symbols.push(node$2.SymbolInformation.create(
          node.id.raw, node$2.SymbolKind.Method, getNodeRange(node)));
        return true
      }
    },
    FeatureDeclaration: {
      pre(node) {
        symbols.push(node$2.SymbolInformation.create(
          node.id.raw, node$2.SymbolKind.Property, getNodeRange(node)));
        return true
      }
    },
    FeatureAddition: {
      pre(node) {
        symbols.push(node$2.SymbolInformation.create(
          node.id.raw, node$2.SymbolKind.Property, getNodeRange(node)));
        return true
      }
    },
    FeatureInitialization: {
      pre(node) {
        symbols.push(node$2.SymbolInformation.create(
          node.id.raw, node$2.SymbolKind.Property, getNodeRange(node)));
        return true
      }
    }
  });
  logDebug('%1 flat symbols found', symbols.length);
  return symbols
}

function doHierarchicalSymbols(textDocument, extras) {
  const { ast } = ensureParsedDocument(textDocument, extras);
  if (!ast) { // skip invalid documents
    logDebug('invalid document');
    return
  }
  const symbols = [];
  const scopes = [];
  let currentScope = symbols;
  simple(ast, {
    PackageDeclaration: {
      pre(node) {
        const children = [];
        currentScope.push(node$2.DocumentSymbol.create(
          getPackageName(node), undefined, node$2.SymbolKind.Module,
          getNodeRange(node), getNodeRange(node.name), children));
        scopes.push(currentScope);
        currentScope = children;
      }
    },
    ObjectDeclaration: {
      pre(node) {
        const children = [];
        currentScope.push(node$2.DocumentSymbol.create(
          node.id.raw, undefined, node$2.SymbolKind.Object, 
          getNodeRange(node), getNodeRange(node.id), children));
        scopes.push(currentScope);
        currentScope = children;
      }
    },
    ScriptDeclaration: {
      pre(node) {
        const children = [];
        currentScope.push(node$2.DocumentSymbol.create(
          node.id.raw, undefined, node$2.SymbolKind.Function,
          getNodeRange(node), getNodeRange(node.id), children));
        scopes.push(currentScope);
        currentScope = children;
      },
      post() {
        currentScope = scopes.pop();
      }
    },
    FunctionDeclaration: {
      pre(node) {
        currentScope.push(node$2.DocumentSymbol.create(
          node.id.raw, undefined, node$2.SymbolKind.Method,
          getNodeRange(node), getNodeRange(node.id)));
        return true
      }
    },
    FeatureDeclaration: {
      pre(node) {
        currentScope.push(node$2.DocumentSymbol.create(
          node.id.raw, undefined, node$2.SymbolKind.Property,
          getNodeRange(node), getNodeRange(node.id)));
        return true
      }
    },
    FeatureAddition: {
      pre(node) {
        currentScope.push(node$2.DocumentSymbol.create(
          node.id.raw, undefined, node$2.SymbolKind.Property,
          getNodeRange(node), getNodeRange(node.id)));
        return true
      }
    },
    FeatureInitialization: {
      pre(node) {
        currentScope.push(node$2.DocumentSymbol.create(
          node.id.raw, undefined, node$2.SymbolKind.Property,
          getNodeRange(node), getNodeRange(node.id)));
        return true
      }
    }
  });
  logDebug('%1 hierarchical symbols found', symbols.length);
  return symbols
}

function getPackageName (pkg) {
  const { name } = pkg.name;
  const lastNamePart = name[name.length - 1];
  return lastNamePart.raw // identifier or legacy alias
}

function findLocalsInScope (scope, node) {
  const results = [];
  const { value } = node;
  let nestedScope;
  let ignoreScope = false;
  // Find all occurrences of the identifier denoting a variable or a local function
  simple(scope, {
    Identifier: {
      post (node, state, parent) {
        // Skip the scope itself, if it has accidentally the same name. Also,
        // skip nested scopes, if they contain a local declaration using the
        // same identifier value.
        if (scope !== node && !ignoreScope &&
            mayComeFromVariable(node, parent) && node.value === value) {
          results.push({ node, parent });
        }
      }
    },
    FunctionDeclaration: {
      pre (node) {
        // Do not limit the initial scope of the variable itself
        if (node === scope) return
        // Skip the nested function if an argument shadows the outer variable
        if (node.params.some(({ id }) => id.value === value)) return true
        nestedScope = node;
      },
      post () {
        nestedScope = undefined;
        ignoreScope = false;
      }
    },
    VariableDeclarator: {
      pre (node) {
        // Skip the rest of the nested function if an inner variable
        // shadows the outer variable
        if (nestedScope && node.id.value === value) {
          ignoreScope = true;
          return true
        }
      }
    }
  });
  logDebug('found %1 identifiers', results.length);
  return results
}

function findScopeOfLocal (ast, position) {
  const astPosition = { line: position.line + 1, column: position.character + 1 };
  const scopes = [];
  const { type: sourceType } = ast.body;
  let script;
  logDebug('checking the line %2 and column %3 of a %3',
    position.line + 1, position.character + 1, sourceType);
  if (sourceType === 'ScriptSource') { // all identifiers in scripts are local
    scopes.push(ast.body);
    script = true;
  }
  // Firstly, find if the cursor points to an identifier, which can be a locally
  // declared variable or function
  const result = findNodeAround(ast, astPosition, {
    pre (node) {
      const { type } = node;
      // Only scopes that may contain variables and local functions are interesting
      if (type === 'FunctionDeclaration' || type === 'ScriptDeclaration') scopes.unshift(node);
    },
    post (node, state, parent) {
      const { type } = node;
      if (type === 'Identifier' && parent) {
        return parent.type === 'FunctionDeclaration'
          // Only functions in scripts (and not object methods) can be local
          ? script || scopes.length === 2
          // First-level identifiers may come from a variable or local function declaration
          : mayComeFromVariable(node, parent)
      }
      if (type === 'FunctionDeclaration' || type === 'ScriptDeclaration') scopes.shift();
    }
  });
  if (!result) {
    logDebug('no local identifier');
    return null
  }
  const { node, parent } = result;
  let [scope] = scopes;
  // If an identifier in a local function declaration was selected, set
  // the scope to its parent script
  if (scope === parent) scope = scopes[1];
  if (!scope) {
    logDebug('no surrounding scope or no local for "%1"', node.raw);
    return null
  }
  // Secondly, check if the identifier belongs to a variable or a local function
  const { value } = node;
  // Look for the declaration of the identifier. Either among the formal
  // parameters, if the scope is a function declaration, ...
  let variable = scope.params && scope.params.some(({ id }) => id.value === value);
  if (!variable) {
    try {
      // ... or inside the scope among its variables and local functions
      simple(scope, {
        VariableDeclarator: {
          pre (node) {
            if (node.id.value === value) throw new DeclarationFound
          }
        },
        FunctionDeclaration: {
          pre (node) {
            if (node.id.value === value) throw new DeclarationFound
            // Do not skip the scope of the variable itself, but otherwise
            // do not look for the variable declaration in nested functions.
            // If the variable occurred outside of them, it could not be
            // declared inside of them.
            return node !== scope
          }
        }
      });
    } catch (error) {
      if (error instanceof DeclarationFound) variable = true;
      else throw error
    }
  }
  if (!variable) {
    logDebug('not declared in scope of identifier "%1"', node.raw);
    return null
  }
  logDebug('found scope %1 "%2" for "%3"', scope.type, scope.id.raw, node.raw);
  return { node: node, parent, scope }
}

class DeclarationFound {}

function mayComeFromVariable (node, parent) {
  const { type: parentType } = parent;
  return !((parentType === 'MemberExpression' && parent.property === node) ||
    (parentType === 'Property' && parent.key === node) ||
    parentType === 'XlateExpression')
}

function declaresLocal (parent) {
  const { type: parentType } = parent;
  return parentType === 'VariableDeclarator' || parentType === 'Parameter' ||
    parentType === 'FunctionDeclaration'
}

function doDefinition(textDocument, position, extras) {
  const { ast } = ensureParsedDocument(textDocument, extras);
  if (!ast) { // skip invalid documents
    logDebug('invalid document');
    return
  }
  const result = findScopeOfLocal(ast, position); // if no preparation was made
  if (!result) return // abort if no variable identifier
  const { node, scope } = result;
  const { uri } = textDocument;
  const results = findLocalsInScope(scope, node);
  const declaration = results.find(({ parent }) => declaresLocal(parent));
  if (!declaration) {
    logDebug('declaration not found');
    return
  }
  return node$2.Location.create(uri, getNodeRange(declaration.node))
}

function doReferences(textDocument, position, context, extras) {
  const { ast } = ensureParsedDocument(textDocument, extras);
  if (!ast) { // skip invalid documents
    logDebug('invalid document');
    return
  }
  const result = findScopeOfLocal(ast, position); // if no preparation was made
  if (!result) return // abort if no identifier to rename was found
  const { node, scope } = result;
  const { uri } = textDocument;
  let results = findLocalsInScope(scope, node);
  if (!context.includeDeclaration) {
    results = results.filter(({ parent }) => !declaresLocal(parent));
  }
  return results.map(({ node }) => node$2.Location.create(uri, getNodeRange(node)))
}

var quickFixes = new Map([
  ['W001', [{
    title: 'Replace string delimiters with backticks',
    action (document, ast, range) {
      const { start } = range;
      const { node } = findNodeAround(ast, { line: start.line + 1, column: start.character + 1 }, 'Literal');
      const { start: stringStart, end: stringEnd } = getNodeRange(node);
      return [node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(document.uri, null), [
          node$2.TextEdit.replace(node$2.Range.create(
            stringStart, node$2.Position.create(stringStart.line, stringStart.character + 1)), '`'),
          node$2.TextEdit.replace(node$2.Range.create(
            node$2.Position.create(stringEnd.line, stringEnd.character - 1), stringEnd), '`')
        ])]
    }
  }, {
    title: 'Replace line breaks with spaces',
    action (document, ast, range) {
      const { start } = range;
      const { node } = findNodeAround(ast, { line: start.line + 1, column: start.character + 1 }, 'Literal');
      const string = replaceLineBreaks(node.value);
      const { start: stringStart, end: stringEnd } = getNodeRange(node);
      return [node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(document.uri, null), [
          node$2.TextEdit.replace(node$2.Range.create(
            node$2.Position.create(stringStart.line, stringStart.character + 1),
            node$2.Position.create(stringEnd.line, stringEnd.character - 1)), string)
        ])]
    }
  }, {
    title: 'Delete line breaks',
    action (document, ast, range) {
      const { start } = range;
      const { node } = findNodeAround(ast, { line: start.line + 1, column: start.character + 1 }, 'Literal');
      const string = deleteLineBreaks(node.value);
      const { start: stringStart, end: stringEnd } = getNodeRange(node);
      return [node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(document.uri, null), [
          node$2.TextEdit.replace(node$2.Range.create(
            node$2.Position.create(stringStart.line, stringStart.character + 1),
            node$2.Position.create(stringEnd.line, stringEnd.character - 1)), string)
        ])]
    }
  }]],
  ['W002', [{
    title: 'Delete the backslash',
    action (document, ast, range) {
      const { start } = range;
      return [node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(document.uri, null), [
          node$2.TextEdit.del(node$2.Range.create(start, node$2.Position.create(start.line, start.character + 1)))
        ])]
    }
  }, {
    title: 'Insert a space after the backslash',
    action (document, ast, range) {
      const { start } = range;
      return [node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(document.uri, null), [
          node$2.TextEdit.insert(node$2.Position.create(start.line, start.character + 1), ' ')
        ])]
    }
  }]],
  ['W003', [{
    title: 'Insert a dummy variable name after the directive',
    action (document, ast, range) {
      const { start } = range;
      const text = document.getText(range);
      const match = /^(#\w+)(\s*)/.exec(text);
      const lead = match[1].length;
      const spaces = match[2];
      return [node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(document.uri, null), [
          spaces
            ? node$2.TextEdit.replace(node$2.Range.create(
              node$2.Position.create(start.line, start.character + lead),
              node$2.Position.create(start.line, start.character + lead + spaces.length)), ' DUMMY')
            : node$2.TextEdit.insert(node$2.Position.create(start.line, start.character + lead), ' DUMMY')
        ])]
    }
  }]],
  ['W004', [{
    title: 'Replace the current modifier with "public"',
    action (document, ast, range) {
      return [node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(document.uri, null), [
          node$2.TextEdit.replace(range, 'public')
        ])]
    }
  }]],
  ['W005', [{
    title: 'Remove the characters after the directive',
    action (document, ast, range) {
      const { end } = range;
      const text = document.getText(range);
      const match = /^(#\w+)/.exec(text);
      const tail = text.length - match[1].length;
      return [node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(document.uri, null), [
          node$2.TextEdit.del(node$2.Range.create(node$2.Position.create(end.line, end.character - tail), end))
        ])]
    }
  }, {
    title: 'Make a single-line comment from the characters after the directive',
    action (document, ast, range) {
      const { start } = range;
      const text = document.getText(range);
      const match = /^(#\w+)/.exec(text);
      const head = match[1].length;
      return [node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(document.uri, null), [
          node$2.TextEdit.insert(node$2.Position.create(start.line, start.character + head), ' //')
        ])]
    }
  }, {
    title: 'Put the characters after the directive to a multi-line comment',
    action (document, ast, range) {
      const { start } = range;
      const text = document.getText(range);
      const match = /^(#\w+)/.exec(text);
      const head = match[1].length;
      return [node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(document.uri, null), [
          node$2.TextEdit.insert(node$2.Position.create(start.line, start.character + head), ' /*'),
          node$2.TextEdit.insert(node$2.Position.create(start.line, start.character + text.length), ' */')
        ])]
    }
  }]],
  ['W006', [{
    title: 'Delete the semicolon',
    action (document, ast, range) {
      return [node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(document.uri, null), [
          node$2.TextEdit.del(range)
        ])]
    }
  }]],
  ['W007', [{
    title: 'Insert a semicolon before the keyword "end"',
    action (document, ast, range) {
      return [node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(document.uri, null), [
          node$2.TextEdit.insert(range.start, '; ')
        ])]
    }
  }, {
    title: 'Insert a line break before the keyword "end"',
    action (document, ast, range) {
      const { start } = range;
      const text = document.getText(node$2.Range.create(node$2.Position.create(start.line, 0), start));
      const match = /^(\s*)(.*\S)(\s*)$/.exec(text);
      const indent = match[1] || '';
      const actions = [node$2.TextEdit.insert(start, `\n${indent}`)];
      const tail = match[3];
      if (tail) {
        actions.unshift(node$2.TextEdit.del(node$2.Range.create(
          node$2.Position.create(start.line, start.character - tail.length), start)));
      }
      return [node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(document.uri, null), actions)]
    }
  }]]
]);

function replaceLineBreaks (text) {
  return text.replace(/\r?\n\s*/g, ' ').replace(/\r\s*([^\n])/g, ' $1')
}

function deleteLineBreaks (text) {
  return text.replace(/\r?\n\s*/g, '').replace(/\r\s*([^\n])/g, '$1')
}

function doCodeAction(textDocument, range, context, extras) {
  const { ast } = ensureParsedDocument(textDocument, extras);
  if (!ast) { // skip invalid documents
    logDebug('invalid document');
    return
  }
  const { diagnostics, only } = context;
  if (only && !only.includes(node$2.CodeActionKind.QuickFix)) {
    logDebug('quick fixes not requested');
    return
  }
  const fixables = diagnostics.filter(({ code }) => code && quickFixes.has(String(code)));
  if (!fixables.length) {
    if (wantDebug()) {
      logDebug('quick fixes not found for problems %1', formatCodes(diagnostics));
    }
    return
  }
  if (wantDebug()) {
    logDebug('quick fixes found for problems %1', formatCodes(fixables));
  }
  return fixables
    .map(problem => {
      const { code, range } = problem;
      return quickFixes
        .get(String(code))
        .map(({ title, action }) => node$2.CodeAction.create(
          title, { documentChanges: action(textDocument, ast, range) },
          node$2.CodeActionKind.QuickFix))
    })
    .flat()
}

function formatCodes (problems) {
  return problems
    .filter(({ code }, index) => problems.indexOf(code) === index)
    .map(({ code }) => code)
    .join(', ')
}

function doRenameRequest(textDocument, position, newName, extras) {
  const result = ensureParsedDocument(textDocument, extras);
  const { ast } = result;
  if (!ast) { // skip invalid documents
    logDebug('invalid document');
    return
  }
  let { rename } = result;
  if (rename) extras.rename = undefined; // will not be used any more
  else rename = findScopeOfLocal(ast, position); // if no preparation was made
  if (!rename) return // abort if no identifier to rename was found
  const { node, scope } = rename;
  const results = findLocalsInScope(scope, node);
  return {
    documentChanges: [
      node$2.TextDocumentEdit.create(
        node$2.OptionalVersionedTextDocumentIdentifier.create(textDocument.uri, null),
        results.map(({ node }) => node$2.TextEdit.replace(getNodeRange(node), newName)))
    ]
  }
}

function doPrepareRename(textDocument, position, extras) {
  const { ast } = ensureParsedDocument(textDocument, extras);
  if (!ast) { // skip invalid documents
    logDebug('invalid document');
    return
  }
  const rename = findScopeOfLocal(ast, position);
  if (!rename) return    // abort if no identifier to rename was found
  extras.rename = rename; // remember the data for the following rename request
  return getNodeRange(rename.node)
}

function uriToProjectPath (workspaceFolders, workspaceRoot, uri) {
  for (const folder of workspaceFolders) {
    const path$1 = tryMatchPath(folder.name, uri);
    if (path$1) return `${folder.name}${path.sep}${path$1}`
  }
  if (workspaceRoot) {
    const path = tryMatchPath(workspaceRoot, uri);
    if (path) return path
  }
  return uri
}

function tryMatchPath (folderUri, fileUri) {
  if (fileUri.startsWith(folderUri)) {
    const path = fileUri.substr(folderUri.length);
    const start = path.charCodeAt(0);
    return start === 47 || start === 92 ? path.substr(1) : path // /\
  }
}

const defaultSettings = {
  languageServer: { enabled: true },
  validation: { enabled: true },
  completion: { enabled: true },
  hover: { enabled: true },
  symbols: { enabled: true },
  definition: { enabled: true },
  references: { enabled: true },
  rename: { enabled: true },
  quickFixes: { enabled: true },
  logging: { level: 'error' }
};
let globalSettings = defaultSettings;









const documentExtras = new Map;

let workspaceRoot;
let workspaceFolders$1 = [];
let hasConfigurationCapability = false;
let hasWorkspaceFolderCapability = false;
let hasDiagnosticRelatedInformationCapability = false;
let hasHierarchicalDocumentSymbolSupport = false;
let hasRenamePreparationSupport = false;
let hasCodeActionLiteralSupport = false;

const connection$2 = node$2.createConnection(node$2.ProposedFeatures.all);

const documents = new node$2.TextDocuments(TextDocument$1);
const pendingValidationRequests = new Map;
const validationDelay = 200;

connection$2.onInitialize((params) => {
  workspaceRoot = params.rootUri;
  workspaceFolders$1 = params.workspaceFolders || [];

  const capabilities = params.capabilities;
  hasConfigurationCapability = !!(
    capabilities.workspace && capabilities.workspace.configuration);
  hasWorkspaceFolderCapability = !!(
    capabilities.workspace && capabilities.workspace.workspaceFolders);
  hasDiagnosticRelatedInformationCapability = !!(
    capabilities.textDocument &&
    capabilities.textDocument.publishDiagnostics &&
    capabilities.textDocument.publishDiagnostics.relatedInformation);
  hasHierarchicalDocumentSymbolSupport = !!(
    capabilities.textDocument &&
    capabilities.textDocument.documentSymbol &&
    capabilities.textDocument.documentSymbol.hierarchicalDocumentSymbolSupport);
  hasRenamePreparationSupport = !!(
    capabilities.textDocument &&
    capabilities.textDocument.rename &&
    capabilities.textDocument.rename.prepareSupport);
  hasCodeActionLiteralSupport = !!(
    capabilities.textDocument &&
    capabilities.textDocument.codeAction &&
    capabilities.textDocument.codeAction.codeActionLiteralSupport
  );

  const result = {
    capabilities: {
      textDocumentSync: node$2.TextDocumentSyncKind.Incremental,
      completionProvider: {
        resolveProvider: true,
        triggerCharacters: ['.', '#', '(', '[']
      },
      hoverProvider: true,
      documentSymbolProvider: true,
      definitionProvider: true,
      referencesProvider: true,
      codeActionProvider: hasCodeActionLiteralSupport ? { codeActionKinds: [node$2.CodeActionKind.QuickFix] } : true,
      renameProvider: hasRenamePreparationSupport ? { prepareProvider: true } : true
    }
  };
  if (hasWorkspaceFolderCapability) {
    result.capabilities.workspace = {
      workspaceFolders: { changeNotifications: true, supported: true }
    };
  }
  return result
});

connection$2.onInitialized(() => {
  if (hasConfigurationCapability) {
    connection$2.client.register(node$2.DidChangeConfigurationNotification.type, undefined);
  }
  if (hasWorkspaceFolderCapability) {
    connection$2.workspace.onDidChangeWorkspaceFolders(updateWorkspaceFolders);
  }
  updateLogLevel()
    .then(() => {
      if (wantDebug()) {
        logDebug('initialized with workspace root "%1" and workspace folders %2, supporting configuration - %3, workspace folders - %4, related information - %5, hierarchical symbols - %6, rename preparation - %7 and code actions - %8',
          workspaceRoot, JSON.stringify(workspaceFolders$1.map(({ name, uri }) => ([name, uri]))),
          hasConfigurationCapability, hasWorkspaceFolderCapability,
          hasDiagnosticRelatedInformationCapability,
          hasHierarchicalDocumentSymbolSupport, hasRenamePreparationSupport,
          hasCodeActionLiteralSupport);
      }
    })
    .then(doInitialize)
    .catch(error => {
      logError(error, 'initialization failed');
      connection$2.sendNotification(node$2.ShowMessageNotification.type.method,
        { message: error.message, type: node$2.MessageType.Error });
    });
});

function updateWorkspaceFolders(event) {
  if (wantDebug()) {
    logDebug('workspace folders removed - %1, added - %2',
      JSON.stringify(event.removed.map(({ name }) => name)),
      JSON.stringify(event.added.map(({ name, uri }) => ([name, uri]))));
  }
  workspaceFolders$1 = workspaceFolders$1
    .filter(current => !event.removed.some(removed => removed.uri === current.uri))
    .filter(current => !event.added.some(added => added.uri === current.uri))
    .concat(event.added);
}

function updateLogLevel () {
  return connection$2.workspace
    .getConfiguration('oscript')
    .then(settings => setLevel(settings.logging.level))
}

connection$2.onDidChangeConfiguration(event => {
  logDebug('configuration changed');
  documentExtras.clear();
  if (!hasConfigurationCapability) {
    globalSettings = event.settings.oscript || defaultSettings;
  }
  updateLogLevel()
    .then(() => documents.all().forEach(triggerValidation))
    .catch(error => {
      logError(error, 'initialization failed');
      connection$2.sendNotification(node$2.ShowMessageNotification.type.method,
        { message: error.message, type: node$2.MessageType.Error });
    });
});

async function getDocumentSettings(uri) {
  if (!hasConfigurationCapability) return globalSettings
  const settings = await connection$2.workspace.getConfiguration({
    scopeUri: uri, section: 'oscript'
  });
  if (wantDebug()) {
    logDebug('new document settings: %2', uri, JSON.stringify({
      languageServer: settings.languageServer.enabled,
      validation: settings.validation.enabled,
      completion: settings.completion.enabled,
      hover: settings.hover.enabled,
      symbols: settings.symbols.enabled,
      rename: settings.rename.enabled
    }));
  }
  return settings
}

async function ensureDocumentExtras(document) {
  const { uri } = document;
  let extras = documentExtras.get(uri);
  if (!extras) {
    logDebug('new document extras');
    extras = {
      path: uriToProjectPath(workspaceFolders$1, workspaceRoot, uri),
      settings: await getDocumentSettings(uri)
    };
    documentExtras.set(uri, extras);
  }
  return extras
}

documents.onDidChangeContent(event => {
  const { document } = event;
  const { uri } = document;
  logDebug('document changed - %1', uri);
  const extras = documentExtras.get(uri);
  if (extras) invalidateExtras(extras);
  triggerValidation(document);
});

function invalidateExtras(extras) {
  extras.error = extras.ast = extras.tokens = extras.warnings = undefined;
}

documents.onDidClose(event => {
  const { document } = event;
  const { uri } = document;
  logDebug('document closed - %1', uri);
  documentExtras.delete(uri);
  cancelValidation(document);
});

connection$2.onDidChangeWatchedFiles(event => {
  if (wantDebug()) {
    logDebug('watched files changed - %1',
      JSON.stringify(event.changes.map(({ uri }) => uri)));
  }
  event.changes.forEach(change => {
    const { uri } = change;
    const document = documents.get(uri);
    if (document) triggerValidation(document);
  });
});

function cleanPendingValidation(uri) {
  const request = pendingValidationRequests.get(uri);
  if (request) {
    clearTimeout(request);
    pendingValidationRequests.delete(uri);
  }
}

function triggerValidation(document) {
  const { uri } = document;
  cleanPendingValidation(uri);
  pendingValidationRequests.set(uri, setTimeout(() => {
    pendingValidationRequests.delete(uri);
    validateTextDocument(document);
  }, validationDelay));
}

function cancelValidation(document) {
  const { uri } = document;
  cleanPendingValidation(uri);
  connection$2.sendDiagnostics({ uri, diagnostics: [] });
}

async function validateTextDocument(document) {
  const extras = await prepareDocument(document, 'validating document', 'validation');
  if (!extras) return
  const diagnostics = doValidation(document, extras,
    { relatedInformation: hasDiagnosticRelatedInformationCapability });
  connection$2.sendDiagnostics({ uri: document.uri, diagnostics });
}

connection$2.onCompletion(async (documentPositionParams) => {
  const { textDocument, position } = documentPositionParams;
  const [document, extras] = await prepareDocumentHandler (textDocument, 'completion', 'completion');
  if (!document) return
  return doCompletion(document, position, extras)
});

connection$2.onCompletionResolve((item) => {
  logDebug('completion resolution requested for %1', item.label);
  return doCompletionResolve(item)
});

connection$2.onHover(async (documentPositionParams) => {
  const { textDocument, position } = documentPositionParams;
  const [document, extras] = await prepareDocumentHandler (textDocument, 'hover', 'hover');
  if (!document) return
  return doHover(document, position, extras)
});

connection$2.onDocumentSymbol(async (documentSymbolParams) => {
  const { textDocument } = documentSymbolParams;
  const [document, extras] = await prepareDocumentHandler (textDocument, 'symbols', 'symbols');
  if (!document) return
  return hasHierarchicalDocumentSymbolSupport
    ? doHierarchicalSymbols(document, extras)
    : doFlatSymbols(document, extras)
});

connection$2.onDefinition(async (documentPositionParams) => {
  const { textDocument, position } = documentPositionParams;
  const [document, extras] = await prepareDocumentHandler (textDocument, 'definition', 'definition');
  if (!document) return
  return doDefinition(document, position, extras)
});

connection$2.onReferences(async (referenceParams) => {
  const { textDocument, position, context } = referenceParams;
  const [document, extras] = await prepareDocumentHandler (textDocument, 'references', 'references');
  if (!document) return
  return doReferences(document, position, context, extras)
});

connection$2.onCodeAction(async (codeActionParams) => {
  const { textDocument, range, context } = codeActionParams;
  const [document, extras] = await prepareDocumentHandler (textDocument, 'code action', 'quickFixes');
  if (!document) return
  return doCodeAction(document, range, context, extras)
});

connection$2.onRenameRequest(async (renameParams) => {
  const { textDocument, position, newName } = renameParams;
  const [document, extras] = await prepareDocumentHandler (textDocument, 'rename', 'rename');
  if (!document) return
  return doRenameRequest(document, position, newName, extras)
});

connection$2.onPrepareRename(async (documentPositionParams) => {
  const { textDocument, position } = documentPositionParams;
  const [document, extras] = await prepareDocumentHandler (textDocument, 'rename preparation', 'rename');
  if (!document) return
  return doPrepareRename(document, position, extras)
});

async function prepareDocumentHandler (documentId, eventName, enablingFlag) {
  const document = documents.get(documentId.uri);
  if (!document) {
    logDebug('%1 rejected for unknown document', eventName);
    return []
  }
  const extras = await prepareDocument(document, eventName, enablingFlag);
  return extras ? [document, extras] : []
}

async function prepareDocument(document, eventName, enablingFlag) {
  logDebug('%1 requested for %2', eventName, document.uri);
  const extras = await ensureDocumentExtras(document);
  const { settings } = extras;
  if (!(settings.languageServer.enabled && settings[enablingFlag].enabled)) return
  return extras
}

documents.listen(connection$2);

connection$2.listen();
//# sourceMappingURL=server.js.map
